package br.usp.talkagent.ide;

import javax.swing.*;
import java.awt.event.*;
import javax.swing.tree.*;
import java.io.*;
import java.util.*;
import java.net.*;
import java.awt.*;
import javax.swing.*;
import javax.swing.table.*;
import javax.swing.tree.*;
import br.usp.talkagent.kb.*;
import br.usp.talkagent.basicagent.*;
import br.usp.talkagent.kb.objects.*;
import br.usp.talkagent.component.*;
import br.usp.talkagent.component.*;

/**  XKT-KB  IDE  **/

public class IDEform extends SharpServerAgent
{
	/** IDE's Main Window*/
	protected JFrame frame;

	/** Tree Stuff */
	protected OntologyTree tree;
	protected ComponentTree ctree; // component tree
	protected DefaultMutableTreeNode lastItem;
	protected int newIndex;	    
	protected int insertCount;	
	
	/** GUI Elements are Form global variables, so
	 * its easier to get their values and move them
	 * dinamically 
	 */
	protected JScrollPane MLeftBar;
	protected JScrollPane sp;
	protected JPanel panel;
	protected JPanel retPanel; 
   	protected JPanel borderPane;
   	protected JScrollPane Footer;
	protected JPanel Sidebar;	
   	protected JLabel labelp;
	protected JScrollPane sb;
	protected JScrollPane sb2;
	protected JScrollPane sb3;
	protected JPanel LeftPanel;
   	protected JPanel pn;
   	protected JPanel pn2;
   	protected JPanel pn3;
	protected JButton connectButton;
	protected JButton disconnectButton;
	protected JList astBox;
	protected JTextField host;
	protected JTextArea debug;
	protected JMenuBar menuBar;
	protected JTable jTable1;
			
	/** Concepts**/
   	protected JTextField conceptName;
   	protected String Parent;
   	protected String Concept;
   	     
	/** Agent Stuff */ 
	public  static XktClient xktc; // connector to KB	
	public  AmsClient ams;  // used to get other agent addresses (KB)
	public  CRclient crmc; //


/**-----------------------------------------------------------------------------------
*** ONTOLOGY TREE EVENT LISTENERS
/**-----------------------------------------------------------------------------------

    * AddAction is used to add a new item after the selected item. */		
	class EditAction extends Object implements ActionListener
	{
	/** Number of nodes that have been added. */
	public int      addCount;
	/**
	  * Messaged when the user clicks on the Add menu item.
	  * Determines the selection from the Tree and adds an item
	  * after that.  If nothing is selected, an item is added to
	  * the root.
	  */	
	public void actionPerformed(ActionEvent e) 
	{
	    int               		newIndex;
	    DefaultMutableTreeNode  lastItem = tree.getSelectedNode();
	    DefaultMutableTreeNode  parent;

	    /* Determine where to create the new node. */
	    if(lastItem != null)
		parent = (DefaultMutableTreeNode)lastItem.getParent();
	    else
		parent = (DefaultMutableTreeNode)tree.treeModel.getRoot();

	    if(lastItem == null)
			newIndex = lastItem.getChildCount();			
	    else
			//newIndex = parent.getIndex(lastItem) + 1;
			newIndex = lastItem.getChildCount() +1;		
			Concept = ((NodeData) lastItem.getUserObject()).getValue();
			MLeftBar.getViewport().removeAll();
			MLeftBar.getViewport().add(LeftPanel);		
			SideBar("Edit Concept", "Rename Concept: ", "",Concept);	
			SideBar2(Concept);		
	    	/* Let the treemodel know. */
	    	//treeModel.insertNodeInto(createNewNode("Added " +
	    	//Integer.toString(addCount++)), lastItem, newIndex);
		}
	} // End of SampleTree.AddAction


	/***
	* InsertAction is used to insert a new item before the selected item.
	*/
	class InsertAction extends Object implements ActionListener
	{
	/** Number of nodes that have been added. */
	/**
	  * Messaged when the user clicks on the Insert menu item.
	  * Determines the selection from the Tree and inserts an item
	  * after that.  If nothing is selected, an item is added to
	  * the root.
	  */
	public void actionPerformed(ActionEvent e) 
	{	    
	    DefaultMutableTreeNode          parent;
	    lastItem = tree.getSelectedNode();

	    /* Determine where to create the new node. */
	    if(lastItem != null)
		parent = (DefaultMutableTreeNode)lastItem.getParent();
	    else
		parent = (DefaultMutableTreeNode)tree.treeModel.getRoot();
		
	    if(lastItem == null)
		newIndex = tree.treeModel.getChildCount(lastItem);
		//treeModel.getChildCount(lastItem);
	    else
		//newIndex = parent.getIndex(lastItem) + 1;
		newIndex = lastItem.getChildCount();

		Parent = ((NodeData) lastItem.getUserObject()).getValue();
		
        // shows sideBar for insertion
        SideBar("Insert New Concept","New Concept: ","Parent: " + Parent, "");
        MLeftBar.getViewport().removeAll();
		MLeftBar.getViewport().add(LeftPanel);           
		sb2.getViewport().removeAll();	
		sb2.getViewport().repaint();			    	

	    /* Let the treemodel know. */    
	}
	} // End of SampleTree.InsertAction


	/** SubItems */
	class SubItems extends Object implements ActionListener
	{		
	/**
	  * Messaged when the user clicks on the Reload menu item.
	  * Determines the selection from the Tree and asks the treemodel
	  * to reload from that node.
	  */
	public void actionPerformed(ActionEvent e) 
	{
	    DefaultMutableTreeNode  lastItem = tree.getSelectedNode();
	    NodeData item = (NodeData) lastItem.getUserObject();
	    String str = "SubItems #: " + item.getToolTipText();
	    JOptionPane.showMessageDialog(null, str);
	}
	} 

	// Find Component	
	class FindAction extends Object implements ActionListener
	{		
	
	public void actionPerformed(ActionEvent e) 
	{
		SideBar("Find Concept","Find Concept: ","" + "", "");
        MLeftBar.getViewport().removeAll();
		MLeftBar.getViewport().add(LeftPanel);		           
		sb2.getViewport().removeAll();	
		sb2.getViewport().repaint();						
	}	
	}


	class FindConceptAction extends Object implements ActionListener
	{	
	public void actionPerformed(ActionEvent e) 
	{
	Vector response;
	int i;
	
		if(conceptName.getText().length()>0)
		{
			sb2.getViewport().removeAll();	
			sb2.getViewport().repaint();
			response = xktc.getPath(conceptName.getText());
			String sresponse="\n";
			if(response.size()>1)
			{
				for(i=0;i<response.size();i++)
					sresponse+=" * " + response.elementAt(i)+"\n";
			}
			else
				sresponse+="Couldn't find concept " + conceptName.getText();
			if(response!=null)
			{
				JPanel pn  = new JPanel(false);
				pn.setLayout(new BorderLayout());
				JLabel action  = new JLabel("Search Results");    	
	    		action.setOpaque(true);
	    		action.setBackground(Color.yellow);	
	    		pn.add(action, "North");
				debug = new JTextArea(15,25);
				debug.setOpaque(true);
				debug.setFont(new Font( null, Font.BOLD, 12));
				debug.setBackground(new Color(200,200,200));
				debug.setText(sresponse);
				debug.setLineWrap(true);	
				debug.setEditable(false);	
				JScrollPane sc = new JScrollPane(debug);
				pn.add(sc, "Center");
				sb2.getViewport().add(pn);			
			}
			else
			JOptionPane.showMessageDialog(null, "Concept not found " + conceptName.getText());
		}
	}
	}	
		

	/** Delete Component */
	class DeleteComponent extends Object implements ActionListener
	{		
	
	public void actionPerformed(ActionEvent e) 
	{
		DefaultMutableTreeNode comp = ctree.lastItem();
		NodeData nd = null;
		String str;
		if(comp!=null)
		{
			nd= (NodeData) comp.getUserObject();				
			if( (nd!=null)&& ((nd.getType().equalsIgnoreCase("component"))))
			{
				String question = "Do you really want to remove component " + nd.getValue() + " ?";
	 			int n = JOptionPane.showConfirmDialog(null, question, "Confirm Action",JOptionPane.YES_NO_OPTION);
				if (n == JOptionPane.YES_OPTION)
				{
					crmc.DeleteComponent(nd.getValue());
					ComponentsBar();
					sb.getViewport().removeAll();
					sb2.getViewport().add(pn3);
					renderOntologyTree();
					str = "Component " + nd.getValue() + " deleted";
					JOptionPane.showMessageDialog(null, str);					
				}
			}
			else
			{
				str = nd.getValue() + "is not a valid component";
				JOptionPane.showMessageDialog(null, str);
			}
		}
		else
		{			
			if(nd==null)
			{
				 str = "Please select a component to delete";
				 JOptionPane.showMessageDialog(null, str);
			}				
		}			
	  }	
	} 


	
	class RunComponent extends Object implements ActionListener
	{		
	/**
	  * Messaged when the user clicks on the Reload menu item.
	  * Determines the selection from the Tree and asks the treemodel
	  * to reload from that node.
	  */
	public void actionPerformed(ActionEvent e) 
	{
		DefaultMutableTreeNode  lastItem = ctree.lastItem();
		if(lastItem!=null)
		{
			NodeData item = (NodeData) lastItem.getUserObject();
			if(item.getType().equalsIgnoreCase("method"))
			{
				String method=item.getValue();
				DefaultMutableTreeNode ncomp0 = (DefaultMutableTreeNode) lastItem.getParent();
				DefaultMutableTreeNode ncomp = (DefaultMutableTreeNode) ncomp0.getParent();								
				String component =  ((NodeData)ncomp.getUserObject()).getValue();				
				int nparams = lastItem.getChildCount()-1;
				System.err.println("nparams " + nparams);
				//jTable1.getRowCount();				
				Vector params = new Vector(1);
				for(int i=0; i<nparams; i++)
				{
					params.add((jTable1.getModel()).getValueAt(i,1));					
				}	
				String response = crmc.runMethod(component,method,params);
				debug.setText(response);								
			}
			else 
	    		JOptionPane.showMessageDialog(null,"Please choose a valid method to run");
		}
		else 
	    	JOptionPane.showMessageDialog(null,"Please choose a valid method to run");
	}
	} 


/**-----------------------------------------------------------------------------------
*** MENU EVENT LISTENERS
/**-----------------------------------------------------------------------------------

	/** SubItems */
	class ImportComp extends Object implements ActionListener
	{		
	/**
	  * Messaged when the user clicks on the Reload menu item.
	  * Determines the selection from the Tree and asks the treemodel
	  * to reload from that node.
	  */
	public void actionPerformed(ActionEvent e) 
	{
		ComponentsBar();
		MLeftBar.getViewport().remove(LeftPanel);
		MLeftBar.getViewport().add(pn3);		
	
		//File file;
		//String filename = File.separator+"tmp";
		String filename = "/";	
    	JFileChooser fc = new JFileChooser(new File(filename));
    	CustomFileFilter ff = new CustomFileFilter("jar", "JavaBeans Jars");    
    	fc.setFileFilter(ff); 
    	// Show open dialog; this method does not return until the dialog is closed
    	fc.setDialogTitle("Import Component");
    	fc.showOpenDialog(frame);    
    	File selFile = fc.getSelectedFile();
    	String aux = selFile.getAbsolutePath();
    	crmc.upload(aux);
		ComponentsBar();						
		clearSideBars();
		sb2.getViewport().add(pn3);	
	    //String str = "File " + aux + " uploaded";
    	//JOptionPane.showMessageDialog(null, str); 
	}	
	}


	/**
	* RemoveAction removes the selected node from the tree.  If
    * The root or nothing is selected nothing is removed.
	*/
	class RemoveAction extends Object implements ActionListener
	{
	/**
	* Removes the selected item as long as it isn't root.
	*/
	 public void actionPerformed(ActionEvent e)
	 {
	 	lastItem = tree.getSelectedNode();
	 	String value = ((NodeData) lastItem.getUserObject()).getValue();
	 	String question = "Do you really want to remove " + value + " ?";
	 	int n = JOptionPane.showConfirmDialog(null, question, "Confirm Action",JOptionPane.YES_NO_OPTION);
		if (n == JOptionPane.YES_OPTION)
		{
	   	 	DefaultMutableTreeNode lastItem = tree.getSelectedNode();
   			xktc.deleteConcept(value);
	    	String msg =  lastItem + " removed !";
			JOptionPane.showMessageDialog(null, msg);		
	    	if(lastItem != null && lastItem != (DefaultMutableTreeNode)tree.treeModel.getRoot()) {
			tree.treeModel.removeNodeFromParent(lastItem);
	    }    
	   }	    
	}
	} // End of SampleTree.RemoveAction
	

	/** Connection Button */
	class ConnectAction extends Object implements ActionListener
	{
		public void actionPerformed(ActionEvent e) 
		{			
			try
			{			
			LinkedList l1;
			fipaos.ont.fipa.fipaman.AgentID agentid	 = new fipaos.ont.fipa.fipaman.AgentID();
			agentid.setName("ide");
			l1 = new LinkedList();
			l1.add(InetAddress.getLocalHost().getHostAddress());
			l1.add("5030");
	    	agentid.setAddresses(l1);	
	    	String hostname = host.getText();
	  		ams = new AmsClient(hostname, 5040);
	  		if(ams.isConnected())
	  		{
		    	ams.register(agentid);		    
				xktc = new XktClient(ams, agentid);				
				crmc = new CRclient(ams, agentid);
				renderOntologyTree();
				connectButton.setEnabled(false);
				menuBar.setEnabled(true);
				menuBar.setVisible(true);						
				disconnectButton.setEnabled(true);
				frame.repaint();
	  		}
	  		else
	  			JOptionPane.showMessageDialog(null,"Invalid Talk Agent Server: " + hostname);			
			}
			catch(Exception e1)
			{e1.printStackTrace();}
		}
    }
	

	/**	Insert Concept*/
	class InsertConceptAction extends Object implements ActionListener
	{	
		public void actionPerformed(ActionEvent e) 
		{		
			if(conceptName!=null)
			{
				if(conceptName.getText().length()>0)
				{
					xktc.insertconcept(conceptName.getText(), Parent);	
					tree.treeModel.insertNodeInto(tree.createConceptNode(conceptName.getText()),lastItem, newIndex);
					clearSideBars();				        
    				JOptionPane.showMessageDialog(null,"Concept Inserted");
				}
				else
				{
					JOptionPane.showMessageDialog(null,"Please fill in concept name field");
				}
			}
			else
			{
				JOptionPane.showMessageDialog(null,"Please fill in concept name field");
			}			
		}			
	}
 
 
 	/**	Concept Info */
	class ListCompAction extends Object implements ActionListener
	{
		public void actionPerformed(ActionEvent e) 
		{			
			ComponentsBar();
			MLeftBar.getViewport().remove(LeftPanel);
			MLeftBar.getViewport().add(pn3);			
			
			/*
			LeftBar.remove(sb);
			LeftBar.remove(sb2);			
			LeftBar.add(sb3);	
			sb3.getViewport().add(pn3);*/								
		}
	}
 
 
	/**	Edit Concept Action */
	class EditConceptAction extends Object implements ActionListener
	{
	
		public void actionPerformed(ActionEvent e) 
		{		
			if(conceptName.getText().length()>0)
			{
				xktc.updateConcept(Concept,conceptName.getText());
				lastItem = tree.getSelectedNode();
				NodeData nd = new NodeData(Color.black, conceptName.getText(), conceptName.getText());			
				nd.ConceptNodeLookAndFeel(true);
				lastItem.setUserObject(nd);				
				tree.treeModel.nodeChanged(lastItem);
				//tree.treeModel.insertNodeInto(tree.createConceptNode(conceptName.getText()),lastItem, lastItem);			
				//treeModel.insertNodeInto(createNewNode(conceptName.getText()),lastItem, );
				clearSideBars();										        
    			JOptionPane.showMessageDialog(null,"Concept Renamed"); 		   	    		
			}
			else
			{
				JOptionPane.showMessageDialog(null,"Please fill in concept name field");
			}			
		}			
	}


	/** SideBar Cancel Button */
	class SideBarCancelAction extends Object implements ActionListener
	{
		public void actionPerformed(ActionEvent e) 
		{
			clearSideBars();			    	
		}
	}


	class AssociateComp extends Object implements ActionListener
	{
		public void actionPerformed(ActionEvent e) 
		{			
			DefaultMutableTreeNode comp = ctree.lastItem();
			DefaultMutableTreeNode concept = tree.lastItem();
			CElement cel;			
			if((concept!=null) && (!concept.getUserObject().toString().equalsIgnoreCase("ontologies")))
			{
				if(comp!=null)
				{
					NodeData  nd= (NodeData) comp.getUserObject();				
					if((nd!=null)&&((nd.getType().equalsIgnoreCase("method")) || (nd.getType().equalsIgnoreCase("param")))) 
					{
						int nparam=0;
						cel = ctree.getElement(comp);
						cel.setConcept(concept.getUserObject().toString());
						String type = nd.getType(); 
						if(type.equalsIgnoreCase("method"))						
							nparam  = comp.getChildCount()-1;						
						else if(type.equalsIgnoreCase("param"))
							nparam  = comp.getSiblingCount()-1;
						cel.setNumberofparam(nparam);	
						xktc.AssociateConceptToComponent(cel);
						crmc.Associate(cel);						
						DefaultMutableTreeNode lastItem = tree.getSelectedNode();
						int newIndex;
						if(lastItem == null)						 
							newIndex= tree.treeModel.getChildCount(lastItem);						
	    				else						
							newIndex = lastItem.getChildCount();
						Parent = ((NodeData) lastItem.getUserObject()).getValue();						
						String str = comp.getUserObject().toString() + " : " + concept.getUserObject().toString() + " successfully associated"	;
						String str2 = cel.getComponent() + ":" + cel.getMethod() + ":" + cel.getParam();						
						DefaultMutableTreeNode node = tree.createComponentNode(str2); 						
						tree.treeModel.insertNodeInto(node,lastItem, newIndex);
						ComponentsBar();
						sb.getViewport().removeAll();
						sb2.getViewport().add(pn3);
						//renderOntologyTree();
						JOptionPane.showMessageDialog(null, str);
					}
					else
					{
						String str = "Unable to create Association \n";
						str+= "'" + comp.getUserObject().toString() + "' is not a valid method or parameter";
						JOptionPane.showMessageDialog(null, str);
					}
				}
				else
					JOptionPane.showMessageDialog(null, "Please select a methood or a parameter from a valid component");
			}
			else
				JOptionPane.showMessageDialog(null, "Please choose  a valid concept to associate");
		}
	}


	class RemoveConceptAssociation extends Object implements ActionListener
	{
	/**
	* Removes association between a given concept and a component
	*/
	 public void actionPerformed(ActionEvent e)
	 {
	 	lastItem = tree.getSelectedNode();
	 	String Type = ((NodeData) lastItem.getUserObject()).getType();
	 	
	 	if((Type!=null) && (Type.equalsIgnoreCase("Component")))
	 	{	 	
	 		CElement cel = new CElement();	 	
	 		String cp = ((NodeData) lastItem.getUserObject()).getValue();
	 		StringTokenizer st = new StringTokenizer(cp, ":", true);
	 	 	cel.setComponent(st.nextToken());
	 		st.nextToken();
	 		cel.setMethod(st.nextToken());	 		
	 		if(st.hasMoreElements())
	 		{	
	 			st.nextToken();
	 			cel.setParam(st.nextToken());
	 		}	 	
	 		DefaultMutableTreeNode parent = (DefaultMutableTreeNode) lastItem.getParent();
	 		cel.setConcept(((NodeData) parent.getUserObject()).getValue());
	 	 	String question = "Do you really want to dissociate component\n"; 
	 	 	question+= cel.getComponent() + ":" + cel.getMethod() + ": " + cel.getParam() + "\n";   
	 	 	question+= "from concept: " + cel.getConcept() + " ?";
	 		int n = JOptionPane.showConfirmDialog(null, question, "Confirm Action",JOptionPane.YES_NO_OPTION);
			if (n == JOptionPane.YES_OPTION)
			{
	   	 		DefaultMutableTreeNode lastItem = tree.getSelectedNode();
	   	 		// link has 2 ends
   				xktc.DissociateComponent(cel); // dissociate concept from component 
   				crmc.Dissociate(cel); // dissociate component from concept
	    		String msg =  lastItem + " dissociated !";
				JOptionPane.showMessageDialog(null, msg);		
	    		if(lastItem != null && lastItem != (DefaultMutableTreeNode)tree.treeModel.getRoot()) {
					tree.treeModel.removeNodeFromParent(lastItem);
				ComponentsBar();
				sb.getViewport().removeAll();
				sb2.getViewport().add(pn3);
	    	}  
	    }	    	      
	   }
	   else
	    {
	    	String msg =  ((NodeData) lastItem.getUserObject()).getValue() + " is not a valid component";
			JOptionPane.showMessageDialog(null, msg);			
	    }	    
	}		
	} // End of SampleTree.RemoveAction


	class DissociateComponent extends Object implements ActionListener
	{
	/**
	* Removes association between a given concept and a component
	*/
	 public void actionPerformed(ActionEvent e)
	 {
	 		 	
	 	DefaultMutableTreeNode method, component;
	 	String smethod;
	 	String cconcept=null;
	 	String scomponent=null;
	 	String sparam = null;
	 	String oconcept = null;
	 	CElement cel = new CElement();
	 	
	 	DefaultMutableTreeNode comp = ctree.lastItem();
		DefaultMutableTreeNode concept = tree.lastItem();
		if(concept!=null)		
			 oconcept = ((NodeData) concept.getUserObject()).getValue();
		
		if((comp!=null) && (((NodeData) comp.getUserObject()).getType().equalsIgnoreCase("link")))
		{		
			cconcept = ((NodeData) comp.getUserObject()).getValue();
	 		DefaultMutableTreeNode pr = (DefaultMutableTreeNode) comp.getParent();
	 		DefaultMutableTreeNode parent = (DefaultMutableTreeNode) pr.getParent();
	 		DefaultMutableTreeNode pr2 =  (DefaultMutableTreeNode) parent.getParent();	 	
	 		String value = ((NodeData) pr2.getUserObject()).getValue();
	 		if(value.startsWith("Methods")) // then is a method
	 		{
	 			cel.setType("method");
	 			smethod = ((NodeData) parent.getUserObject()).getValue();
	 			component = (DefaultMutableTreeNode) pr2.getParent();
	 			scomponent = ((NodeData) component.getUserObject()).getValue();	 		
	 		}
	 		else
	 		{
	 			cel.setType("param");
	 			sparam = ((NodeData) parent.getUserObject()).getValue();
	 			method = (DefaultMutableTreeNode) parent.getParent();
	 			smethod = ((NodeData) method.getUserObject()).getValue();
	 			DefaultMutableTreeNode pr3 = (DefaultMutableTreeNode) pr2.getParent();
	 			component = (DefaultMutableTreeNode) (DefaultMutableTreeNode) pr3.getParent(); 			
	 			scomponent = ((NodeData) component.getUserObject()).getValue();
	 		}
	 	 	// Componet name still missing	 	 	
	 	 	cel.setComponent(scomponent);
	 	 	cel.setConcept(cconcept);
	 	 	cel.setMethod(smethod);
	 	 	cel.setParam(sparam);
	 	 	crmc.Dissociate(cel);
	 	 	xktc.DissociateComponent(cel);
	 	 	//renderOntologyTree(); 	 	
	 	 	String question = "Do you really want to dissociate component\n"; 
	 	 	question+= cel.getComponent() + ":" + cel.getMethod() + ": " + cel.getParam() + "\n";   
	 	 	question+= "from concept: " + cel.getConcept() + " ?";
	 	 	int n = JOptionPane.showConfirmDialog(null, question, "Confirm Action",JOptionPane.YES_NO_OPTION);
			if (n == JOptionPane.YES_OPTION)
			{			
	 	 		String Dissociate =  cconcept + ": ->" + scomponent  + ":"; 
	 			Dissociate += smethod + ":" + ":" + sparam + "\n";
	 			Dissociate += " Dissociated";	 		
				JOptionPane.showMessageDialog(null, Dissociate);
			}	 		 	
		}
		else
		{
			String msg = "Can not dissociate ";
			if(comp!=null)
		 		msg += ((NodeData) comp.getUserObject()).getValue();
		 	else
		 	  msg += "null";
		   	JOptionPane.showMessageDialog(null, msg);
		}
	 }
	} 


/**-----------------------------------------------------------------------------------
*** MENU GUI
/**-----------------------------------------------------------------------------------
*/

/** Construct a menu. */
	private JMenuBar constructMenuBar() 
	{
	JMenu            menu;
	JMenuBar         menuBar = new JMenuBar();
	JMenuItem        menuItem;

	/* Good ol exit. */
	menu = new JMenu("File");
	menuBar.add(menu);
	menuItem = menu.add(new JMenuItem("Exit"));
	menuItem.addActionListener(new ActionListener() 
	{
	    public void actionPerformed(ActionEvent e) {
		System.exit(0);
	}});
	/* Concept Menu */
	menu = new JMenu("Concept");
	menuBar.add(menu);
	menuItem = menu.add(new JMenuItem("Find"));
	menuItem.addActionListener(new FindAction());
	menuItem = menu.add(new JMenuItem("Edit"));
	menuItem.addActionListener(new EditAction());
	menuItem = menu.add(new JMenuItem("Insert"));
	menuItem.addActionListener(new InsertAction());
	menuItem = menu.add(new JMenuItem("Information"));
	menuItem.addActionListener(new SubItems());
	menuItem = menu.add(new JMenuItem("Dissociate Component"));
	menuItem.addActionListener(new RemoveConceptAssociation());
	menuItem = menu.add(new JMenuItem("Remove"));
	menuItem.addActionListener(new RemoveAction());
	/*  Ontology Menu */
	menu = new JMenu("Ontology");
	menuBar.add(menu);
	menuItem = menu.add(new JMenuItem("New"));
	menuItem.setEnabled(false);
	menuItem = menu.add(new JMenuItem("Import"));
	menuItem.setEnabled(false);	
	/*  Ontology Menu */
	menu = new JMenu("Component");
	menuBar.add(menu);
	menuItem = menu.add(new JMenuItem("Import"));
	menuItem.addActionListener(new ImportComp());
	menuItem = menu.add(new JMenuItem("View Components"));
	menuItem.addActionListener(new ListCompAction());	
	menuBar.setEnabled(false);
	menuBar.setVisible(false);
	return menuBar;
	}
	
	
    /** Constructs a JPanel containing check boxes for the different
    * options that tree supports. */
	private JPanel constructOptionsPanel() 
	{	
	borderPane = new JPanel(false);
	borderPane.setLayout(new BorderLayout());

	JPanel         buttonPane = new JPanel(false);
	buttonPane.setLayout(new FlowLayout(java.awt.FlowLayout.LEFT));
	JLabel label;
	label = new JLabel("TalkAgent Server: ");
	host = new JTextField(25);
	host.setText("localhost");
	connectButton = new JButton("Connect");	
	connectButton.addActionListener(new ConnectAction());	
	disconnectButton = new JButton("Disconnect");	
	disconnectButton.setEnabled(false);
    buttonPane.add(label);
    buttonPane.add(host);
    buttonPane.add(connectButton);
    buttonPane.add(disconnectButton);     
	borderPane.add(buttonPane, "North");
	return borderPane;	
	}

	
	/* Right Conner Top Sidebar */    
	public void SideBar(String Label, String Action, String Parent, String Concept)
    {   	
		JPanel pn  = new JPanel(false);
    	pn.setLayout(new BorderLayout());    	    	
    	JPanel concept  = new JPanel(false);
	 	GridLayout grid = new GridLayout(7,1);	 	   	
    	concept.setLayout(grid);    	    	    	
    		JLabel action  = new JLabel(Label);    	
	    	action.setOpaque(true);
	    	action.setBackground(Color.yellow);	   	
			concept.add(action); //1			 			  			
			JLabel dummy1  = new JLabel("  ");    	
			concept.add(dummy1); //2			
			JLabel parent  = new JLabel(Parent);
			concept.add(parent); //3	
			JLabel dummy2  = new JLabel("  "); 
			concept.add(dummy2); //4	 
			JLabel nc  = new JLabel(Action); 
			concept.add(nc); //6	 		
			JLabel desc  = new JLabel(Concept); 
			concept.add(desc); //5	 	  			
			conceptName = new JTextField();
			concept.add(conceptName); //7		
		pn.add(concept, "North");  			
			JPanel buttons  = new JPanel(false);	
			buttons.setLayout(new FlowLayout());
				JButton ok = new JButton("OK");
				buttons.add(ok);
				if(Label.equalsIgnoreCase("Insert New Concept"))    
					ok.addActionListener(new InsertConceptAction());
				if(Label.equalsIgnoreCase("Edit Concept"))   
					ok.addActionListener(new EditConceptAction());
				if(Label.equalsIgnoreCase("Find Concept"))
				{   
					ok.setText("Find");
					ok.addActionListener(new FindConceptAction());
				}			
				JButton cancel = new JButton("Cancel");;
				cancel.addActionListener(new SideBarCancelAction());
				buttons.add(cancel);				
		pn.add(buttons, "Center");
		sb.getViewport().add(pn);				    			    	
    }


    /* Assertions Bar (Right Conner Botton Sidebar)*/
	public void SideBar2(String Concept)
	{			
		pn2 = new JPanel(false);
		pn2.setLayout(new BorderLayout());				
		JPanel up = new JPanel();
		up.setLayout(new BorderLayout());		
			JPanel assertions = new JPanel(false);
			GridLayout grid = new GridLayout(2,1);    	
			assertions.setLayout(grid);
    		JLabel ast  = new JLabel("Assertions: ");
    		assertions.add(ast);    	
    		JLabel dummy  = new JLabel(" ");
    		assertions.add(dummy);    	   	    	    	
			up.add(assertions, "North");
			astBox = new JList();
			BoxAddAssertions(Concept);		
			astBox.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
			astBox.setVisibleRowCount(5);
			JScrollPane sp3 = new JScrollPane();
			sp3.getViewport().add(astBox);		
		up.add(sp3, "Center");		
		pn2.add(up, "North"); // pn2 1
			JPanel east = new JPanel(false);
 			GridLayout grid2= new GridLayout(9,1);   	
    		east.setLayout(grid2);
    			JLabel astl = new JLabel("Assertion: ");
    		east.add(astl); // 1
    			JLabel dummy2= new JLabel("");
    		east.add(dummy2); // 2
    			String[] items = {"is", "atrib","relat"};
    			JComboBox jComboBox1 = new JComboBox(items);
    	 		Dimension d = jComboBox1.getPreferredSize();
    			jComboBox1.setPreferredSize(new Dimension(d.width, 5));    	
    			jComboBox1.setMaximumRowCount(3);    	
    		east.add(jComboBox1); // 3
    			JLabel dummy3= new JLabel("");
    		east.add(dummy3); // 4
    			String[] items2 = {"default", "number","string"};
    			JComboBox jComboBox2 = new JComboBox(items2);
    			jComboBox2.setMaximumRowCount(3);    	
    			jComboBox2.setVisible(true);    	
    		east.add(jComboBox2); // 5
    			JLabel dummy4= new JLabel("");
    		east.add(dummy4); // 6    	
				JPanel value1  = new JPanel(false);	
					JLabel v1 = new JLabel("Type:  ");
				value1.add(v1);
					JTextField val1 = new JTextField(20);
				value1.add(val1);
			east.add(value1); //7			
				JPanel value2  = new JPanel(false);	
					JLabel v2 = new JLabel("Value: ");
				value2.add(v2);		
					JTextField val2 = new JTextField(20);
				value2.add(val2);
			east.add(value2); //8
				JPanel buttons  = new JPanel(false);	
				buttons.setLayout(new FlowLayout());
					JButton edit = new JButton("Edit");
   	    		buttons.add(edit);
					JButton add = new JButton("Add");;
				buttons.add(add);				    	
					JButton CANCEL = new JButton("Cancel");;
				buttons.add(CANCEL);	
    	pn2.add(east, "South");    			    	
		JPanel pn22 = new JPanel(false);
		pn22.setLayout(new BorderLayout());
		pn22.add(pn2, "North");		    			    	
    	pn22.add(buttons, "Center");  
		sb2.getViewport().add(pn22);		    		
	}	
	
	
	// Displays assertions of a given concept on rightdown box
	protected void BoxAddAssertions(String ConceptName)
	{
	int i;
	
		ozConcept cpt = xktc.getConcept(ConceptName);
		Vector Assertions = cpt.getAssertions();
		String assertion;		
		Vector ListData = new Vector(1);	
		if(Assertions.size()==0)
			ListData.addElement("No Assertions");
		for(i=0;i<Assertions.size();i++)
		{
			ozAssertion ozA = (ozAssertion) Assertions.elementAt(i);
			if(ozA != null)
			{ 							
				assertion = ozA.getType();
				Relation rl =ozA.getvalue(); 
				assertion += " :: " + rl.getType();
				assertion += " :: " + rl.getValue().toString();
				ListData.addElement(assertion);
			}
		}
		astBox.setListData(ListData);
	}


	// SideBar which displays components info 
	public void ComponentsBar()
	{							
		pn3 = new JPanel(false);
		JScrollPane sp2 = new JScrollPane(); 
		pn3.setLayout(new BorderLayout());
		JPanel ptitle = new JPanel();
		GridLayout grid2 = new GridLayout(2,1);
		ptitle.setLayout(grid2);
		JLabel title = new JLabel("Components");
		title.setOpaque(true);
		title.setBackground(Color.yellow);		
		ptitle.add(title);
		JLabel dummy = new JLabel("");
		ptitle.add(dummy);	
		JPanel comp = new JPanel(false);		
		comp.setLayout(new BorderLayout());
		comp.add(ptitle,"North");				
		ctree = new ComponentTree(crmc);       			
		ctree.buildTree();		      	
       	comp.add(sp2, "Center");
       	sp2.getViewport().add(ctree.getTree());
		JPanel buttons  = new JPanel(false);	
		buttons.setLayout(new FlowLayout());
		JButton importButton = new JButton((new ImageIcon("../ide/images/addcomp.gif")));
    	importButton.setToolTipText("Import Component");
		importButton.addActionListener(new  ImportComp());
		buttons.add(importButton);
		JButton deleteButton = new JButton((new ImageIcon("../ide/images/delete.gif")));
		deleteButton.setToolTipText("Delete Component");
		deleteButton.addActionListener(new  DeleteComponent());
		buttons.add(deleteButton);			
		JButton con = new JButton(new ImageIcon("../ide/images/associate.gif"));
		con.setToolTipText("Associate Component to Concept");
		con.addActionListener(new AssociateComp());
   	    buttons.add(con);   	    
		JButton disc = new JButton(new ImageIcon("../ide/images/dissociate.gif"));
		disc.setToolTipText("Dissociate concept from component");
		disc.addActionListener(new DissociateComponent());
		buttons.add(disc);
		JButton run = new JButton(new ImageIcon("../ide/images/run.gif"));
		run.setToolTipText("Run method");
		run.addActionListener(new RunComponent());
		buttons.add(run);						    	
		JButton CANCEL = new JButton(new ImageIcon("../ide/images/cancel.gif"));
		CANCEL.setToolTipText("Cancel");
		CANCEL.addActionListener(new SideBarCancelAction());
		buttons.add(CANCEL);		
		JPanel Panel20 = new JPanel(false);
		Panel20.setLayout(new BorderLayout());
		Panel20.add(buttons, "North");
		
		JPanel Properties = new JPanel(false);
		JLabel dummy75 = new JLabel("\n");		
		JLabel dummy76 = new JLabel("Parameters:");
		Properties.setLayout(new BorderLayout());
		jTable1 = new JTable();
		DefaultTableModel tm = new DefaultTableModel(
            new Object [][] {
                {"param0", null},
                {"param1", null},
                {"param2", null},
                {"param3", null},
                {"param4", null},
                {"param5", null},                                
            },
            new String [] {
                "Parameter", "Value"
            });
        jTable1.setModel(tm);		                            
		//JScrollPane sprop = new JScrollPane(jTable1);
		TableColumnModel colModel = jTable1.getColumnModel();
		// set width of columns in table
		colModel.getColumn(0).setWidth(50);
		colModel.getColumn(0).setMaxWidth(60);
		jTable1.setColumnModel(colModel);		
		int ncols = jTable1.getRowCount();
		for(int i =0; i<ncols; i++)
			jTable1.changeSelection(i, 0, false, false);
		//colModel.getColumn(0).setModelIndex(JTable.);
		jTable1.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
		
		
		Properties.add(dummy75, "North");
		Properties.add(dummy76, "Center");
		Properties.add(jTable1, "South");		
		Panel20.add(Properties, "Center");
		
		JPanel Labels = new JPanel(false);
		Labels.setLayout(new BorderLayout());		
		JLabel dummy77 = new JLabel("\n");		
		Labels.add(dummy77, "North");
		JLabel dinfo = new JLabel("\nDebug Info:");		
		Labels.add(dinfo, "Center");
		debug = new JTextArea(5,25);
		debug.setLineWrap(true);	
		debug.setEditable(false);	
		JScrollPane sc = new JScrollPane(debug);
		Labels.add(sc, "South");						
		Panel20.add(Labels, "South");		
				
		comp.add(Panel20, "South");
		pn3.add(comp, "North");
	}


	public void clearSideBars()
	{		
		sb.getViewport().removeAll();
		sb.getViewport().repaint();		        
		sb2.getViewport().removeAll();
		sb2.getViewport().repaint();
	}
	
	
	public void renderOntologyTree()
	{
		tree = new OntologyTree(xktc);				
		tree.buildTree();			
		sp.getViewport().add(tree.getTree());
				
	}
	


/**-----------------------------------------------------------------------------------*/
/**-----------------------------------------------------------------------------------
 */	


	static public void main(String args[]) 
	{
		new IDEform();
	}


	/**
	  * Constructs a new instance of SampleTree.
	  */
	public IDEform() 
	{
	// Force SampleTree to come up in the Cross Platform L&F
	super(false);
	
	try 
	{
	    //UIManager.setLookAndFeel(UIManager.getCrossPlatformLookAndFeelClassName());
	    // If you want the System L&F instead, comment out the above line and
	    // uncomment the following:
	    UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
	} catch (Exception exc) {
	    System.err.println("Error loading L&F: " + exc);
	}

	menuBar = constructMenuBar();
    panel = new JPanel(true);

	frame = new JFrame("TalkAgent IDE 0.1");
	frame.getContentPane().add("Center", panel);
	frame.setJMenuBar(menuBar);
	frame.setBackground(Color.lightGray);
		
	sp = new JScrollPane();
	sp.setPreferredSize(new Dimension(300, 500));	
	sb = new JScrollPane();
	sb.setPreferredSize(new Dimension(400, 200));
	sb2 = new JScrollPane();
	sb2.setPreferredSize(new Dimension(400, 600));	
	sb3 = new JScrollPane();
	sb3.setPreferredSize(new Dimension(400, 500));	
	//Footer = new JScrollPane();
 	//Footer.setPreferredSize(new Dimension(500, 25));
	LeftPanel = new JPanel(false);
	//GridLayout grid = new GridLayout(2,1);    	
    LeftPanel.setLayout(new BorderLayout());    	
   	LeftPanel.add(sb, "North");
	LeftPanel.add(sb2, "Center");
	
	/*
	LeftBar = new JPanel();
	LeftBar.add(LeftPanel); 
	*/
	MLeftBar = new JScrollPane();
	MLeftBar.setPreferredSize(new Dimension(400,1000));
	MLeftBar.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
	MLeftBar.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_NEVER);
	//MLeftBar.setVerticalScrollBar(null);
	//MLeftBar.setHorizontalScrollBar(null);
	MLeftBar.getViewport().add(LeftPanel);
	
	/* And show it. */
	panel.setLayout(new BorderLayout());
	panel.add("North", constructOptionsPanel());	
	panel.add("Center", sp);
	//panel.add("South", Footer);		
    panel.add("East", MLeftBar);
       

	frame.addWindowListener( new WindowAdapter() {
	    public void windowClosing(WindowEvent e) {System.exit(0);}});

    /* Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
    frame.setSize((d.width), (d.height));
    Dimension b = frame.getSize();
    frame.setLocation((d.width - b.width) / 2, (d.height - b.height) / 2);
    */    	
	frame.setExtendedState(frame.MAXIMIZED_BOTH);
	frame.pack();
	frame.show();
   	frame.setExtendedState(frame.MAXIMIZED_BOTH);    	
	}
}
