// You can redistribute this software and/or modify it under the terms of
// the Ozone Library License version 1 published by softwarebuero m&b (SMB).
//
// Copyright (C) The Ozone Database Project. All rights reserved.
//
// $Id: OzoneProducer.java,v 1.1 2002/11/27 16:30:45 cvs Exp $

import java.io.*;
import org.w3c.dom.*;
import javax.servlet.http.*;

import org.apache.cocoon.framework.*;
import org.apache.cocoon.parser.Parser;
import org.apache.cocoon.producer.Producer;

import org.ozoneDB.*;
import org.ozoneDB.xml.*;
import org.ozoneDB.xml.dom.*;
import org.ozoneDB.xml.util.*;


/**
 * Simple sample that shows how to use ozone together with Cocoon. You need to
 * install Cocoon</a> in order to run this example. Please check
 * http://xml.apache.org/cocoon.<p>
 * 
 * The Infozone project (http://infozone-group.org) has been started to provide
 * a complete content management framework based on ozone and Cocoon.
 * 
 * 
 * @author <a href="mailto:zvia@netmanage.co.il">Zvi Avraham</a>
 * @version $Revision: 1.1 $Date: 2002/11/27 16:30:45 $
 */
public class OzoneProducer extends AbstractActor implements Producer, Status {
    // TODO: make all this Configurable
    private final static String hostname = "localhost";
    private final static int port = 3333;
    private final static String username = "zvi";
    private final static String password = "111";
    
    private RemoteDatabase database = null;
    
    
    /**
     * get persistent DOM document form Ozone DB
     * @return persistent DOM document form Ozone DB
     */
    public Document getDocument( HttpServletRequest request ) throws Exception {
        if (database == null) {
            database = new RemoteDatabase();
            database.open( hostname, port, username, password );
            database.reloadClasses();
        } 
        ;
        
        final String documentName = request.getParameter( "document" );
        final String query = request.getParameter( "query" );
        final String stylesheet = request.getParameter( "stylesheet" );
        
        if (documentName == null) {
            throw new Exception( "document parameter is not defined" );
        } 
        ;
        
        Document document = (Document)database.objectForName( documentName );
        
        if (query != null) {
            // TODO: return XPath.executeQuery(document, query);
            throw new Exception( "XPath query engine still not implemented" );
        } 
        ;
        
        if (stylesheet != null) {
            // TODO: insert:
            // <?xsl:stylesheet href=\""+stylesheet+"\"?>
            // <?cocoon-process type="xslt"?>
            throw new Exception( "XSLT processing still not implemented" );
        } 
        ;
        
        return document;
    } 
    
    
    /**
     * This method is responsible to provide an input stream to read
     * the data generated or contained by the resource mapped by
     * this document producer. This stream is not guaranteed to be
     * buffered.
     */
    public Reader getStream( HttpServletRequest request ) throws Exception {
        return null;
    } 
    
    
    /**
     * Returns the path where the resource is found, or an empty string if
     * no path can be applied to the resource.
     * Warning, null values are not valid.
     */
    public String getPath( HttpServletRequest request ) {
        return "";
    } 
    
    
    /**
     * This method always returns true to reduce the evaluation overhead to
     * a minimum. Producer are highly encouradged to overwrite this method
     * if they can provide a fast way to evaluate the response change.
     */
    public boolean hasChanged( Object request ) {
        return true;
    } 
    
    
    /**
     * toString() like method ...
     */
    public String getStatus() {
        return "Ozone PDOM Producer";
    } 
}
