// You can redistribute this software and/or modify it under the terms of
// the Ozone Core License version 1 published by ozone-db.org.
//
// The original code and portions created by Thorsten Fiebig are
// Copyright (C) 2000-@year@ by Thorsten Fiebig. All rights reserved.
// Code portions created by SMB are
// Copyright (C) 1997-@year@ by SMB GmbH. All rights reserved.
//
// $Id: OO7_CompositePartImpl.java,v 1.1 2002/11/27 16:30:46 cvs Exp $

import org.ozoneDB.OzoneObject;
import org.ozoneDB.DxLib.*;


public class OO7_CompositePartImpl extends OO7_DesignObjectImpl implements OO7_CompositePart {
    OO7_Document theDocumentation;
    DxListBag theUsedInPriv;
    DxListBag theUsedInShar;
    DxListBag theParts;
    OO7_AtomicPart theRootPart;
    
    
    public OO7_CompositePartImpl() {
        theUsedInPriv = new DxListBag();
        theUsedInShar = new DxListBag();
        theParts = new DxListBag();
    }
    
    
    public void setDocumentation( OO7_Document x ) {
        theDocumentation = x;
    } 
    
    
    public OO7_Document documentation() {
        return theDocumentation;
    } 
    
    
    public void addUsedInPriv( OO7_BaseAssembly x ) {
        theUsedInPriv.addBack( x );
    } 
    
    
    public DxBag usedInPriv() {
        return theUsedInPriv;
    } 
    
    
    public void addUsedInShar( OO7_BaseAssembly x ) {
        theUsedInShar.addBack( x );
    } 
    
    
    public DxBag usedInShar() {
        return theUsedInShar;
    } 
    
    
    public void addPart( OO7_AtomicPart x ) {
        theParts.add( x );
    } 
    
    
    public DxBag parts() {
        return theParts;
    } 
    
    
    public void setRootPart( OO7_AtomicPart x ) {
        theRootPart = x;
    } 
    
    
    public OO7_AtomicPart rootPart() {
        return theRootPart;
    } 
}
