// $Id: SongCollection.java,v 1.1 2002/11/27 16:30:47 cvs Exp $



import Song;

import java.lang.String;
import java.util.Collection;
import java.util.AbstractMap;

import org.ozoneDB.*;

/**
 * The external interface of the database object SongCollection
 * A SongCollection is the catalog of songs an artist plays.
 * 
 * NOTE:  Maybe this should be based on an Ozone collection...
 *
 * @version $Revision: 1.1 $ $Date: 2002/11/27 16:30:47 $
 * @author James Stiefel
 */
public interface SongCollection extends OzoneRemote {
    /**
     * Retrieves the object's unique (database) Handle
     *
     * @return the object handle   
     */
    public String handle();

    /**
     * Adds a Song to the SongCollection
     * You can add a Song with whatever title you choose.
     * We suggest using it's own title. 
     * "Nicknames" (multiple entries for the same song) may work,
     * but they may cause problems too (especially in MasterCollection). 
     *
     */
    public void         addSong(String title, Song song) throws Exception ;      /*update*/


    /**
     * Deletes a Song from the SongCollection
     *
     */
    public Song         deleteSong(String title);          /*update*/
    
    /**
     * Finds a song in SongCollection
     *
     */
    public Song         findSong(String song_title);

    /**
     * Returns the collection of songs in the SongCollection.
     * Modifications to that collection ought to be reflected
     * in this SongCollection, but one should make changes to the 
     * SongCollection to ensure they persist.
     */
    public AbstractMap   getAllSongs(); 
}
