package cli;

import java.io.*;
import java.net.HttpURLConnection;
import java.net.URL;

import db.Hello;
import db.HelloImpl;
import org.ozoneDB.ExternalDatabase;
import org.ozoneDB.OzoneInterface;

public class HelloClient {

    private static Hello hello;
    private static ExternalDatabase db;
    private static String OBJ_NAME = "hej";

    public static void main(String[] args) {
        try {
            buildObject();
            callServlet();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    private static void buildObject() throws Exception {
        System.out.println("Trying to connect to ozone...");
        db = ExternalDatabase.openDatabase("ozonedb:remote://localhost:3333");
        System.out.println("....Connected to ozone");
        db.reloadClasses();
        System.out.println("....Classes reloaded");
        hello = (Hello) db.objectForName(OBJ_NAME);
        if (hello == null) {
            System.out.println("Storing new Hello object");
            hello = (Hello) db.createObject(HelloImpl.class.getName(), OzoneInterface.Public, OBJ_NAME);
        } else {
            System.out.println("Found existing Hello object");
        }
        System.out.println("db.Hello has the following greeting: " + hello.getGreeting());
        db.close();
    }

    private static void callServlet() throws IOException {
        URL url = new URL("http", "localhost", 80, "/SimpleOzoneServlet/HelloServlet");
        System.out.println("Connecting to " + url);
        HttpURLConnection connection = (HttpURLConnection) url.openConnection();
        BufferedReader reader = new BufferedReader(new InputStreamReader(connection.getInputStream()));
        String response = reader.readLine();
        do {
            System.out.println(response);
            response = reader.readLine();
        } while (response != null);
    }
}