<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2//EN">
<!--NewPage-->
<html>
<head>
<!-- Generated by javadoc on Tue Nov 30 15:58:29 EST 1999 -->
<title>
  Class com.signiform.tt.TTConnection
</title>
</head>
<body>
<a name="_top_"></a>
<pre>
<a href="packages.html">All Packages</a>  <a href="tree.html">Class Hierarchy</a>  <a href="Package-com.signiform.tt.html">This Package</a>  <a href="Package-com.signiform.tt.html">Previous</a>  <a href="Package-com.signiform.tt.html">Next</a>  <a href="AllNames.html">Index</a></pre>
<hr>
<h1>
  Class com.signiform.tt.TTConnection
</h1>
<pre>
java.lang.Object
   |
   +----com.signiform.tt.TTConnection
</pre>
<hr>
<dl>
  <dt> public class <b>TTConnection</b>
  <dt> extends Object
</dl>
The <code>TTConnection</code> class provides an interface
 to the ThoughtTreasure natural language/commonsense server.
 It implements the ThoughtTreasure Server Protocol (TTSP).
 <p>
 Here is a simple program which asks the ThoughtTreasure
 server whether Evian is a beverage:
 <pre>
 import com.signiform.tt.*;
 public class Example {
 public static void main(String args[])
 {
   try {
     TTConnection tt = new TTConnection("somehost");
     System.out.println(tt.ISA("beverage", "Evian"));
     tt.close();
   } catch (Exception e) {
   }
 }
 }
 </pre>
 <p>
 To start the ThoughtTreasure server, start ThoughtTreasure
 and then issue the command:
 <pre>
 server
 </pre>
 to listen on port 1832, the ThoughtTreasure Server Protocol (TTSP)
 registered port number listed by the Internet Assigned Numbers
 Authority (IANA), or:
 <pre>
 server -port PORT
 </pre>
 to listen on port number <code>PORT</code>.
 <p>
 The discourse context is normally maintained across calls for
 a given <code>TTConnection</code>. This allows, for example, pronouns
 to be understood and generated. To clear the connection's discourse
 context, use <code>clearContext</code>.
<p>
<hr>
<a name="index"></a>
<h2>
  <img src="images/variable-index.gif" width=207 height=38 alt="Variable Index">
</h2>
<dl>
  <dt> <img src="images/blue-ball-small.gif" width=6 height=6 alt=" o ">
	<a href="#DEBUG"><b>DEBUG</b></a>
  <dd>  Whether debugging information should be printed to <code>System.out</code>;
 <code>false</code> by default.
  <dt> <img src="images/blue-ball-small.gif" width=6 height=6 alt=" o ">
	<a href="#PORT"><b>PORT</b></a>
  <dd>  The ThoughtTreasure Server Protocol (TTSP) registered port number
 listed by the Internet Assigned Numbers Authority (IANA); the port
 number is 1832.
  <dt> <img src="images/blue-ball-small.gif" width=6 height=6 alt=" o ">
	<a href="#USECACHE"><b>USECACHE</b></a>
  <dd>  Whether to cache results for later reuse without contacting
 the ThoughtTreasure server; <code>true</code> by default.
</dl>
<h2>
  <img src="images/constructor-index.gif" width=275 height=38 alt="Constructor Index">
</h2>
<dl>
  <dt> <img src="images/yellow-ball-small.gif" width=6 height=6 alt=" o ">
	<a href="#TTConnection(java.net.InetAddress)"><b>TTConnection</b></a>(InetAddress)
  <dd>  Creates a new connection to the specified ThoughtTreasure server.
  <dt> <img src="images/yellow-ball-small.gif" width=6 height=6 alt=" o ">
	<a href="#TTConnection(java.net.InetAddress, int)"><b>TTConnection</b></a>(InetAddress, int)
  <dd>  Creates a new connection to the specified ThoughtTreasure server.
  <dt> <img src="images/yellow-ball-small.gif" width=6 height=6 alt=" o ">
	<a href="#TTConnection(java.lang.String)"><b>TTConnection</b></a>(String)
  <dd>  Creates a new connection to the specified ThoughtTreasure server.
  <dt> <img src="images/yellow-ball-small.gif" width=6 height=6 alt=" o ">
	<a href="#TTConnection(java.lang.String, int)"><b>TTConnection</b></a>(String, int)
  <dd>  Creates a new connection to the specified ThoughtTreasure server.
</dl>
<h2>
  <img src="images/method-index.gif" width=207 height=38 alt="Method Index">
</h2>
<dl>
  <dt> <img src="images/red-ball-small.gif" width=6 height=6 alt=" o ">
	<a href="#ancestors(java.lang.String)"><b>ancestors</b></a>(String)
  <dd>  Returns the ancestors of the specified object.
  <dt> <img src="images/red-ball-small.gif" width=6 height=6 alt=" o ">
	<a href="#bringdown()"><b>bringdown</b></a>()
  <dd>  Forces ThoughtTreasure to break out of the server select loop,
 so that it can process further ThoughtTreasure shell commands.
  <dt> <img src="images/red-ball-small.gif" width=6 height=6 alt=" o ">
	<a href="#chatterbot(java.lang.String, java.lang.String)"><b>chatterbot</b></a>(String, String)
  <dd>  Sends natural language input text to the chatterbot and returns the
 natural language response.
  <dt> <img src="images/red-ball-small.gif" width=6 height=6 alt=" o ">
	<a href="#children(java.lang.String)"><b>children</b></a>(String)
  <dd>  Returns the children of the specified object.
  <dt> <img src="images/red-ball-small.gif" width=6 height=6 alt=" o ">
	<a href="#clearCache()"><b>clearCache</b></a>()
  <dd>  Clears the cache.
  <dt> <img src="images/red-ball-small.gif" width=6 height=6 alt=" o ">
	<a href="#clearContext()"><b>clearContext</b></a>()
  <dd>  Clears the discourse context.
  <dt> <img src="images/red-ball-small.gif" width=6 height=6 alt=" o ">
	<a href="#close()"><b>close</b></a>()
  <dd>  Closes the connection.
  <dt> <img src="images/red-ball-small.gif" width=6 height=6 alt=" o ">
	<a href="#conceptToLexEntries(java.lang.String)"><b>conceptToLexEntries</b></a>(String)
  <dd>  Returns the lexical entries associated with the specified object
 (atomic concept) in the lexicon.
  <dt> <img src="images/red-ball-small.gif" width=6 height=6 alt=" o ">
	<a href="#descendants(java.lang.String)"><b>descendants</b></a>(String)
  <dd>  Returns the descendants of the specified object.
  <dt> <img src="images/red-ball-small.gif" width=6 height=6 alt=" o ">
	<a href="#generate(java.lang.String, java.lang.Object)"><b>generate</b></a>(String, Object)
  <dd>  Generates the specified ThoughtTreasure assertion in natural language.
  <dt> <img src="images/red-ball-small.gif" width=6 height=6 alt=" o ">
	<a href="#ISA(java.lang.String, java.lang.String)"><b>ISA</b></a>(String, String)
  <dd>  Tests whether the specified object is of the specified class.
  <dt> <img src="images/red-ball-small.gif" width=6 height=6 alt=" o ">
	<a href="#isPartOf(java.lang.String, java.lang.String)"><b>isPartOf</b></a>(String, String)
  <dd>  Tests whether the specified object is a part of another specified object.
  <dt> <img src="images/red-ball-small.gif" width=6 height=6 alt=" o ">
	<a href="#parents(java.lang.String)"><b>parents</b></a>(String)
  <dd>  Returns the parents of the specified object.
  <dt> <img src="images/red-ball-small.gif" width=6 height=6 alt=" o ">
	<a href="#phraseToConcepts(java.lang.String, java.lang.String)"><b>phraseToConcepts</b></a>(String, String)
  <dd>  Returns the objects (atomic concepts) for the specified
 word or phrase (lexical entry) in the lexicon.
  <dt> <img src="images/red-ball-small.gif" width=6 height=6 alt=" o ">
	<a href="#retrieve(int, int, int, java.lang.String, java.lang.String)"><b>retrieve</b></a>(int, int, int, String, String)
  <dd>  Retrieves assertions from the database matching the specified pattern.
  <dt> <img src="images/red-ball-small.gif" width=6 height=6 alt=" o ">
	<a href="#semanticParse(java.lang.String, java.lang.String)"><b>semanticParse</b></a>(String, String)
  <dd>  Semantically parses the specified natural language text.
  <dt> <img src="images/red-ball-small.gif" width=6 height=6 alt=" o ">
	<a href="#status()"><b>status</b></a>()
  <dd>  Returns the status of the ThoughtTreasure server: "up" or "down".
  <dt> <img src="images/red-ball-small.gif" width=6 height=6 alt=" o ">
	<a href="#syntacticParse(java.lang.String, java.lang.String)"><b>syntacticParse</b></a>(String, String)
  <dd>  Syntactically parses the specified natural language text.
  <dt> <img src="images/red-ball-small.gif" width=6 height=6 alt=" o ">
	<a href="#tag(java.lang.String, java.lang.String)"><b>tag</b></a>(String, String)
  <dd>  Performs part-of-speech (and other) tagging of the specified
 natural language text.
</dl>
<a name="variables"></a>
<h2>
  <img src="images/variables.gif" width=153 height=38 alt="Variables">
</h2>
<a name="DEBUG"><img src="images/blue-ball.gif" width=12 height=12 alt=" o "></a>
<b>DEBUG</b>
<pre>
 public static boolean DEBUG
</pre>
<dl>
  <dd> Whether debugging information should be printed to <code>System.out</code>;
 <code>false</code> by default.<p>
</dl>
<a name="USECACHE"><img src="images/blue-ball.gif" width=12 height=12 alt=" o "></a>
<b>USECACHE</b>
<pre>
 public static boolean USECACHE
</pre>
<dl>
  <dd> Whether to cache results for later reuse without contacting
 the ThoughtTreasure server; <code>true</code> by default.<p>
</dl>
<a name="PORT"><img src="images/blue-ball.gif" width=12 height=12 alt=" o "></a>
<b>PORT</b>
<pre>
 public static int PORT
</pre>
<dl>
  <dd> The ThoughtTreasure Server Protocol (TTSP) registered port number
 listed by the Internet Assigned Numbers Authority (IANA); the port
 number is 1832.<p>
</dl>
<a name="constructors"></a>
<h2>
  <img src="images/constructors.gif" width=231 height=38 alt="Constructors">
</h2>
<a name="TTConnection"></a>
<a name="TTConnection(java.lang.String)"><img src="images/yellow-ball.gif" width=12 height=12 alt=" o "></a>
<b>TTConnection</b>
<pre>
 public TTConnection(String host) throws IOException
</pre>
<dl>
  <dd> Creates a new connection to the specified ThoughtTreasure server.
 The IANA-listed registered port number is assumed.
<p>
  <dd><dl>
    <dt> <b>Parameters:</b>
    <dd> host - the host name of the ThoughtTreasure server
    <dt> <b>Throws:</b> IOException
    <dd> if an I/O error occurs when creating the socket
  </dl></dd>
</dl>
<a name="TTConnection(java.net.InetAddress)"><img src="images/yellow-ball.gif" width=12 height=12 alt=" o "></a>
<b>TTConnection</b>
<pre>
 public TTConnection(InetAddress address) throws IOException
</pre>
<dl>
  <dd> Creates a new connection to the specified ThoughtTreasure server.
 The IANA-listed registered port number is assumed.
<p>
  <dd><dl>
    <dt> <b>Parameters:</b>
    <dd> address - the IP address of the ThoughtTreasure server
    <dt> <b>Throws:</b> IOException
    <dd> if an I/O error occurs when creating the socket
  </dl></dd>
</dl>
<a name="TTConnection(java.lang.String, int)"><img src="images/yellow-ball.gif" width=12 height=12 alt=" o "></a>
<b>TTConnection</b>
<pre>
 public TTConnection(String host,
                     int port) throws IOException
</pre>
<dl>
  <dd> Creates a new connection to the specified ThoughtTreasure server.
<p>
  <dd><dl>
    <dt> <b>Parameters:</b>
    <dd> host - the host name of the ThoughtTreasure server
    <dd> port - the port number of the ThoughtTreasure server
    <dt> <b>Throws:</b> IOException
    <dd> if an I/O error occurs when creating the socket
  </dl></dd>
</dl>
<a name="TTConnection(java.net.InetAddress, int)"><img src="images/yellow-ball.gif" width=12 height=12 alt=" o "></a>
<b>TTConnection</b>
<pre>
 public TTConnection(InetAddress address,
                     int port) throws IOException
</pre>
<dl>
  <dd> Creates a new connection to the specified ThoughtTreasure server.
<p>
  <dd><dl>
    <dt> <b>Parameters:</b>
    <dd> address - the IP address of the ThoughtTreasure server
    <dd> port - the port number of the ThoughtTreasure server
    <dt> <b>Throws:</b> IOException
    <dd> if an I/O error occurs when creating the socket
  </dl></dd>
</dl>
<a name="methods"></a>
<h2>
  <img src="images/methods.gif" width=151 height=38 alt="Methods">
</h2>
<a name="close()"><img src="images/red-ball.gif" width=12 height=12 alt=" o "></a>
<a name="close"><b>close</b></a>
<pre>
 public void close() throws IOException
</pre>
<dl>
  <dd> Closes the connection.
<p>
  <dd><dl>
    <dt> <b>Throws:</b> IOException
    <dd> if an I/O error occurs when closing the socket
  </dl></dd>
</dl>
<a name="ISA(java.lang.String, java.lang.String)"><img src="images/red-ball.gif" width=12 height=12 alt=" o "></a>
<a name="ISA"><b>ISA</b></a>
<pre>
 public boolean ISA(String classname,
                    String objname) throws IOException
</pre>
<dl>
  <dd> Tests whether the specified object is of the specified class.
<p>
  <dd><dl>
    <dt> <b>Parameters:</b>
    <dd> classname - the name of the class object
    <dd> objname - the name of the object
    <dt> <b>Throws:</b> IOException
    <dd> if an I/O error occurs communicating with the server
  </dl></dd>
</dl>
<a name="isPartOf(java.lang.String, java.lang.String)"><img src="images/red-ball.gif" width=12 height=12 alt=" o "></a>
<a name="isPartOf"><b>isPartOf</b></a>
<pre>
 public boolean isPartOf(String part,
                         String whole) throws IOException
</pre>
<dl>
  <dd> Tests whether the specified object is a part of another specified object.
<p>
  <dd><dl>
    <dt> <b>Parameters:</b>
    <dd> part - the name of the part object
    <dd> whole - the name of the whole object
    <dt> <b>Throws:</b> IOException
    <dd> if an I/O error occurs communicating with the server
  </dl></dd>
</dl>
<a name="parents(java.lang.String)"><img src="images/red-ball.gif" width=12 height=12 alt=" o "></a>
<a name="parents"><b>parents</b></a>
<pre>
 public Vector parents(String objname) throws IOException
</pre>
<dl>
  <dd> Returns the parents of the specified object.
<p>
  <dd><dl>
    <dt> <b>Parameters:</b>
    <dd> objname - the name of the object
    <dt> <b>Throws:</b> IOException
    <dd> if an I/O error occurs communicating with the server
  </dl></dd>
</dl>
<a name="children(java.lang.String)"><img src="images/red-ball.gif" width=12 height=12 alt=" o "></a>
<a name="children"><b>children</b></a>
<pre>
 public Vector children(String objname) throws IOException
</pre>
<dl>
  <dd> Returns the children of the specified object.
<p>
  <dd><dl>
    <dt> <b>Parameters:</b>
    <dd> objname - the name of the object
    <dt> <b>Throws:</b> IOException
    <dd> if an I/O error occurs communicating with the server
  </dl></dd>
</dl>
<a name="ancestors(java.lang.String)"><img src="images/red-ball.gif" width=12 height=12 alt=" o "></a>
<a name="ancestors"><b>ancestors</b></a>
<pre>
 public Vector ancestors(String objname) throws IOException
</pre>
<dl>
  <dd> Returns the ancestors of the specified object.
<p>
  <dd><dl>
    <dt> <b>Parameters:</b>
    <dd> objname - the name of the object
    <dt> <b>Throws:</b> IOException
    <dd> if an I/O error occurs communicating with the server
  </dl></dd>
</dl>
<a name="descendants(java.lang.String)"><img src="images/red-ball.gif" width=12 height=12 alt=" o "></a>
<a name="descendants"><b>descendants</b></a>
<pre>
 public Vector descendants(String objname) throws IOException
</pre>
<dl>
  <dd> Returns the descendants of the specified object.
<p>
  <dd><dl>
    <dt> <b>Parameters:</b>
    <dd> objname - the name of the object
    <dt> <b>Throws:</b> IOException
    <dd> if an I/O error occurs communicating with the server
  </dl></dd>
</dl>
<a name="retrieve(int, int, int, java.lang.String, java.lang.String)"><img src="images/red-ball.gif" width=12 height=12 alt=" o "></a>
<a name="retrieve"><b>retrieve</b></a>
<pre>
 public Vector retrieve(int picki,
                        int anci,
                        int desci,
                        String mode,
                        String ptn) throws IOException
</pre>
<dl>
  <dd> Retrieves assertions from the database matching the specified pattern.
 <p>
 Returns a Vector of Java Objects representing ThoughtTreasure assertions.
<p>
  <dd><dl>
    <dt> <b>Parameters:</b>
    <dd> picki - if not -1, the index of the object to be picked out
              of the result assertion
    <dd> anci - move up (mode="anc" or mode="ancdesc") the hierarchy on this
            index; should be -1 for mode not "anc" or "ancdesc"
    <dd> desci - move down (mode="desc" or "ancdesc") the hierarchy on this
              index; should be -1 for mode not "desc" or "ancdesc"
    <dd> mode - "exact" or "anc" or "desc" or "ancdesc"
    <dd> ptn - pattern such as "duration-of attend-play ?"
    <dt> <b>Throws:</b> IOException
    <dd> if an I/O error occurs communicating with the server
  </dl></dd>
</dl>
<a name="phraseToConcepts(java.lang.String, java.lang.String)"><img src="images/red-ball.gif" width=12 height=12 alt=" o "></a>
<a name="phraseToConcepts"><b>phraseToConcepts</b></a>
<pre>
 public Vector phraseToConcepts(String feat,
                                String phrase) throws IOException
</pre>
<dl>
  <dd> Returns the objects (atomic concepts) for the specified
 word or phrase (lexical entry) in the lexicon.
 <p>
 Returns a Vector of TTLexEntryToObj.
<p>
  <dd><dl>
    <dt> <b>Parameters:</b>
    <dd> feat - a String containing single-character ThoughtTreasure
             features such as <code>F_ENGLISH</code> or
             <code>F_FRENCH</code>. The feature codes are defined
             in the <code>TT</code> class.
    <dd> phrase - a ThoughtTreasure lexical entry
    <dt> <b>Throws:</b> IOException
    <dd> if an I/O error occurs communicating with the server
    <dt> <b>See Also:</b>
    <dd> <a href="com.signiform.tt.TTLexEntryToObj.html#_top_">TTLexEntryToObj</a>, <a href="com.signiform.tt.TT.html#_top_">TT</a>
  </dl></dd>
</dl>
<a name="conceptToLexEntries(java.lang.String)"><img src="images/red-ball.gif" width=12 height=12 alt=" o "></a>
<a name="conceptToLexEntries"><b>conceptToLexEntries</b></a>
<pre>
 public Vector conceptToLexEntries(String objname) throws IOException
</pre>
<dl>
  <dd> Returns the lexical entries associated with the specified object
 (atomic concept) in the lexicon.
 <p>
 Returns a Vector of TTLexEntryToObj.
<p>
  <dd><dl>
    <dt> <b>Parameters:</b>
    <dd> objname - the name of the object
    <dt> <b>Throws:</b> IOException
    <dd> if an I/O error occurs communicating with the server
    <dt> <b>See Also:</b>
    <dd> <a href="com.signiform.tt.TTLexEntryToObj.html#_top_">TTLexEntryToObj</a>
  </dl></dd>
</dl>
<a name="tag(java.lang.String, java.lang.String)"><img src="images/red-ball.gif" width=12 height=12 alt=" o "></a>
<a name="tag"><b>tag</b></a>
<pre>
 public Vector tag(String feat,
                   String text) throws IOException
</pre>
<dl>
  <dd> Performs part-of-speech (and other) tagging of the specified
 natural language text.
 <p>
 Returns a Vector of TTPNode.
<p>
  <dd><dl>
    <dt> <b>Parameters:</b>
    <dd> feat - a String containing single-character ThoughtTreasure
             features such as <code>F_ENGLISH</code> or
             <code>F_FRENCH</code>. The feature codes are defined
             in the <code>TT</code> class.
    <dd> text - natural language text
    <dt> <b>Throws:</b> IOException
    <dd> if an I/O error occurs communicating with the server
    <dt> <b>See Also:</b>
    <dd> <a href="com.signiform.tt.TTPNode.html#_top_">TTPNode</a>, <a href="com.signiform.tt.TT.html#_top_">TT</a>
  </dl></dd>
</dl>
<a name="syntacticParse(java.lang.String, java.lang.String)"><img src="images/red-ball.gif" width=12 height=12 alt=" o "></a>
<a name="syntacticParse"><b>syntacticParse</b></a>
<pre>
 public Vector syntacticParse(String feat,
                              String text) throws IOException
</pre>
<dl>
  <dd> Syntactically parses the specified natural language text.
 <p>
 Returns a Vector of Java Objects representing parse trees.
<p>
  <dd><dl>
    <dt> <b>Parameters:</b>
    <dd> feat - a String containing single-character ThoughtTreasure
             features such as <code>F_ENGLISH</code> or
             <code>F_FRENCH</code>. The feature codes are defined
             in the <code>TT</code> class.
    <dd> text - natural language text
    <dt> <b>Throws:</b> IOException
    <dd> if an I/O error occurs communicating with the server
    <dt> <b>See Also:</b>
    <dd> <a href="com.signiform.tt.TT.html#_top_">TT</a>
  </dl></dd>
</dl>
<a name="semanticParse(java.lang.String, java.lang.String)"><img src="images/red-ball.gif" width=12 height=12 alt=" o "></a>
<a name="semanticParse"><b>semanticParse</b></a>
<pre>
 public Vector semanticParse(String feat,
                             String text) throws IOException
</pre>
<dl>
  <dd> Semantically parses the specified natural language text.
 <p>
 Returns a Vector of Java Objects representing ThoughtTreasure assertions
 and parse trees.
<p>
  <dd><dl>
    <dt> <b>Parameters:</b>
    <dd> feat - a String containing single-character ThoughtTreasure
             features such as <code>F_ENGLISH</code> or
             <code>F_FRENCH</code>. The feature codes are defined
             in the <code>TT</code> class.
    <dd> text - natural language text
    <dt> <b>Throws:</b> IOException
    <dd> if an I/O error occurs communicating with the server
    <dt> <b>See Also:</b>
    <dd> <a href="com.signiform.tt.TT.html#_top_">TT</a>
  </dl></dd>
</dl>
<a name="generate(java.lang.String, java.lang.Object)"><img src="images/red-ball.gif" width=12 height=12 alt=" o "></a>
<a name="generate"><b>generate</b></a>
<pre>
 public String generate(String feat,
                        Object obj) throws IOException
</pre>
<dl>
  <dd> Generates the specified ThoughtTreasure assertion in natural language.
<p>
  <dd><dl>
    <dt> <b>Parameters:</b>
    <dd> feat - a String containing single-character ThoughtTreasure
             features such as <code>F_ENGLISH</code> or
             <code>F_FRENCH</code>. The feature codes are defined
             in the <code>TT</code> class.
    <dd> obj - Java Object representing a ThoughtTreasure assertion
    <dt> <b>Throws:</b> IOException
    <dd> if an I/O error occurs communicating with the server
    <dt> <b>See Also:</b>
    <dd> <a href="com.signiform.tt.TT.html#_top_">TT</a>
  </dl></dd>
</dl>
<a name="chatterbot(java.lang.String, java.lang.String)"><img src="images/red-ball.gif" width=12 height=12 alt=" o "></a>
<a name="chatterbot"><b>chatterbot</b></a>
<pre>
 public String chatterbot(String feat,
                          String text) throws IOException
</pre>
<dl>
  <dd> Sends natural language input text to the chatterbot and returns the
 natural language response.
<p>
  <dd><dl>
    <dt> <b>Parameters:</b>
    <dd> feat - a String containing single-character ThoughtTreasure
             features such as <code>F_ENGLISH</code> or
             <code>F_FRENCH</code>. The feature codes are defined
             in the <code>TT</code> class.
    <dd> text - natural language input text
    <dt> <b>Throws:</b> IOException
    <dd> if an I/O error occurs communicating with the server
    <dt> <b>See Also:</b>
    <dd> <a href="com.signiform.tt.TT.html#_top_">TT</a>
  </dl></dd>
</dl>
<a name="clearContext()"><img src="images/red-ball.gif" width=12 height=12 alt=" o "></a>
<a name="clearContext"><b>clearContext</b></a>
<pre>
 public boolean clearContext()
</pre>
<dl>
  <dd> Clears the discourse context.
 <p>
 If this does not seem to be working, remember that results are
 cached unless <code>USECACHE</code> is set to <code>false</code>.
<p>
  <dd><dl>
    <dt> <b>See Also:</b>
    <dd> <a href="#USECACHE">USECACHE</a>
  </dl></dd>
</dl>
<a name="status()"><img src="images/red-ball.gif" width=12 height=12 alt=" o "></a>
<a name="status"><b>status</b></a>
<pre>
 public String status()
</pre>
<dl>
  <dd> Returns the status of the ThoughtTreasure server: "up" or "down".
<p>
</dl>
<a name="bringdown()"><img src="images/red-ball.gif" width=12 height=12 alt=" o "></a>
<a name="bringdown"><b>bringdown</b></a>
<pre>
 public void bringdown()
</pre>
<dl>
  <dd> Forces ThoughtTreasure to break out of the server select loop,
 so that it can process further ThoughtTreasure shell commands.
 <p>
 If you would like ThoughtTreasure to exit in this situation,
 start ThoughtTreasure with a script:
 <pre>
 tt -f server.tt
 </pre>
 where <code>server.tt</code> contains:
 <pre>
 server
 quit
 </pre>
<p>
</dl>
<a name="clearCache()"><img src="images/red-ball.gif" width=12 height=12 alt=" o "></a>
<a name="clearCache"><b>clearCache</b></a>
<pre>
 public void clearCache()
</pre>
<dl>
  <dd> Clears the cache.
<p>
</dl>
<hr>
<pre>
<a href="packages.html">All Packages</a>  <a href="tree.html">Class Hierarchy</a>  <a href="Package-com.signiform.tt.html">This Package</a>  <a href="Package-com.signiform.tt.html">Previous</a>  <a href="Package-com.signiform.tt.html">Next</a>  <a href="AllNames.html">Index</a></pre>
</body>
</html>
