/* repcxt.c */
void ContextInit(void);
Context *ContextCreate(Ts *ts, TenseStep tensestep, Discourse *dc, Context *next);
Context *ContextSprout(Context *parent, Obj *sproutcon, PNode *sproutpn, Context *next);
Bool ContextIsAncestor(Context *anc, Context *des);
Context *ContextLast(Context *cx);
Context *ContextAppendDestructive(Context *cx1, Context *cx2);
void ContextPrintName(FILE *stream, Context *cx);
void ContextNameToString(Context *cx, char *out);
void ContextPrintAllNames(FILE *stream, Context *cxs);
char *ContextModeString(int mode);
void ContextPrintReasons(FILE *stream, Context *cx);
void ContextPrint(FILE *stream, Context *cx);
void ContextPrintAll(FILE *stream, Context *cxs);
void ContextFree(Context *cx);
void ContextSetSense(Context *cx, Float val);
void ContextSetRelevance(Context *cx, Float val);
void ContextSetNovelty(Context *cx, Float val);
void ContextRSNReset(Context *cx);
void ContextSenseReset(Context *cx);
void ContextRSNPrint(FILE *stream, Context *cx);
void ContextSetRSN(Context *cx, Float relevance, Float sense, Float novelty);
void ContextAddMakeSenseReason(Context *cx, Obj *obj);
void ContextAddMakeSenseReasons(Context *cx, ObjList *objs);
void ContextAddNotMakeSenseReason(Context *cx, Obj *obj);
void ContextAddNotMakeSenseReasons(Context *cx, ObjList *objs);
void ContextSetJustifiedSenses(Context *cx, Float sense, ObjList *justifications);
void ContextSetJustifiedSense(Context *cx, Float sense, Obj *justification);
void ContextClearSpin(Context *cx);
Context *ContextFindBest(Context *cxs, Context *exclude1, Context *exclude2);
Context *ContextPrune3(Context *cxs);
Context *ContextPrune(Context *cxs);
void ContextFreeAll(Context *cxs);
void ContextInitiateHandlers(Context *cx, Obj *actor);
Actor *ContextActorFind(Context *cx, Obj *actor, int create_ok);
void ContextOnAssert(TsRange *tsrange, Obj *assertion);
ObjList *ContextFindMatchingSubgoals(Context *cx, Obj *subgoal_obj);
Subgoal *ContextFindSubgoal(Context *cx, Obj *subgoal_obj);
Obj *ContextSupergoal(Context *cx, Obj *subgoal_obj);
ObjList *ContextSubgoals(Context *cx, Obj *subgoal_obj);
ObjList *ContextGetObjectRels(TsRange *tsr, Obj *scriptprop, Obj *obj);
void ContextRepairChildAssertions(Context *cx_parent, Context *cx_child);
ObjList *ContextFindGrids(Context *cx);
ObjList *ContextFindObjects(Context *cx, Obj *class);
Bool ContextIsObjectFound(Context *cx, Obj *class);
void ContextAntecedentDecayAllCh(Context *cx);
void ContextAntecedentDecayOneCh(Context *cx);
void ContextAntecedentRefreshAllCh(Context *cx, Obj *obj, PNode *pn, PNode *pn_top, int gender, int number, int person);
Bool ContextIsAntecedent(Obj *obj, Context *cx);
void ContextAntecedentRefreshOneCh(Context *cx, Obj *obj, PNode *pn, PNode *pn_top, int gender, int number, int person);
void ContextHighestTs(Context *cx, /* OUTPUT */ Ts *ts);
