/* repgrid.c */
void GridInit(void);
Grid *GridCreate(Obj *grid, GridCoord rows, GridCoord cols, int fill);
void GridFree(Grid *gr);
Grid *GridCopy(Grid *gr);
Grid *GridBlankCopy(Grid *gr);
void GridPrint(FILE *stream, char *type, Grid *gr, int longformat);
Bool GridAdjacentCell(GridCoord r1, GridCoord c1, GridCoord r2, GridCoord c2);
Bool GridAdjacentIsEmpty(Grid *gr, GridCoord row, GridCoord col, char *wallchars);
void GridRowColDist(Obj *grid, Float *rowdist, Float *coldist);
Float GridDistance1(Float rowdist, Float coldist, GridCoord row1, GridCoord col1, GridCoord row2, GridCoord col2);
Float GridDistance(Obj *grid, GridCoord row1, GridCoord col1, GridCoord row2, GridCoord col2);
GridSubspace *GridSubspaceCreate(int maxlen, Grid *grid);
GridSubspace *GridSubspaceCopyShared(GridSubspace *old_gs);
void GridSubspaceAdd(GridSubspace *gs, GridCoord row, GridCoord col);
void GridSubspaceAddGrid(GridSubspace *gs, Grid *gr);
void GridSubspaceFree(GridSubspace *gs);
Bool GridSubspaceIn(GridSubspace *gs, GridCoord row, GridCoord col);
Bool GridSubspaceAdjacentIn(GridSubspace *gs, GridCoord row, GridCoord col);
GridSubspace *GridSubspaceGetVar(Grid *gr, int var, int onlyone);
Float GridSubspacePathDist(GridSubspace *gs);
void GridSubspacePrint(FILE *stream, Ts *ts, GridSubspace *gs, int longformat);
void GridSubspaceSocketPrint(Socket *skt, GridSubspace *gs);
void GridSubspaceTextPrint(Text *text, GridSubspace *gs);
IntergridPath *IntergridPathCreate(int len);
void IntergridPathAddNext(IntergridPath *igp, Obj *grid, Obj *wormhole);
void IntergridPathFree(IntergridPath *igp);
IntergridPath *IntergridFindPath1(Ts *ts, TsRange *tsr, Obj *gr1, Obj *gr2, Obj *grvia, int maxdepth);
IntergridPath *IntergridFindPath(Ts *ts, TsRange *tsr, Obj *gr1, Obj *gr2);
Grid *GridParse(Obj *grid, char *s, int sep);
Grid *GridRead(FILE *stream, Obj *grid);
void GridReadVariables(FILE *stream, Grid *gr);
void GridReadVariable(char *line, int required, Grid *gr, FILE *stream);
void GridFill(Grid *srcgr, Grid *destgr, char *wallchars);
void GridSubspaceFill(Grid *srcgr, GridSubspace *destgs, char *wallchars);
int GridFindPathMidpoint(Grid *srcgr, GridCoord fromrow, GridCoord fromcol, GridCoord torow, GridCoord tocol, char *wallchars, GridCoord *midrow, GridCoord *midcol);
GridSubspace *GridFindLinearPath(Grid *gr, GridCoord fromrow, GridCoord fromcol, GridCoord torow, GridCoord tocol, char *wallchars);
GridSubspace *GridFindPath1(Grid *gr, GridCoord fromrow, GridCoord fromcol, GridCoord torow, GridCoord tocol, char *wallchars);
GridSubspace *GridFindPath(Grid *gr, GridCoord fromrow, GridCoord fromcol, GridCoord torow, GridCoord tocol, char *wallchars);
void GridSubspaceSimplify(GridSubspace *gs);
void GridSetSubspace(Grid *to, GridSubspace *from, int fillchar);
int GridPlopdownText1(Grid *to, char *text, int len, GridCoord row, GridCoord col, int mustbeempty);
void GridPlopdownText(Grid *to, char *text, GridCoord row, GridCoord col);
Bool GridFindAccessibleBorder(GridSubspace *gs, Grid *gr, GridCoord *rowp, GridCoord *colp);
Grid *GridBuild(Ts *ts, Grid *gr, int namestr, int fillchar, Obj *prop);
Grid *GridStateGet(Ts *ts, Obj *gridobj, Obj *prop);
Bool GridObjAtRowCol(Obj *grid, GridCoord row, GridCoord col);
