/* repprove.c */
ProofReason *ProofReasonCreate(Proof *proof, ProofReason *next);
ProofReason *ProofReasonLast(ProofReason *reasons);
ProofReason *ProofReasonAppend(ProofReason *pr1, ProofReason *pr2);
ProofReason *ProofReasonCopyAll(ProofReason *pr);
void ProofReasonFree(ProofReason *pr);
Proof *ProofCreate(Obj *fact, Bd *bd, Obj *rule, ProofReason *reasons, Proof *next);
Proof *ProofCopyHead(Proof *p);
void ProofFree(Proof *p);
Proof *ProofAddLevel(Obj *fact, Obj *rule, Proof *proof, Proof *r);
void ProofPrintAll1(FILE *stream, Proof *p, int top);
void ProofReasonPrintAll(FILE *stream, ProofReason *pr);
void ProofPrint(FILE *stream, Proof *p);
void ProofPrintAll(FILE *stream, Proof *p);
Proof *ProofAppendEach(Proof *head, Proof *tails, Proof *r);
Bool ProveAnd(Ts *ts, TsRange *tsr, Obj *goal, ObjList *rules, ObjList *more, Bool querydb, Proof **out_pr);
Bool ProveOr(Ts *ts, TsRange *tsr, Obj *goal, ObjList *rules, ObjList *more, Bool querydb, Proof **out_pr);
Bool ProveNot(Ts *ts, TsRange *tsr, Obj *goal, ObjList *rules, ObjList *more, Bool querydb, Proof **out_pr);
Bool ProveFact(Ts *ts, TsRange *tsr, Obj *goal, ObjList *rules, ObjList *more, Bool querydb, Proof **out_pr);
Bool Prove1(Ts *ts, TsRange *tsr, Obj *goal, ObjList *rules, ObjList *more, Bool querydb, Proof **out_pr);
Bool Prove(Ts *ts, TsRange *tsr, Obj *goal, ObjList *more, Bool querydb, Proof **out_pr);
ObjList *ProveRetrieve(Ts *ts, TsRange *tsr, Obj *ptn, Bool freeptn);
void ProverTool(void);
void InferenceInit(void);
Bool InferenceAdd(Obj *obj);
ObjList *InferenceRun1(Ts *ts, TsRange *tsr, Obj *obj, ObjList *inferences, ObjList *more, Bool querydb);
ObjList *InferenceRunInferenceRules(Ts *ts, TsRange *tsr, Obj *obj, ObjList *more, Bool querydb);
ObjList *InferenceRunActivationRules(Ts *ts, TsRange *tsr, Obj *obj, ObjList *more, Bool querydb);
