/* repspace.c */
Bool CoordParse(char *text, Float *lat, Float *lng);
Float CoordPlanetDistance(Float lat1, Float long1, Float lat2, Float long2, Float radius);
Float CoordEarthDistance(Float lat1, Float long1, Float lat2, Float long2);
Float CoordEuclideanDistance(Float x0, Float y0, Float x1, Float y1);
Float CoordEuclideanDistance3(Float x0, Float y0, Float z0, Float x1, Float y1, Float z1);
Float CoordDistance(Obj *coord1, Obj *coord2);
Obj *PolityToSuperpolity(Ts *ts, TsRange *tsr, Obj *polity, Obj *class);
Bool PolityContained(Ts *ts, TsRange *tsr, Obj *polity, Obj *enclosing_polity);
Obj *PolityCoord(Ts *ts, TsRange *tsr, Obj *polity);
Float PolityDistance(Ts *ts, TsRange *tsr, Obj *polity1, Obj *polity2);
Float SpaceDistance2(Ts *ts, TsRange *tsr, Obj *polity1, Obj *grid1, GridCoord row1, GridCoord col1, Obj *polity2, Obj *grid2, GridCoord row2, GridCoord col2);
Float SpaceDistance1(Ts *ts, TsRange *tsr, Obj *polity1, Obj *grid1, GridCoord row1, GridCoord col1, Obj *obj2);
Float SpaceDistance(Ts *ts, TsRange *tsr, Obj *obj1, Obj *obj2);
void SpaceAtGridGet(Obj *ga, Obj **polityp, Obj **gridp, GridCoord *rowp, GridCoord *colp);
Obj *SpaceGridToPolity(Ts *ts, TsRange *tsr, Obj *grid);
Obj *SpaceGridToPolityClass(Ts *ts, TsRange *tsr, Obj *grid, Obj *polity_class);
Bool SpaceGridInPolity(Ts *ts, TsRange *tsr, Obj *grid, Obj *polity);
Bool SpaceInPolity(Ts *ts, TsRange *tsr, Obj *obj, Obj *polity, TsRange *tsr_r);
Obj *SpaceFindEncloseMake(TsRange *ga_tsr, Obj *physobj, Obj *loc);
ObjList *SpaceFindEncloseObject(Ts *ts, TsRange *tsr, TsRange *ga_tsr, Obj *physobj, Obj *enclose_class, Obj *encl_grid, GridCoord encl_row, GridCoord encl_col, Obj *enclose_restriction, ObjList *r);
ObjList *SpaceFindEnclosePolity(Ts *ts, TsRange *tsr, TsRange *ga_tsr, Obj *physobj, Obj *polity_class, Obj *grid, Obj *enclose_restriction, ObjList *r);
ObjList *SpaceFindEnclose1(Ts *ts, TsRange *tsr, TsRange *ga_tsr, Obj *physobj, Obj *encl_grid, GridCoord encl_row, GridCoord encl_col, Obj *enclose_restriction, ObjList *r);
ObjList *SpaceFindEnclose(Ts *ts, TsRange *tsr, Obj *physobj, Obj *enclose_restriction, ObjList *r);
Bool SpaceEncloses(Ts *ts, TsRange *tsr, Obj *encloser, Obj *enclosed, TsRange *tsr_r);
ObjList *SpaceLocateObject1(Ts *ts, TsRange *tsr, Obj *obj, Obj *gridprefer, int desc_ok);
Bool SpaceFindResidence(Ts *ts, TsRange *tsr, Obj *human, Obj **residence, Obj **polityp, Obj **gridp, GridCoord *rowp, GridCoord *colp);
Bool SpaceLocateHuman(Ts *ts, TsRange *tsr, Obj *human, Obj **residence, Obj **polityp, Obj **gridp, GridCoord *rowp, GridCoord *colp);
Bool SpaceLocateObject(Ts *ts, TsRange *tsr, Obj *obj, Obj *gridprefer, int desc_ok, Obj **polityp, Obj **gridp, GridCoord *rowp, GridCoord *colp);
Bool SpaceObjectIsLocated(Ts *ts, TsRange *tsr, Obj *obj);
Obj *SpaceCountryOfObject(Ts *ts, TsRange *tsr, Obj *obj);
ObjList *SpaceFindAll(Ts *ts, TsRange *tsr, Obj *desired);
ObjList *SpaceGetAllInGrid(Ts *ts, TsRange *tsr, Obj *grid);
ObjList *SpaceFindWithinRadiusOwned1(Ts *ts, TsRange *tsr, Obj *desired, Obj *nearx, Float radius, Obj *owner);
ObjList *SpaceFindWithinRadiusOwned(Ts *ts, TsRange *tsr, Obj *desired, Obj *nearx, Float radius, Obj *owner);
Obj *SpaceFindNearestOwnedInPolity(Ts *ts, TsRange *tsr, Obj *desired, Obj *nearx, Obj *owner, Obj *polity);
Obj *SpaceFindNearestOwned(Ts *ts, TsRange *tsr, Obj *desired, Obj *nearx, Obj *owner);
Obj *SpaceFindNearest(Ts *ts, TsRange *tsr, Obj *desired, Obj *nearx);
Obj *SpaceFindNearestOwnedIfPossible(Ts *ts, TsRange *tsr, Obj *desired, Obj *nearx, Obj *owner);
Obj *SpaceFindNearestInGrid(Ts *ts, TsRange *tsr, Obj *not_equal, Obj *grid, GridCoord row1, GridCoord col1);
ObjList *SpaceFindNearby1(Ts *ts, TsRange *tsr, Obj *desired, Obj *nearx, Obj *owner);
ObjList *SpaceFindNearby(Ts *ts, TsRange *tsr, Obj *desired, Obj *nearx);
ObjList *SpaceFindNear(Ts *ts, TsRange *tsr, Obj *physobj, Obj *restrict, ObjList *r);
ObjList *SpaceFindNearAudible(Ts *ts, TsRange *tsr, Obj *desired, Obj *nearx);
Bool SpaceLocatedAt(Ts *ts, TsRange *tsr, Obj *obj, Obj *location, TsRange *tsr_r);
Bool SpaceIsNearAudible(Ts *ts, TsRange *tsr, Obj *obj1, Obj *obj2);
Bool SpaceGridIsNearReachable(Obj *grid, GridCoord row1, GridCoord col1, GridCoord row2, GridCoord col2);
Bool SpaceIsNearReachable(Ts *ts, TsRange *tsr, Obj *obj1, Obj *obj2);
Bool SpaceNGIn(Obj *obj1, Obj *obj2);
Bool SpaceNGAdd(Obj *obj1, Obj *obj2);
Bool SpaceIsNearGraspable1(Ts *ts, Obj *obj1, Obj *obj2);
Bool SpaceIsNearGraspable(Ts *ts, Obj *obj1, Obj *obj2);
