/* repstr.c */
char *StringIth(char *s, int i);
void StringInit(void);
char *StringCopy(char *s, char *typ);
void StringCpy(char *dest, char *src, int maxlen);
void StringCat(char *dest, char *src, int maxlen);
void StringReverse(char *in, char *out);
char *StringCopyLen(char *s, int len, char *typ);
char *StringCopyLenLong(char *s, size_t len, char *typ);
Bool StringHeadEqual(char *s1, char *s2);
Bool StringHeadEqualAdvance(char *s1, char *s2, char **nextp);
Bool StringReadUntilString(char *in, char *stopstring, int maxlen, char *out, char **nextp);
Bool StringLocate(char *in, char *stopstring,
                  /* RESULTS */ char **start, char **after);
Bool StringLocateFollowedByDigit(char *in, char *stopstring,
                                 /* RESULTS */ char **start, char **after);
Bool StringIn(register char c, register char *s);
int StringCountOccurrences(char *s, int c);
Bool StringInWithin(register char c, register int within, register char *s);
Bool StringLineIsAll(char *s, char *set, char **next_line);
Bool StringAnyIn(char *s1, char *s2);
Bool StringAllIn(char *s1, char *s2);
Bool StringAllEqual(char *s, char c);
char *StringNthTail(char *s, int n);
Bool StringTailEq(char *s, char *tail);
Bool StringTailEqual(char *s, char *tail, char *stem);
char *StringReadTo(char *in, char *out, int maxlen, int sep1, int sep2, int sep3);
Bool StringReadToRequireTerm(char *in, int sep1, int sep2, int maxlen, char *out, char **nextp);
char *StringReadTo1(char *in, char *out, int maxlen, int sep, int *sep_found);
char *StringReadTos(char *in, int including, char *out, int maxlen, char *seps);
char *StringReadWord(char *in, int word_len, char *word);
char *StringReadToNons(char *in, int including, char *out, int maxlen, char *seps);
char *StringSkipParenthetical(char *s);
Bool StringSkipChar(char *s, int c, char **nextp);
char *StringSkipTo(char *in, int sep1, int sep2, int sep3);
Bool StringSkipToAcrossNewlines(char *in, int c, int maxnewlines, char **nextp);
char *StringSkipTos(char *in, char *seps);
char *StringSkipToNons(char *in, char *seps);
char *StringSkipWhitespaceNonNewline(char *in);
char *StringSkipWhitespace(char *in);
char *StringSkipspace(char *in);
Bool StringIsCharInLine(char *s, int c);
void StringAppendDots(char *s1, char *s2, int maxlen);
void StringAppendLen(char *s1, char *s2, int len);
void StringAppendChar(char *r, int maxlen, int c);
void StringPrependChar(char *r, int maxlen, int c);
int StringLastChar(char *s);
char *StringEndOf(char *s);
void StringCopyExcept(char *in, int except, int maxlen, char *out);
void StringCopyExcept2(char *in, int except1, int except2, int maxlen, char *out);
void StringElimChar(char *to, int c);
void StringElims(char *to, char *set, int *mods);
void StringElimNonAlphanumeric(char *to);
Float StringPercentAlpha(char *s);
void StringMapChar(char *to, int from_c, int to_c);
void StringMap(char *to, char *from_map, char *to_map);
void StringMapLeWhitespaceToSpace(char *to);
void StringMapLeWhitespaceToDash(char *to);
void StringElimTrailingBlanks(char *s);
void StringElimLeadingBlanks(char *s);
void StringAppendIfNotAlreadyIns(char *in, int maxlen, char *out);
void StringAppendIfNotAlreadyIn(int in, int maxlen, char *out);
void StringIntersect(char *in1, char *in2, char *out);
char *StringReadFile(char *fn, int useroot);
char *StringReadUntil(FILE *stream, char *term);
void StringSearchReplace(char *s, char *from, char *to);
void StringToLowerNoAccentsDest(char *s);
void StringISO_8859_1ToMacDestructive(char *s);
void StringToLowerNoAccents(char *in, int maxlen, char *out);
void StringDevoice(char *s);
void StringReduceTotal(char *out);
void StringReduce6(char *out);
void StringReduce5(char *out);
void StringReduce4(char *out);
void StringReduce3(char *out);
void StringReduce2(char *out);
void StringReduce1(char *out);
void StringElimPunctDest(char *to);
void StringElimDupDest(char *to);
void StringReduceConsonDest(char *to);
void StringReduceVowelDest(char *s);
void StringToLowerDestructive(char *s);
void StringToLower(char *in, int maxlen, char *out);
void StringToUpper(char *in, int maxlen, char *out);
void StringToUpperDestructive(char *out);
Bool StringIsRomanNumeral(char *s);
Bool StringIsAllUpper(char *s);
void StringAllUpperToUL(char *s);
void StringAllUpperToLower(char *s);
Bool CharPhoneMatch(int ptn, int c);
Bool StringPhoneMatch(char *ptn, char *s, char *digits, char **nextp);
Bool StringMatch_ModuloSpaces(char *ptn, char *s, int entireline, char **nextp);
void StringPrintLen(FILE *stream, char *s, int len);
void StringGenSym(char *result, int maxlen, char *prefix1, char *prefix2);
Bool StringIsDigits(char *s);
Bool StringIsAlphaOr(char *s, char *set);
Bool StringIsDigitOr(char *s, char *set);
Bool StringIsDigitOrUpper(char *s);
Bool StringIsNumber(char *s);
char *StringSkipWhitespace_LeNonwhite(char *in);
char *StringReadWhitespace_LeNonwhite(char *out, char *in, int maxlen);
void StringElimDupWhitespaceDest(char *to);
Bool StringGetWord(char *out, char *in, int maxlen, char **nextp);
Bool StringGetWord_LeNonwhite(char *out, char *in, int maxlen, char **nextp, char *trail_punc);
Bool StringGetNWords_LeNonwhite(char *out, char *trail_punc, char *in, int maxlen, int n, char **nextp);
Bool StringGetLeNonwhite(char *out, char *in, int maxlen);
Bool StringGetNWords_LeN_Back(char *output, char *in, char *in_base, int maxlen, int n, char **nextp);
Bool StringGetDigits(char *out, char *in, int maxlen, char **nextp);
Bool StringGetDigitsOrSpace(char *out, char *in, int maxlen, char **nextp);
int StringFirstLoc(char c, char *s);
int StringTab(int pos, int tabsize);
int french_strcmp(const char *s, const char *t);
int negative_strcmp(const char *s, const char *t);
int inverse_strcmp(const char *s, const char *t);
Bool StringIsPalindrome(char *s);
void StringAnagramUniquify(char *in, int maxlen, char *out);
void StringPrintJustify(FILE *stream, char *s, int len, int just);
void StringMakeCorpusLine(char *text, long offset, int halflinelen, int wordlen, char *buf);
StringArray *StringArrayCreate(void);
void StringArrayFree(StringArray *sa);
void StringArrayFreeCopy(StringArray *sa);
void StringArrayAdd(StringArray *sa, char *s, int elimdup);
void StringArrayAddCopy(StringArray *sa, char *s, int elimdup);
int StringArrayComparStrcmp(const void *s1, const void *s2);
char *StringSkipHTML(char *s);
int StringArrayHTMLComparStrcmp(const void *s1, const void *s2);
int StringArrayComparNegativeStrcmp(const void *s1, const void *s2);
int StringArrayComparInverseStrcmp(const void *s1, const void *s2);
void StringArraySort1(StringArray *sa, int (*compar)(const void *, const void *));
void StringArraySort(StringArray *sa);
void StringArrayHTMLSort(StringArray *sa);
void StringArraySortCol(StringArray *sa, int col);
void StringArrayNegativeSort(StringArray *sa);
void StringArrayInverseSort(StringArray *sa);
void StringArrayPrint(FILE *stream, StringArray *sa, int elimdup, int showcount);
void StringArrayTextPrintList(Text *text, StringArray *sa, int use_serial_comma, int post, char *and_string);
StringArray *StringArrayStripOutColumn(char *in, char *stop_before, int startpos, int stoppos, int tabsize);
