/* reptime.c */
char *DayName(Day day);
Day DayParse(char *s);
Bool DaysIn(Day day, Days days);
Days DaysParse(char *s);
void DaysPrint(FILE *stream, Days days);
Tod TodParse(char *s);
void TodPrint(FILE *stream, Tod tod);
void TodSocketPrint(Socket *skt, Tod tod);
void TodTextPrint(Text *text, Tod tod);
void TodToString(Tod tod, int maxlen, char *r);
void TodToHMS(Tod tod, int *hour, int *min, int *sec);
Bool IsDurStem(char *s);
Dur DurParse(char *s, char *stem);
Dur DurParseA(char *s);
void DurPrint(FILE *stream, Dur dur);
void DurSocketPrint(Socket *skt, Dur dur);
void DurTextPrint(Text *text, Dur dur);
void DurToString(Dur dur, int maxlen, char *r);
void TsInit(void);
Tod TsToTod(Ts *ts);
Day TsToDay(Ts *ts);
Float TsToFloat(Ts *ts);
Ts *UnixTsToTs(time_t unixts);
time_t YMDHMSToUnixTs(int year, int month, int day, int hour, int min, int sec);
void YMDHMSToTs(int year, int month, int day, int hour, int min, int sec, Ts *ts);
void YearToTs(int year, Ts *ts);
void YMDHMSToTsComm(int day_of_the_week, int year, int month, int day, int hour, int min, int sec, Ts *ts);
void TsToStringDate(Ts *ts, int show_nonspecific, int maxlen, char *out);
void TsToYMDHMS(Ts *ts, int *year, int *month, int *day, int *hour, int *min, int *sec);
Bool TsGT(Ts *ts1, Ts *ts2);
Bool TsGT1(Ts *ts1, Ts *ts2);
Bool TsGT2(Ts *ts1, Ts *ts2);
Bool TsGE(Ts *ts1, Ts *ts2);
Bool TsGE1(Ts *ts1, Ts *ts2);
Bool TsLE(Ts *ts1, Ts *ts2);
Bool TsLE1(Ts *ts1, Ts *ts2);
Bool TsLT(Ts *ts1, Ts *ts2);
Bool TsLT1(Ts *ts1, Ts *ts2);
Bool TsEQ(Ts *ts1, Ts *ts2);
Bool TsEQ1(Ts *ts1, Ts *ts2);
Bool TsNE(Ts *ts1, Ts *ts2);
Bool TsNE1(Ts *ts1, Ts *ts2);
void TsSetUnixTs(Ts *ts, time_t unixts);
void TsSetNow(Ts *ts);
void TsSetNa(Ts *ts);
void TsSetNaCx(Ts *ts, Context *cx);
void TsSetNegInf(Ts *ts);
void TsSetPosInf(Ts *ts);
void TsSetTod(Tod tod, Ts *ts);
void TsSetDur(Dur dur, Ts *ts);
void TsSetApprox(Ts *ts);
void TsIncrement(Ts *ts, Dur dur);
void TsDecrement(Ts *ts, Dur dur);
void TsPlus(Ts *ts_in, Dur dur, Ts *ts_out);
void TsMidnight(Ts *ints, Ts *outts);
Bool TsIsNa(Ts *ts);
Bool TsIsTod(Ts *ts);
Bool TsIsDur(Ts *ts);
Bool TsNonNa(Ts *ts);
Bool TsIsSpecific(Ts *ts);
Dur TsGetDur(Ts *ts);
Tod TsGetTod(Ts *ts);
Dur TsMinus(Ts *ts1, Ts *ts2);
Dur TsSpread(Ts *ts1, Ts *ts2, Ts *ts3, Ts *ts4, Ts *ts5);
Float TsFloatMinus(Ts *ts1, Ts *ts2);
Float TsFloatSpread(Ts *ts1, Ts *ts2, Ts *ts3, Ts *ts4, Ts *ts5);
Bool TsIsSpecification(Ts *specific, Ts *general);
Bool TsSameDay(Ts *ts1, Ts *ts2);
Dur TsDaysBetween(Ts *ts1, Ts *ts2);
Bool LooksLikeTs(char *s);
Bool TsParse(Ts *ts, char *s);
void TsPrint1(FILE *stream, Ts *ts, Context *cx);
void TsSocketPrint(Socket *skt, Ts *ts);
void TsTextPrint(Text *text, Ts *ts);
void TsPrint(FILE *stream, Ts *ts);
void TsToString(Ts *ts, int show_nonspecific, int maxlen, char *out);
void pts(Ts *ts);
void TsRangeInit(void);
TsRange *TsRangeCreate(Ts *startts, Ts *stopts, Days days, Tod tod, Dur dur);
TsRange *TsRangeCopy(TsRange *tsr);
Bool TsRangeIsAlways(TsRange *tsr);
Bool TsRangeIsAlwaysIgnoreCx(TsRange *tsr);
Bool TsRangeIsNa(TsRange *tsr);
Bool TsRangeIsNaIgnoreCx(TsRange *tsr);
Bool TsRangeIsOK(TsRange *tsr);
Bool TsRangeIsNonNa(TsRange *tsr);
Bool TsRangeIsSpecific(TsRange *tsr);
Bool TsRangeValid(TsRange *tsr);
Dur TsRangeDur(TsRange *tsr);
void TsRangeSetAlways(TsRange *tsr);
void TsRangeSetNow(TsRange *tsr);
void TsRangeSetContext(TsRange *tsr, Context *cx);
void TsRangeSetNever(TsRange *tsr);
void TsRangeSetNa(TsRange *tsr);
void TsRangeSetTs(TsRange *tsr, Ts *ts);
void TsRangeSetTodRange(Tod starttod, Tod stoptod, TsRange *tsr);
void TsRangeSetDurRange(Dur startdur, Dur stopdur, TsRange *tsr);
void TsRangeDefault(TsRange *in, TsRange *def, TsRange *out);
void TsMakeRange(TsRange *r, Ts *startts, Ts *stopts);
void TsMakeRangeInf(TsRange *r, Ts *ts);
void TsMakeRangeAlways(TsRange *r, Ts *ts);
void TsMakeRangeAction(TsRange *r, Ts *ts, Dur dur);
void TsMakeRangeState(TsRange *r, Ts *ts, Dur dur);
void TsRangeIncrement(TsRange *tsr, Dur dur);
void TsRangeQueryStartTs(TsRange *tsr, Ts *queryts, Ts *ts);
void TsRangeQueryStopTs(TsRange *tsr, Ts *queryts, Ts *ts);
void TsRangeLast24Hours(Ts *ts, TsRange *tsr);
Bool TsRangeEqual(TsRange *tsr1, TsRange *tsr2);
Bool TsRangeMatch(Ts *ts, TsRange *tsrange);
Bool TsRangeOverlaps(TsRange *tsr1, TsRange *tsr2);
Bool TsRangeIsContained(TsRange *tsr1, TsRange *tsr2);
Bool TsRangeIsSpecification(TsRange *specific, TsRange *general);
Bool TsRangeTsIsContained(TsRange *tsr, Ts *ts);
Bool TsRangeIsProperContained(TsRange *tsr1, TsRange *tsr2);
Bool TsRangeTsIsProperContained(TsRange *tsr, Ts *ts);
Bool TsRangeGT(TsRange *tsr1, TsRange *tsr2);
Bool TsRangeLT(TsRange *tsr1, TsRange *tsr2);
int TsRangeParse(TsRange *tsr, char *s);
void TsRangePrint(FILE *stream, TsRange *tsr);
void TsRangeSocketPrint(Socket *skt, TsRange *tsr);
void TsRangeTextPrint(Text *text, TsRange *tsr);
void TsRangeToString(TsRange *tsr, int maxlen, char *out);
void TsRangeFillSameStart(TsRange *tsr1, TsRange *tsr2);
void TsRangeFillSameStop(TsRange *tsr1, TsRange *tsr2);
void TsRangeFillStop1SameAsStart2(TsRange *tsr1, TsRange *tsr2);
void TsRangeFillAdjacentPosteriority(TsRange *before, TsRange *after);
void TsRangeFillEquallyLongSimultaneity(TsRange *tsr1, TsRange *tsr2);
void TsRangeFillPersistentPosteriority(TsRange *tsr1, TsRange *tsr2);
void ptsr(TsRange *tsr);
void TsTodayTime(Tod tod, /* RESULT */ Ts *outts);
