/* taemail.c */
EmailHeader *EmailHeaderCreate(void);
void EmailHeaderFree(EmailHeader *emh);
void EmailStripRe(char *s);
void EmailHeaderAdjust(EmailHeader *emh);
void EmailHeaderMergeInto(EmailHeader *dest, EmailHeader *src);
void EmailHeaderPrint(FILE *stream, EmailHeader *emh);
Ts *EmailHeaderTs(EmailHeader *emh);
Bool TA_EmailIsSlotnameChar(int c);
Bool TA_EmailIsNewsgroupChar(int c);
Bool TA_EmailIsQuotationChar(int c);
Bool TA_EmailIsNewsgroupString(char *s);
Bool TA_EmailParseUser(char *user, char *username, char *domain);
Bool TA_EmailParseEntity1(char *in, char *fullname, char *user);
Bool TA_EmailParseEntity(char *in, char *fullname, char *username, char *domain, char *address);
void TA_EmailAssertAddress(Ts *ts, Obj *entity, Obj *address, Discourse *dc);
Bool TA_EmailResolveEntity(Ts *ts, char *fullname, char *address, Discourse *dc, Obj **entity);
Bool TA_EmailParseAndResolveEntity(char *in, Ts *ts, Discourse *dc, char *address, Obj **entity);
Bool TA_EmailParseTop(char *in, char *topentity, Ts *receive_ts, char **nextp);
Bool TA_EmailParseRmailHeader(char *in, char **nextp);
Bool TA_EmailParseStringSlot(char *in, char *slotname, int maxlen, char *slotvalue, char **nextp);
Bool TA_EmailParseAngleBracketSlot(char *in, char *slotname, char *slotvalue, char **nextp);
Bool TA_EmailParseAngleObjectSlot(char *in, char *slotname, Obj *class, Obj **slotvalue, char **nextp);
Bool TA_EmailParseReceived(char *in, char *from, char *by, Ts *ts, char **nextp);
Bool TA_EmailParseDate(char *in, char *slotname, Ts *ts, char **nextp);
Bool TA_EmailParseFrom(char *in, char *slotname, Ts *ts, char *topentity_string, Discourse *dc, char *address, Obj **entity, char **nextp);
Bool TA_EmailParseTo(char *in, char *slotname, char *prevslotname, Ts *ts, Discourse *dc, ObjList **to, ObjList **newsgroups, char **nextp);
Bool TA_EmailParseInReplyTo(char *in, char *slotname, char **nextp);
Bool TA_EmailParseArticleNumber1(char *word, long *article_number);
Bool TA_EmailParseArticleNumber(char *sent, long *article_number, char **nextp);
Bool TA_EmailParseNewsgroup1(char *word, Obj **newsgroup);
Bool TA_EmailParseNewsgroup(char *sent, Obj **newsgroup, char **nextp);
Bool TA_EmailParseNewsgroups(char *in, char *slotname, Ts *ts, Discourse *dc, ObjList **newsgroups, char **nextp);
Bool TA_EmailParseArticle(char *in, long *article_number, Obj **newsgroup, char **nextp);
Bool TA_EmailParseUnimplementedSlot(char *in, char **nextp);
Bool TA_EmailParseHeader1(char *in, Discourse *dc, EmailHeader *emh, char **nextp, char **subj_beginp, char **subj_restp);
Bool TA_EmailParseHeaderFirstClass(char *in, Discourse *dc, EmailHeader *emh, char **nextp);
Bool TA_EmailParseHeader(char *in, Discourse *dc, Channel *ch, char **nextp);
void TA_EmailProcessPostHeaders(Channel *ch);
Bool TA_EmailParseQuotationLevel(char *in, Discourse *dc, int *attr1a, char **nextp);
Bool TA_EmailParseAttribution1(char *in, Discourse *dc, Ts *ts, Obj **message_id, char *address, Obj **entity, char **nextp);
Bool TA_EmailParseAttribution2(char *in, Discourse *dc, Ts *ts, Obj **message_id, char *address, Obj **entity, char **nextp);
Bool TA_EmailParseAttributionLast(char *in, Discourse *dc, Ts *ts, Obj **message_id, char *address, Obj **entity, char **nextp);
Bool TA_EmailParseAttributionA(char *in, Discourse *dc, Ts *ts, Obj **message_id, char *address, Obj **entity, char **nextp);
Bool TA_EmailParseAttribution(char *in, Discourse *dc, Channel *ch, char **nextp);
Bool TA_Communicon(char *in, Discourse *dc, Channel *ch, char **nextp);
Bool TA_StarRating(char *in, Discourse *dc, Channel *ch, char **nextp);
