package de.cinek.rssview;

import java.util.*;

public class RssArticleContainer {

    private static RssChannelModel channelmodel=new RssChannelModel();
    private static Vector articles=new Vector();
    private static Hashtable articleshash=new Hashtable();

    public static RssChannelModel getChannelModel() {
	return channelmodel;
    }

    public static RssChannel getGlobalChannel() {
	return (RssChannel)channelmodel.getElementAt(0);
    }

    /* returns article ID */
    public synchronized static boolean addArticle(RssArticle a) {
	if (a==null) return false;
	/* avoid dupes */
	String key=a.getTitle()+a.getLink();
	if (articleshash.containsKey(key)) return false;
	articles.add(0,a);
	articleshash.put(key,a);
	return true;
    }

    public static void removeArticle(RssArticle a) {
	if (articles==null) return;

	System.out.println("Adding: "+a+" Link: "+a.getLink());

	articles.removeElement(a);
	articleshash.put(a.getLink(),null);

	/* if (articles.removeElement(a)) {
	   System.err.println("Article "+a+" expired.");
	} else {
	    System.err.println("*** Article "+a+" failed to expire.");
	    }*/
    }

    /*
    public static RssArticle getArticle(int i) {
	if (articles==null) return null;
	if (i<0 || i>=articles.size()) return null;
	return (RssArticle)articles.elementAt(i);
    }
    */

    public static synchronized RssArticle[] getLatestArticles(int count) {
	if (count<0) count=articles.size();

	if (count>articles.size()) count=articles.size();
	RssArticle[] articleret=new RssArticle[count];

	/*
	for (int i=0;i<count;i++) 
	    articleret[i]=(RssArticle)articles.elementAt(articles.size()-1-i);
	return articleret;
	*/

	return (RssArticle[])
	    articles.subList(0,count).toArray(new RssArticle[0]);
    }

    public static boolean hasNews() {
	RssChannel[] channel=channelmodel.getChannels();
	for (int i=1;i<channel.length;i++)
	    if (channel[i].hasNews()) return true;

	return false;
    }

    public static void flushNews() {
	RssChannel[] channel=channelmodel.getChannels();
	for (int i=0;i<channel.length;i++) {
	    if (!channel[i].isGlobal()) channel[i].flushNews();
	}
    }
}
