package de.cinek.rssview;

import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;
import de.cinek.rssview.images.IconContainer;

public class RssBrowserSetup extends JDialog {

    private JTextField tf_path;
    private JTextField tf_params;

    public RssBrowserSetup(RssView parent) {
	super(parent,"Browser setup",true);
	initComponents();
	pack();
	Dimension d=Toolkit.getDefaultToolkit().getScreenSize();
	setLocation(d.width/2,d.height/2);
	show();
    }

    private void initComponents() {

	InsetsPanel ip=new InsetsPanel();
	getContentPane().add(ip);

	GridBagLayout gbl=new GridBagLayout();
	GridBagConstraints gbc = new GridBagConstraints();

	JPanel widgetpanel=new JPanel(gbl);
	ip.add(widgetpanel,BorderLayout.CENTER);

	gbc.fill = GridBagConstraints.BOTH;
	gbc.weightx = 1.0;
	gbc.gridheight = 4;
	gbc.weighty = 1.0;
	gbc.ipadx=10;
	JLabel imglabel=new JLabel(IconContainer.ICON_GLOBETOOL);
	gbl.setConstraints(imglabel,gbc);
	widgetpanel.add(imglabel);

	gbc.gridheight = 1;
	JLabel lab=new JLabel("Browser path:");
	gbl.setConstraints(lab,gbc);
	widgetpanel.add(lab);
	
	tf_path=new JTextField(20);
	gbl.setConstraints(tf_path,gbc);
	widgetpanel.add(tf_path);

	gbc.gridwidth = GridBagConstraints.REMAINDER;
	JButton search=new JButton("Search...");
	gbl.setConstraints(search,gbc);
	widgetpanel.add(search);

	gbc.gridwidth = 1;
	lab=new JLabel
	    ("Browser parameters (put %u where you want the url inserted):");
	gbl.setConstraints(lab,gbc);
	widgetpanel.add(lab);
	
	gbc.gridwidth = GridBagConstraints.REMAINDER;
	tf_params=new JTextField(20);
	gbl.setConstraints(tf_params,gbc);
	widgetpanel.add(tf_params);

	tf_path.setText(RssSettings.getBrowserPath());
	tf_params.setText(RssSettings.getBrowserParams());

	JPanel buttonpanel=new JPanel(new FlowLayout(FlowLayout.RIGHT));
	ip.add(buttonpanel,BorderLayout.SOUTH);

	JButton add=new JButton("Setup");
	JButton cancel=new JButton("Cancel");
	buttonpanel.add(add);
	buttonpanel.add(cancel);

	cancel.addActionListener(new AbstractAction() {
		public void actionPerformed(ActionEvent e) {
		    dispose();
		}
	    });

	add.addActionListener(new AbstractAction() {
		public void actionPerformed(ActionEvent e) {

		    String path=tf_path.getText();
		    String params=tf_params.getText();

		    RssSettings.setBrowserPath(path);
		    RssSettings.setBrowserParams(params);

		    dispose();
		}
	    });

	search.addActionListener(new AbstractAction() {
		public void actionPerformed(ActionEvent e) {

		    JFileChooser jfc=new JFileChooser();
		    jfc.setDialogTitle("Select your browser application");
		    jfc.setFileSelectionMode(JFileChooser.FILES_ONLY);
		    jfc.setMultiSelectionEnabled(false);
		    if (jfc.showDialog(null,"Select")==
			JFileChooser.APPROVE_OPTION) {
			tf_path.setText(jfc.getSelectedFile().
					getAbsolutePath());
		    }
		}
	    });

    }

    private class InsetsPanel extends JPanel {

	Insets insets=new Insets(10,10,10,10);

	public InsetsPanel() {
	    super(new BorderLayout());
	}

	public Insets getInsets() {
	    return insets;
	}
    }
}
