package de.cinek.rssview;

import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;

public class RssNotifyThread extends Thread {

    RssChannelView channelview;
    volatile boolean killed=false;

    private static final int phaseduration[]={
	300,300,300,300,300,2000
    };

    public RssNotifyThread(RssChannelView channelview) {
	this.channelview=channelview;
    }

    public void run() {

	int phase=0;
	Graphics2D g=(Graphics2D)channelview.getGraphics();
	g.setXORMode(Color.white);
	g.setColor(Color.red);
	g.setFont(new Font("Times",Font.BOLD,16));
	int sw=(int)g.getFontMetrics().getStringBounds("Up",g).getWidth()+
	    channelview.getVerticalScrollBar().getWidth()+5;
	int x=channelview.getWidth()-sw;if (x<0) x=0;
	int y=channelview.getHeight()/2;

	MyChangeHandler l=new MyChangeHandler();
	channelview.getViewport().addChangeListener(l);

	while (!killed) {

	    g.drawString("Up",x,y);

	    try {
		Thread.sleep(phaseduration[phase++]);
		if (phase>=phaseduration.length) phase=0;
	    }
	    catch (InterruptedException ex) {}
	}

	channelview.getViewport().removeChangeListener(l);

	channelview.revalidate();
	channelview.repaint();
    }

    public void kill() {
	killed=true;
    }

    public class MyChangeHandler implements ChangeListener {
	public void stateChanged(ChangeEvent e) {
	    killed=true;
	}
    }
}

