package de.cinek.rssview;

import javax.swing.*;
import javax.swing.event.*;
import java.awt.event.*;
import de.cinek.rssview.images.IconContainer;

public class RssToolBar extends JToolBar {

    private JButton button_new;
    private JButton button_up;
    private JButton button_down;
    
    private RssView parent;
    private RssChannelList list;

    public RssToolBar(RssView parent,RssChannelList list) {
	super("Channel list toolbar",JToolBar.HORIZONTAL);
	this.parent=parent;
	this.list=list;
	initComponents();
    }

    private void initComponents() {

	button_new=new JButton(IconContainer.ICON_STAR);
	button_up =new JButton(IconContainer.ICON_UP);
	button_down=new JButton(IconContainer.ICON_DOWN);

	button_new.setToolTipText("Create new channel");
	button_up.setToolTipText("Move channel up one position");
	button_down.setToolTipText("Move channel down one position");

	add(button_new);
	add(button_up);
	add(button_down);

	button_new.addActionListener(new AbstractAction() {

		public void actionPerformed(ActionEvent e) {
		    
		    new RssChannelDialog(parent,list);
		    parent.updateViews();
		}
	    });

	button_up.addActionListener(new AbstractAction() {

		public void actionPerformed(ActionEvent e) {
		    list.moveUp();
		}
	    });

	button_down.addActionListener(new AbstractAction() {

		public void actionPerformed(ActionEvent e) {
		    list.moveDown();
		}
	    });
    }
}
