package br.usp.talkagent.basicagent;

/**
 * @author: Percival Lucena
 */

import fipaos.ont.fipa.*;
import fipaos.ont.fipa.fipaman.*;
import java.net.*;
import br.usp.talkagent.aclmessages.*;
import br.usp.talkagent.util.*;
import java.io.*;

public class AmsClient 
{
public fipaos.ont.fipa.fipaman.AgentID amsServer;
public addressParser amsAddr;
private Socket outputConnection;
protected fipaos.ont.fipa.fipaman.AgentID agentid;
private String amsaddr;

/**
*/

public AmsClient()
{
		super();
		PrefReader prefs = new PrefReader();
		this.amsaddr = prefs.getAmsClient();
		amsAddr = new addressParser(amsaddr, 5040);
}


public AmsClient(String configfile)
{
		super();
		PrefReader prefs = new PrefReader(configfile);
		this.amsaddr = prefs.getAmsClient();		
		amsAddr = new addressParser(amsaddr, 5040);
}



/***
* Send Message TO AMS Server
*/
private void sendMsgAMS(ACL msg)
{
	ObjectOutputStream output;

	try
	{
		outputConnection = new Socket(amsAddr.IP, amsAddr.port);
		output = new ObjectOutputStream(outputConnection.getOutputStream());
		output.writeObject(msg);
	}
	catch (Exception e)
	{
		System.err.println("== Error on writing to socket == ");
		System.err.println(amsAddr.IP + "," +  amsAddr.port);
		e.printStackTrace();
	}

}


/**
 Set AMS Server address
*/
public void setAMS(String ip, int port)
{
		amsAddr.IP = ip;
		amsAddr.port = port;
}


/**
*/
public void disRegister(AgentID agentid) 
{
	ACLWriter aclwriter =  new ACLWriter("ACL_REQUEST", "Disregister", agentid, amsServer);
	this.sendMsgAMS(aclwriter.aclmsg);
	System.err.println("disregistering agent from AMS");
}


/**
 * @return fipaos.ont.fipa.fipaman.AgentID
 * @param AgentName java.lang.String
 */ 
public AgentID getAgentID(String AgentName)
{
	ObjectInputStream input;
	
	try
	{		
	// send message request agentID from agentName
	
	ACLWriter aclwriter = new ACLWriter("ACL_QUERYREF","getAddress: " + AgentName, agentid, amsServer); 
	this.sendMsgAMS(aclwriter.aclmsg);

	// creates socket server and waits message with reply
		
		//System.err.println("Reading -- Socket connected to port: " +  connection.getLocalPort());
		input =  new ObjectInputStream(new BufferedInputStream(outputConnection.getInputStream())); 
		ACLReader aclreader = new ACLReader((fipaos.ont.fipa.ACL) input.readObject());

		// get content from recieved message
		return (AgentID) aclreader.getMsgContent();

	}
	catch (Exception e)
	{
		e.printStackTrace();
	}
	return null;
}


public void register(AgentID agentid) 
{
	this.agentid = agentid;
	ACLWriter aclwriter =  new ACLWriter("ACL_REQUEST", "Register", agentid, amsServer);
	this.sendMsgAMS(aclwriter.aclmsg);
	//System.err.println("Registering agent to AMS");

}


public AgentID getSelfID()
{
	return this.agentid;
}

/**
 * Returns the amsAddr.
 * @return addressParser
 */
public String getAmsAddr() 
{
	return amsaddr;
}

}