package br.usp.talkagent.ide;

import java.awt.*;
import javax.swing.*;


public class NodeData extends Object
{
	/** Font used for drawing. */
	protected Font font;

	/** Color used for text. */
	protected Color color;

	/** Value to display. */
	protected String string;

	/** Value of tooltip displayed */	 
    private String toolTipText;
    
    /** Node Type */
    private String Type;
    
    private Icon icon = new ImageIcon("images/Circle_1.gif");

	/**
	  * Returns the color used to draw the text.
	  */
	public Color getColor() {
	return color;
	}
	/**
	  * Returns the Font used to represent this object.
	  */
	public Font getFont() {
	return font;
	}
	/**
	  * Constructs a new instance of SampleData with the passed in
	  * arguments.
	  */
	public NodeData(Font newFont, Color newColor, String newString) {
	font = newFont;
	color = newColor;
	string = newString;
	}
	
	public NodeData(Font newFont, Color newColor, String newString, String toolTipText) 
	{
	font = newFont;
	color = newColor;
	string = newString;
    this.toolTipText = toolTipText;
	}
	
	
	public NodeData(Font newFont, Color newColor, String newString, String toolTipText, String Type) 
	{
	font = newFont;
	color = newColor;
	string = newString;
    this.toolTipText = toolTipText;
    this.Type = Type;
	}
	public NodeData(Color newColor, String newString, String toolTipText) 
	{
	color = newColor;
	string = newString;
    this.toolTipText = toolTipText;
	}
	
	public NodeData(String data, String Type)
	{
		this.string = data;
		this.Type = Type;
	}

	/**
	  * Sets the color used to draw the text.
	  */
	public void setColor(Color newColor) 
	{
	color = newColor;
	}
	
	/**
	  * Sets the font that is used to represent this object.
	  */
	public void setFont(Font newFont) 
	{
	font = newFont;
	}
	
	/**
	  * Sets the string to display for this object.
	  */
	public void setString(String newString) 
	{
	string = newString;
	}
	
	
	/**
	  * Returnes the string to display for this object.
	  */
	public String string() {
	return string;
	}
	
	public String toString() {
	return string;
	}
	/**
	 * Returns the toolTipText.
	 * @return String
	 */
	public String getToolTipText() {
		return toolTipText;
	}

	/**
	 * Sets the toolTipText.
	 * @param toolTipText The toolTipText to set
	 */
	public void setToolTipText(String toolTipText) {
		this.toolTipText = toolTipText;
	}

	/**
	 * Returns the string.
	 * @return String
	 */
	public String getValue() {
		return string;
	}

	/**
	 * Returns the type.
	 * @return String
	 */
	public String getType() {
		return Type;
	}

	/**
	 * Sets the type.
	 * @param type The type to set
	 */
	public void setType(String type) {
		Type = type;
	}

	/**
	 * Returns the icon.
	 * @return Icon
	 */
	public Icon getIcon() {
		return icon;
	}

	/**
	 * Sets the icon.
	 * @param icon The icon to set
	 */
	public void setIcon(Icon icon) {
		this.icon = icon;
	}

	public void ConceptNodeLookAndFeel(boolean triger)
	{
		if(triger)
		{
		Icon ic = new ImageIcon("../ide/images/concept.gif");		
		this.setIcon(ic);
		}
		else
			this.setIcon(null);
		
	}
	
	
	public void AssertionNodeLookAndFeel(boolean triger)
	{
		if(triger)
		{
			Icon ic = new ImageIcon("../ide/images/assertion.gif");	
			this.setIcon(ic);
		}
		else
			this.setIcon(null);		
	}


	public void ComponentNodeLookAndFeel(boolean triger)
	{
		if(triger)
		{
			Icon ic = new ImageIcon("../ide/images/component.gif");	
			this.setIcon(ic);
		}
		else
			this.setIcon(null);		
	}

	
}
