package br.usp.talkagent.ucl;

/* An UCL Document is a set of
* UClRelations
* UClConcepts
*/

import java.io.Serializable;
import java.util.Vector;
import br.usp.talkagent.util.List;

public class UCLDoc implements Serializable 
{

public List Concepts;
public Vector Relations;	
public boolean isBroken;

/**
 */
public UCLDoc()
 {
	super();
	Concepts = new  br.usp.talkagent.util.List();
	Relations = new Vector(10);
	isBroken = false;
	// vector may be initialized with any # of elements
	// it grows as needed.
}


/**
 */ 
public List getConcepts() 
{
	return this.Concepts;
}


public void setConcepts(List concepts) 
{
	this.Concepts = concepts;
}


/**
 * Sets the relations.
 * @param relations The relations to set
 */
public void setRelations(Vector relations) 
{
	this.Relations = relations;
}


/**
 * @return java.util.Vector
 */
public Vector getRelations() 
{
	return Relations;
}


public Object findConncept(String concept)
{
	return Concepts.findName(concept);
}



/**
 *  Returns a relation that has a given concept in its tail.
 */
public UCLRelation findRelationWithConcept(String concept)
{

Vector Elements;
UCLRelation relat=null;
int i=0;
boolean found=false;

while( (i<Relations.size()) && (!found) )
{
	relat = (UCLRelation) Relations.elementAt(i);
	Elements = relat.getElements();
	if(Elements.elementAt(0) instanceof UclConcept)
	{
		if((((UclConcept)Elements.elementAt(0)).getName()).equalsIgnoreCase(concept))
			found = true;		
	}
	if(Elements.elementAt(1) instanceof UclConcept)
	{
		if((((UclConcept)Elements.elementAt(1)).getName()).equalsIgnoreCase(concept))	
			found = true;		
	}
	i++;   
}
	return relat;
}


/**
* Find a relation with has a given relation on its tail
*/ 
public UCLRelation findRelationWithRelation(String relatid) 
{
int i=0;
boolean found = false;
UCLRelation relat=null;
Vector Elements;

while((i<Relations.size()) && !found)
{
	relat = (UCLRelation) Relations.elementAt(i);
	Elements = relat.getElements();
	
	if(Elements.elementAt(0) instanceof UCLRelation)
	{
		if((((UCLRelation)Elements.elementAt(0)).getID()).equalsIgnoreCase(relatid))
			found = true;
	}
	
	if(Elements.elementAt(1) instanceof UCLRelation)
	{
		if((((UCLRelation)Elements.elementAt(1)).getID()).equalsIgnoreCase(relatid))	
			found = true;
	}
	i++;
}
  return relat;
}



public void print()
{
	int i;
	UclConcept caux;
	UCLRelation relat;
	String e1, e2;

	// print concepts	
	System.err.println("-- Printing UCL Message --");
	System.err.println("-- Concepts:");
	for(i=0;i<Concepts.getSize();i++)
	{
		caux = (UclConcept) Concepts.elementAt(i);
		if(caux!=null)
		{	
			System.err.println("-- Concept: " + caux.getValue() + " - " + caux.getName());
		}
	}	
	// print relations	
	System.err.println("-- Relations");
	for(i=0;i<Relations.size();i++)
	{
		relat = (UCLRelation) Relations.elementAt(i);
		if(relat!=null)
		{
			Vector Elements = relat.getElements();
			if(Elements.elementAt(0) instanceof UclConcept) 		
			  e1 = ((UclConcept) Elements.elementAt(0)).getName();
			else 
			  e1 = ((UCLRelation) Elements.elementAt(0)).getID();
			  	
			if(Elements.elementAt(1) instanceof UclConcept)
			  e2 = ((UclConcept) Elements.elementAt(1)).getName();
			else 
			  e2 = ((UCLRelation) Elements.elementAt(1)).getID();
			  	
			System.err.println("-- Relation: " + relat.getID() + "-" + relat.getType() + ":" + e1 + "," + e2);
		}	
	}
	System.err.println("--------------------------");	
}


}