//***************************************************************************
//	Open Source Copyright Notice and License: FIPA-OS
//
//	1. 	The programs and other works made available to you in these files 
//		("the Programs") are Copyright (c) 1999 - 2000 Nortel Networks Corporation, 
//		8200 Dixie Road, Suite 100, Brampton, Ontario, Canada L6R 5P6.  
//		All rights reserved.
//
//	2.	Your rights to copy, distribute and modify the Programs are as set out 
//		in the Nortel Networks FIPA-OS Public License, a copy of which can be
//		found in file "FIPA_OS_Public_Licence.txt" and the latest version can
//		also be found at http://fipa-os.sourceforge.net/. By 
//		downloading the files containing the Programs you accept the terms and 
//		conditions of the Public License. You do not have to accept these 
//		terms and conditions, but unless you do so you have no rights to use 
//		the Programs.
//---------------------------------------------------------------------------
//***************************************************************************

//**************************************************************************/

package fipaos.agent.conversation.content;

// -------------------------------------------------------------------------

import fipaos.agent.conversation.content.Content;
import fipaos.util.UTCTime;
import java.util.Vector;
import java.lang.*;

/**
 * @deprecated Content objects should be avoided - please use XML Databinding instead
 * @see fipaos.util.XMLDataBinding
 */
public class ContentUtil {
	
	/*************************************************************
	* getVectorFromContent
	*
	* Retreives the vector stored with the key <b>key_prefix</b>
	* from the Content object <b>the_content</b>
	*************************************************************/
	
	public static Vector getVectorFromContent(Content the_content, String key_prefix) {
		
		Object num_items_ob = the_content.getAttribute(key_prefix);
				
		if (num_items_ob == null) {
			
			return new Vector();
			
		}
		else {
		
			String count_string = num_items_ob.toString();
			
			Integer count_integer = new Integer(count_string);
			
			int num_items = count_integer.intValue();
			
			Vector result = new Vector(num_items);
			
			for (int i = 0; i < num_items; i++) {
				
				result.addElement( the_content.getAttribute(key_prefix + i) );
				
			}
			
			return result;
			
		}
		
	}
	
	/*************************************************************
	* putVectorInContent
	*
	* Adds the vector <b>the_vector</b> to the Content object
	* <b>the_content</b> using the key <b>key_prefix</b>.
	* The updated Content object is returned.
	*************************************************************/
	
	public static Content putVectorInContent(Content the_content,
																					 Vector the_vector,
																					 String key_prefix) {
	
		int num_items = the_vector.size();
		
		the_content.setAttribute(key_prefix, (new Integer(num_items)).toString());
		
		for (int i = 0; i < num_items; i++) {
			
			
			// can currently only add vectors of objects who have a lossless toString()
			String element = (the_vector.elementAt(i)).toString();
			
			the_content.setAttribute(key_prefix + i, element);			
			
		}
		
		return the_content;
	
	}
	
	public static void main(String[] args) {
		
		UTCTime time1 = new UTCTime("19991202T150000000Z");
		UTCTime time2 = new UTCTime("19991203T150000000Z");
		UTCTime time3 = new UTCTime("19991204T150000000Z");
		UTCTime time4 = new UTCTime("19991205T150000000Z");
		UTCTime time5 = new UTCTime("19991206T150000000Z");
		
		Vector v1 = new Vector(5);
		
		v1.addElement(time1);
		v1.addElement(time2);
		v1.addElement(time3);
		v1.addElement(time4);
		v1.addElement(time5);
		
		System.out.println("v1 = " + v1);		
	
		Content my_content = new Content();
		
		my_content = ContentUtil.putVectorInContent(my_content, v1, "times");
		
		System.out.println("Content = " + my_content);
		
		Vector v2 = ContentUtil.getVectorFromContent(my_content, "times");
	
		System.out.println("v2 = " + v2);
	
	}	
	
}