//******************************************************************************
//
//  Open Source Copyright Notice and License: FIPA-OS
//
//  1. The programs and other works made available to you in these files ("the
//     Programs") are Copyright (c) 1999 - 2000 Nortel Networks Corporation, 
//     8200 Dixie Road, Suite 100, Brampton, Ontario, Canada L6R 5P6.  
//     All rights reserved.
//
//  2. Your rights to copy, distribute and modify the Programs are as set out in
//     the Nortel Networks FIPA-OS Public License, a copy of which can be found
//     in file "Nortel_FIPA_OS_Public_Licence.txt" and the latest version can
//     also be found at http://fipa-os.sourceforge.net/. By downloading the
//     files containing the Programs you accept the terms and  conditions of the
//     Public License. You do not have to accept these terms and conditions, but
//     unless you do so you have no rights to use the Programs.
//
//  The Original Code is Nortel Networks' FIPA-OS (Foundation for Intelligent
//  Physical Agents - Open Source).
//
//  The Initial Developer of the Original Code is Nortel Networks Corporation.
//  Portions created by Nortel Networks Corporation or its subsidiaries are
//  Copyright (c) 1999 - 2000 Nortel Networks Corporation. All Rights Reserved.
//
//  Contributor(s):
//  (add contributor names here)
//
//******************************************************************************

package fipaos.agent.conversation.content;

//******************************************************************************
//
//  Open Source Copyright Notice and License: FIPA-OS
//
//  1. The programs and other works made available to you in these files ("the
//     Programs") are Copyright (c) 1999 - 2000 Nortel Networks Corporation, 
//     8200 Dixie Road, Suite 100, Brampton, Ontario, Canada L6R 5P6.  
//     All rights reserved.
//
//  2. Your rights to copy, distribute and modify the Programs are as set out in
//     the Nortel Networks FIPA-OS Public License, a copy of which can be found
//     in file "Nortel_FIPA_OS_Public_Licence.txt" and the latest version can
//     also be found at http://fipa-os.sourceforge.net/. By downloading the
//     files containing the Programs you accept the terms and  conditions of the
//     Public License. You do not have to accept these terms and conditions, but
//     unless you do so you have no rights to use the Programs.
//
//  The Original Code is Nortel Networks' FIPA-OS (Foundation for Intelligent
//  Physical Agents - Open Source).
//
//  The Initial Developer of the Original Code is Nortel Networks Corporation.
//  Portions created by Nortel Networks Corporation or its subsidiaries are
//  Copyright (c) 1999 - 2000 Nortel Networks Corporation. All Rights Reserved.
//
//  Contributor(s):
//  (add contributor names here)
//
//******************************************************************************

//----------------------------------------------------------------------

  /**
   * description of class
   * <br>
   * <br>
   * @deprecated Content objects should be avoided - please use XML Databinding instead
   * @see fipaos.util.XMLDataBinding*/

public class ContentValue
{
	//----------------------------------------------------------------------
	// CONSTANTS
	//----------------------------------------------------------------------

	//----------------------------------------------------------------------
	// STATIC VARIABLES
	//----------------------------------------------------------------------
		
	//----------------------------------------------------------------------
	// INSTANCE VARIABLES
	//----------------------------------------------------------------------

	private String _name = null; 
	private String _position = null;
	private String _value = null;
	
	
	//----------------------------------------------------------------------
	// CONSTRUCTOR
	//----------------------------------------------------------------------

	/**
	 * This is the default ContentValue constructor.
	 */
	public ContentValue() {}
	
	/**
	 * This ContentValue constructor takes in the name, position and value of the
	 * issue. Hence, it is a triple.
	 */
	public ContentValue(String name, String position, String value)
	{
		_name = name;
		_position = position;
		_value = value;
	}
	
	
	//----------------------------------------------------------------------
	// PUBLIC METHODS
	//----------------------------------------------------------------------

	/**
	 * This methods sets the name of the issue.
	 */
	public void setName(String name)
	{
		_name = name;
	}
	
	/**
	 * This methods sets the position of the issue.
	 */
	public void setPosition(String position)
	{
		_position = position;
	}
	
	/**
	 * This methods sets the value of the issue.
	 */
	public void setValue(String value)
	{
		_value = value;
	}
	
	/**
	 * This methods returns the name of the issue.
	 */
	public String getName()
	{
		return _name;
	}
	
	/**
	 * This methods returns the position of the issue.
	 */
	public String getPosition()
	{
		return _position;
	}
	
	/**
	 * This methods returns the value of the issue.
	 */
	public String getValue()
	{
		return _value;
	}
	
	
	//----------------------------------------------------------------------
	// PRIVATE METHODS
	//----------------------------------------------------------------------

	private int getIssue(String name)
	{
		String issue_string = name.substring(name.indexOf('_' ) + 1);
		int issue = java.lang.Integer.getInteger(issue_string).intValue();
		
		return issue;
	}
}