//******************************************************************************
//
//  Open Source Copyright Notice and License: FIPA-OS
//
//  1. The programs and other works made available to you in these files ("the
//     Programs") are Copyright (c) 1999 - 2000 Nortel Networks Corporation, 
//     8200 Dixie Road, Suite 100, Brampton, Ontario, Canada L6R 5P6.  
//     All rights reserved.
//
//  2. Your rights to copy, distribute and modify the Programs are as set out in
//     the Nortel Networks FIPA-OS Public License, a copy of which can be found
//     in file "Nortel_FIPA_OS_Public_Licence.txt" and the latest version can
//     also be found at http://fipa-os.sourceforge.net/. By downloading the
//     files containing the Programs you accept the terms and  conditions of the
//     Public License. You do not have to accept these terms and conditions, but
//     unless you do so you have no rights to use the Programs.
//
//  The Original Code is Nortel Networks' FIPA-OS (Foundation for Intelligent
//  Physical Agents - Open Source).
//
//  The Initial Developer of the Original Code is Nortel Networks Corporation.
//  Portions created by Nortel Networks Corporation or its subsidiaries are
//  Copyright (c) 1999 - 2000 Nortel Networks Corporation. All Rights Reserved.
//
//  Contributor(s):
//  (add contributor names here)
//
//******************************************************************************

package fipaos.ont;

//******************************************************************************
//
//  Open Source Copyright Notice and License: FIPA-OS
//
//  1. The programs and other works made available to you in these files ("the
//     Programs") are Copyright (c) 1999 - 2000 Nortel Networks Corporation, 
//     8200 Dixie Road, Suite 100, Brampton, Ontario, Canada L6R 5P6.  
//     All rights reserved.
//
//  2. Your rights to copy, distribute and modify the Programs are as set out in
//     the Nortel Networks FIPA-OS Public License, a copy of which can be found
//     in file "Nortel_FIPA_OS_Public_Licence.txt" and the latest version can
//     also be found at http://fipa-os.sourceforge.net/. By downloading the
//     files containing the Programs you accept the terms and  conditions of the
//     Public License. You do not have to accept these terms and conditions, but
//     unless you do so you have no rights to use the Programs.
//
//  The Original Code is Nortel Networks' FIPA-OS (Foundation for Intelligent
//  Physical Agents - Open Source).
//
//  The Initial Developer of the Original Code is Nortel Networks Corporation.
//  Portions created by Nortel Networks Corporation or its subsidiaries are
//  Copyright (c) 1999 - 2000 Nortel Networks Corporation. All Rights Reserved.
//
//  Contributor(s):
//  (add contributor names here)
//
//******************************************************************************

//----------------------------------------------------------------------

/**
 * This class is used as a central repository for all base tokens used
 * by agents in the construction of messages or for internal operations.
 * These constants are those which are not already defined in a specific
 * ontology deinfition or by FIPA.
 * Agents wishing to use any base token constants should use this file
 * and should not define constants locally.
 * <br>The standard naming for these constants is as follows:
 * <p><ul>
 * <li>Constants names are capitalised versions of the strings they represent
 * <li>Space ( ) and dash (-) characters are replaced by underscores (_)
 * <li>Colon (:) characters are omitted from constants names
 * <li>Constants do not include any whitespace at the start or then end of the string
 *     unless expicitly mentioned in the constants name.
 * <li>Character constants are named after the character that they represent and do not
 *     include any underscores in the constant name at all. Some characters are also
 *     aliased to common 'alternative' names. E.g. A question mark (?) is available as:
 *     QUESTIONMARK, BANG, PLINK and QUESTION. Note that QUESTIONMARK has no _ character
 *     in its name.
 * </ul>
 * <br>
 * <br>
 **/
public class BASETOKENS
{
	 
//----------------------------------------------------------------------
// MISC USEFUL CONSTANTS
//----------------------------------------------------------------------	
	
	// CHARACTERS AND SYMBOLS
	public static final String BLANK								= "";
	public static final String EMPTY								= BLANK;
	public static final String EMPTYSTRING					= BLANK;
	public static final String COLON								= ":";
	public static final String SEMICOLON						= ";";
	public static final String COMMA								= ",";
	public static final String DOT									= ".";
	public static final String FULLSTOP							= DOT;
	public static final String BANG									= "!";
	public static final String PLINK								= BANG;
	public static final String PLING								= BANG;
	public static final String EXCLAMATION					= BANG;
	public static final String EXCLAMATIONMARK			= BANG;
	public static final String QUESTIONMARK					= "?";
	public static final String QUESTION							= QUESTIONMARK;
	public static final String STAR									= "*";
	public static final String ASTERISK							= STAR;
	public static final String PLUS									= "+";
	public static final String MINUS								= "-";
	public static final String DASH									= MINUS;
	public static final String T										= "T";
	public static final String Z										= "Z";
	public static final String OPENBRACKET					= "(";	
	public static final String CLOSEBRACKET					= ")";
	public static final String SPACE								= " ";
	public static final String OPENBRACKETSPACE			= "( ";	
	public static final String SPACECLOSEBRACKET		= " )";
	public static final String OPENSQUAREBRACKET		= "[";
	public static final String CLOSESQUAREBRACKET		= "]";
	public static final String OPENBRACE						= "{";
	public static final String CLOSEBRACE						= "}";
	public static final String OPENANGLEBRACKET 		= "<";
	public static final String CLOSEANGLEBRACKET 		= ">";
	public static final String TAGOPEN							= OPENANGLEBRACKET;
	public static final String TAGCLOSE							= CLOSEANGLEBRACKET;
	public static final String GREATERTHAN					= OPENANGLEBRACKET;
	public static final String LESSTHAN							= CLOSEANGLEBRACKET;
	public static final String AT										= "@";
	public static final String FORWARDSLASH 				= "/";
	public static final String SLASH 								= "/";
	public static final String BACKSLASH 						= "\\";
	public static final String COLONSLASHSLASH			= "://";
	public static final String NEWLINE							= "\n";
  public static final String TAB							    = "\t";
	public static final String QUOTES								= "\"";
	public static final String SPEECHMARKS					= QUOTES;
	public static final String QUOTE								= "'";
	public static final String APOSTROPHE	  				= QUOTE;
	public static final String HASH									= "#";
	public static final String EQUALS								= "=";
	public static final String AND									= "&";
	public static final String AMPERSAND						= AND;
	public static final String TILDE								= "~";

	// NUMBERS
	public static final String ONE									= "1";
	public static final String TWO									= "2";
	public static final String THREE								= "3";
	public static final String FOUR									= "4";
	public static final String FIVE									= "5";
	public static final String SIX									= "6";
	public static final String SEVEN								= "7";
	public static final String EIGHT								= "8";
	public static final String NINE									= "9";
	public static final String ZERO									= "0";
	public static final String NOUGHT								= ZERO;
	public static final String OH										= ZERO;
	public static final String O										= ZERO;
	
	// USEFUL KEYWORDS
	public static final String UNKNOWN							= "unknown";
	public static final String DONE									= "done";
	public static final String RESULT								= "result";
	public static final String RESULTS							= RESULT;
	public static final String ACTION								= "action";
	public static final String LOCALHOST						= "localhost";
	public static final String DEFAULT							= "default";
	public static final String FORWARD							= "forward";
	
	/** 
	 * NOTE: IOR constant includes the ':' character
	 **/
  public static final String IOR									= "IOR:";	
  
  public static final String NO_PROTOCOL          = "no-protocol";
	
	
	// CHAR CONSTANTS
	public static final char BACKSLASH_CHAR					= '\\';
	public static final char FORWARDSLASH_CHAR			= '/';
	public static final char SLASH_CHAR							= FORWARDSLASH_CHAR;
	public static final char DASH_CHAR							= '-';
	public static final char MINUS_CHAR							= DASH_CHAR;
	public static final char DOT_CHAR								= '.';
	public static final char QUOTES_CHAR						= '"';
	public static final char SPEECHMARKS_CHAR				= QUOTES_CHAR;
	
	

	
	
}