//******************************************************************************
//
//  Open Source Copyright Notice and License: FIPA-OS
//
//  The contents of this file are subject to the Emorphia Public License (the
//  "License"); you may not use this file except in compliance with the License.
//  You may obtain a copy of the License at http://www.emorphia.com/EPL/
//
//  Software distributed under the License is distributed on an "AS IS" basis,
//  WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License
//  for the specific language governing rights and limitations under the
//  License.
//
//  The Original Code is FIPA-OS.
//
//  The Initial Developer of the Original Code is Emorphia.
//
//  Portions created by Emorphia are Copyright (C) 2001 Emorphia Limited
//  licensed under the Emorphia Public License, available at
//  http://www.emorphia.com/EPL/.
//
//  All Rights Reserved.
//
//  Contributor(s):
//  (add contributor names here)
//
//******************************************************************************

package fipaos.ont.fipa;

import fipaos.ont.fipa.fipaman.AgentID;

/** A wrapper object for the ACL message content for the action to be executed
 */
public class Action implements java.io.Serializable
{
/** Returns the actor agent
 * @return AgentID. The actor agent
 */
	public fipaos.ont.fipa.fipaman.AgentID getActor()
	{ return actor; }
	
/** Sets the actor agent
 * @param actor The actor agent
 */
	public void setActor(fipaos.ont.fipa.fipaman.AgentID actor)
	{ this.actor = actor; }
	
/** Returns the action to be executed
 * @return Object. The action object
 */
	public Object getAction()
	{ return action; }
	
/** Sets the action object to be executed
 * @param action The action object
 */
	public void setAction(Object action)
	{ this.action = action; }
	
/** The agent that will execute the action
 */
	private AgentID actor;
/** The object describing the action
 */
	private Object action;
}