//******************************************************************************
//  Open Source Copyright Notice and License: FIPA-OS
//
//  1. The programs and other works made available to you in these files 
//     ("the Programs") are Copyright (c) 1999 - 2000 Nortel Networks
//     Corporation, 8200 Dixie Road, Suite 100, Brampton, Ontario, Canada 
//     L6R 5P6.  All rights reserved.
//
//  2. Your rights to copy, distribute and modify the Programs are as set out 
//     in the Nortel Networks FIPA-OS Public License, a copy of which can be
//     found in file "Nortel_FIPA_OS_Public_Licence.txt" and the latest version 
//     can also be found at http://fipa-os.sourceforge.net/. By  downloading
//     the files containing the Programs you accept the terms and conditions of
//     the Public License. You do not have to accept these terms and conditions,
//     but unless you do so you have no rights to use the Programs.
//
//  The Original Code is Nortel Networks' FIPA-OS (Foundation for Intelligent
//  Physical Agents - Open Source).
//
//  The Initial Developer of the Original Code is Nortel Networks Corporation.
//  Portions created by Nortel Networks Corporation or its subsidiaries are
//  Copyright (c) 1999 - 2000 Nortel Networks Corporation. All Rights Reserved.
//
//  Contributor(s): 
//    Emorphia agree to provide Modifications to Nortel Networks' FIPA-OS 
//    Covered Code under Nortel Networks' FIPA-OS Public License. All Emorphia's 
//    Modifications remain Copyright (c) 2001 Emorphia Limited. All Rights
//    Reserved. 
//
//******************************************************************************

package fipaos.ont.fipa;

//******************************************************************************
//  Open Source Copyright Notice and License: FIPA-OS
//
//  1. The programs and other works made available to you in these files 
//     ("the Programs") are Copyright (c) 1999 - 2000 Nortel Networks
//     Corporation, 8200 Dixie Road, Suite 100, Brampton, Ontario, Canada 
//     L6R 5P6.  All rights reserved.
//
//  2. Your rights to copy, distribute and modify the Programs are as set out 
//     in the Nortel Networks FIPA-OS Public License, a copy of which can be
//     found in file "Nortel_FIPA_OS_Public_Licence.txt" and the latest version 
//     can also be found at http://fipa-os.sourceforge.net/. By  downloading
//     the files containing the Programs you accept the terms and conditions of
//     the Public License. You do not have to accept these terms and conditions,
//     but unless you do so you have no rights to use the Programs.
//
//  The Original Code is Nortel Networks' FIPA-OS (Foundation for Intelligent
//  Physical Agents - Open Source).
//
//  The Initial Developer of the Original Code is Nortel Networks Corporation.
//  Portions created by Nortel Networks Corporation or its subsidiaries are
//  Copyright (c) 1999 - 2000 Nortel Networks Corporation. All Rights Reserved.
//
//  Contributor(s): 
//    Emorphia agree to provide Modifications to Nortel Networks' FIPA-OS 
//    Covered Code under Nortel Networks' FIPA-OS Public License. All Emorphia's 
//    Modifications remain Copyright (c) 2001 Emorphia Limited. All Rights
//    Reserved. 
//
//******************************************************************************

//----------------------------------------------------------------------

// import ;

//----------------------------------------------------------------------

  /**
   * This class is used as a central repository for FIPA constants, such as
   * performative names, ACL fields names etc.
   * All FIPA constants should be defined in this file. Agents wishing to 
   * use any FIPA constants should use this file and should not define
	 * constants locally.
   * <br>The standard naming for these constants is as follows:
   * <p><ul>
   * <li>Constants names are capitalised versions of the strings they represent
   * <li>Colon (:) characters are omitted from constants names
   * <li>Space ( ) and dash (-) characters are replaced by underscores (_)
   * <li>Constants do not include any whitespace at the start or then end of the string
   * </ul>
   * <br>
   * <br>
   */

public class FIPACONSTANTS
{
	 
//----------------------------------------------------------------------
// FIPA CONSTANTS
//----------------------------------------------------------------------
	
	// THE MOST IMPORTANT CONSTANT :-)
	public static final String FIPA_OS							= "FIPA-OS";
	
	// PERFORMATIVES
	public static final String ACCEPT_PROPOSAL			= "accept-proposal";
	public static final String AGREE								= "agree";
	public static final String CANCEL								= "cancel";
	public static final String CFP									= "cfp";
	public static final String CONFIRM							= "confirm";
	public static final String DISCONFIRM						= "disconfirm";
	public static final String FAILURE							= "failure";
	public static final String INFORM								= "inform";
	public static final String INFORM_IF						= "inform-if";
	public static final String INFORM_REF						= "inform-ref";
	public static final String NOT_UNDERSTOOD				= "not-understood";
	public static final String PROPAGATE						= "propagate";
	public static final String PROPOSE							= "propose";
	public static final String PROXY								= "proxy";
	public static final String QUERY_IF							= "query-if";
	public static final String QUERY_REF						= "query-ref";
	public static final String REFUSE								= "refuse";
	public static final String REJECT_PROPOSAL			= "reject-proposal";
	public static final String REQUEST							= "request";
	public static final String REQUEST_WHEN					= "request-when";
	public static final String REQUEST_WHENEVER			= "request-whenever";
	public static final String REQUEST_WHOMEVER			= "request-whomever";
	public static final String SUBSCRIBE						= "subscribe";

	// LANGUAGES
	public static final String SL										= "FIPA-SL";
	public static final String SL0									= "FIPA-SL0";
	public static final String SL1									= "FIPA-SL1";
	public static final String ACL									= "ACL";
	public static final String KIF									= "FIPA-KIF";
	public static final String KQML									= "KQML";
	public static final String RDF									= "FIPA-RDF";
	public static final String XML									= "FIPA-XML";
	public static final String XQL									= "XQL";
	public static final String OKBC									= "OKBC";
	
	// PROTOCOLS
	public static final String FIPA_REQUEST									= "fipa-request";
	public static final String FIPA_REQUEST_WHEN						= "fipa-request-when";
	public static final String FIPA_QUERY										= "fipa-query";
	public static final String FIPA_CONTRACT_NET						= "fipa-contract-net";
	public static final String FIPA_ITERATED_CONTRACT_NET		= "fipa-iterated-contract-net";
	public static final String FIPA_AUCTION_ENGLISH					= "fipa-auction-english";
  public static final String FIPA_AUCTION_DUTCH						= "fipa-auction-dutch";
  public static final String FIPA_RECRUITING              = "fipa-recruiting";
  public static final String FIPA_BROKERING               = "fipa-brokering";
	public static final String FIPA_SUBSCRIBE								= "fipa-subscribe";
	
	// PLATFORM AGENT IDS
	public static final String AMS		= "ams";
	public static final String ACC		= "acc";
	public static final String DF			= "df";
	
	// TRANSPORTS
	public static final String IIOP		= "iiop";
	
	// RESERVED AGENT TYPES
	public static final String FIPA_AMS			= "fipa-ams";
	public static final String FIPA_ACC			= "fipa-acc";
	public static final String FIPA_DF			= "fipa-df";
	public static final String FIPA_OA			= "fipa-oa";
	public static final String FIPA_ARB			= "fipa-arb";
	public static final String FIPA_AGENT		= "fipa-agent";
	
	// ACL MESSAGE FIELDS
	public static final String SENDER						= ":sender";
	public static final String RECEIVER					= ":receiver";
	public static final String CONTENT					= ":content";
	public static final String REPLY_WITH 			= ":reply-with";
	public static final String REPLY_BY					= ":reply-by";
	public static final String REPLY_TO					= ":reply-to";
	public static final String IN_REPLY_TO			= ":in-reply-to";
	public static final String ENVELOPE					= ":envelope";
	public static final String LANGUAGE					= ":language";
	public static final String ONTOLOGY					= ":ontology";
	public static final String PROTOCOL					= ":protocol";
	public static final String CONVERSATION_ID	= ":conversation-id";
	
  //moved to FIPAMANCONSTANTS
	// AGENT ID CONSTANTS
	/*public static final String SET							= "set";
	public static final String SEQUENCE					= "sequence";
	public static final String AGENT_IDENTIFIER = "agent-identifier";
	public static final String NAME 						= ":name";
	public static final String ADDRESSES 				= ":addresses";
	public static final String RESOLVERS 				= ":resolvers";*/
	
	// ENVELOPE CONSTANTS (as described in FIPA00075)
	public static final String ACL_REPRESENTATION		= "ACL-Representation";
	public static final String COMMENTS							= "Comments";
	public static final String CONTENT_LENGTH				= "Content-length";
	public static final String CONTENT_ENCODING			= "Content-encoding";
	public static final String DATE									= "Date";
	public static final String ENCRYPTED						= "Encrypted";
	public static final String INTENDED_RECEIVER		= "Intended-receiver";
	public static final String RECEIVED							= "Received";
	public static final String ENV_SENDER						= "From";
	public static final String ENV_RECEIVER					= "To";
	public static final String TRANSPORT_BEHAVIOUR	= "Transport-behaviour";	
	public static final String PAYLOAD_ENCODING			= "Payload-Encoding";	
	public static final String PAYLOAD_LENGTH				= "Payload-Length";	
  
  
  //misc
  public static final String TRUE                 = "true";
  public static final String FALSE                 = "false";
	

	
} // End FIPACONSTANTS