//******************************************************************************
//
//  Open Source Copyright Notice and License: FIPA-OS
//
//  1. The programs and other works made available to you in these files ("the
//     Programs") are Copyright (c) 1999 - 2000 Nortel Networks Corporation, 
//     8200 Dixie Road, Suite 100, Brampton, Ontario, Canada L6R 5P6.  
//     All rights reserved.
//
//  2. Your rights to copy, distribute and modify the Programs are as set out in
//     the Nortel Networks FIPA-OS Public License, a copy of which can be found
//     in file "Nortel_FIPA_OS_Public_Licence.txt" and the latest version can
//     also be found at http://fipa-os.sourceforge.net/. By downloading the
//     files containing the Programs you accept the terms and  conditions of the
//     Public License. You do not have to accept these terms and conditions, but
//     unless you do so you have no rights to use the Programs.
//
//  The Original Code is Nortel Networks' FIPA-OS (Foundation for Intelligent
//  Physical Agents - Open Source).
//
//  The Initial Developer of the Original Code is Nortel Networks Corporation.
//  Portions created by Nortel Networks Corporation or its subsidiaries are
//  Copyright (c) 1999 - 2000 Nortel Networks Corporation. All Rights Reserved.
//
//  Contributor(s):
//  (add contributor names here)
//
//******************************************************************************

package fipaos.ont.fipa.fipaman;

//******************************************************************************
//
//  Open Source Copyright Notice and License: FIPA-OS
//
//  1. The programs and other works made available to you in these files ("the
//     Programs") are Copyright (c) 1999 - 2000 Nortel Networks Corporation, 
//     8200 Dixie Road, Suite 100, Brampton, Ontario, Canada L6R 5P6.  
//     All rights reserved.
//
//  2. Your rights to copy, distribute and modify the Programs are as set out in
//     the Nortel Networks FIPA-OS Public License, a copy of which can be found
//     in file "Nortel_FIPA_OS_Public_Licence.txt" and the latest version can
//     also be found at http://fipa-os.sourceforge.net/. By downloading the
//     files containing the Programs you accept the terms and  conditions of the
//     Public License. You do not have to accept these terms and conditions, but
//     unless you do so you have no rights to use the Programs.
//
//  The Original Code is Nortel Networks' FIPA-OS (Foundation for Intelligent
//  Physical Agents - Open Source).
//
//  The Initial Developer of the Original Code is Nortel Networks Corporation.
//  Portions created by Nortel Networks Corporation or its subsidiaries are
//  Copyright (c) 1999 - 2000 Nortel Networks Corporation. All Rights Reserved.
//
//  Contributor(s):
//  (add contributor names here)
//
//******************************************************************************

//----------------------------------------------------------------------

/**
   * This class is used as a central repository for all FIPA Agent Management
   * ontology constants and definitions used by agents in agent management situations
   * e.g. registration with platform agents.
   * Agents wishing to use these constants should use this file
   * and should not define constants locally.
   * <br>The standard naming for these constants is as follows:
   * <p><ul>
   * <li>Constants names are capitalised versions of the strings they represent
   * <li>Space ( ) and dash (-) characters are replaced by underscores (_)
   * <li>Constants do not include any whitespace at the start or then end of the string
   * </ul>
   * <br>
   * <br>
 */
public class FIPAMANCONSTANTS
{
	 
//----------------------------------------------------------------------
// AGENT MANAGEMENT ACTION CONSTANTS
//----------------------------------------------------------------------	
	
	// AMS ACTIONS
	public static final String REGISTER_AGENT					= "register-agent";
  	public static final String DEREGISTER_AGENT				= "deregister-agent";
  	public static final String MODIFY_AGENT						=	"modify-agent";
  	public static final String AUTHENTICATE						=	"authenticate";
	public static final String SEARCH_AGENT						= "search-agent";
  	public static final String QUERY_PLATFORM_PROFILE	= "query-platform-profile";
  
  	// DF ACTIONS
  	public static final String	REGISTER								= "register";
  	public static final String	DEREGISTER							= "deregister";
  	public static final String	MODIFY									= "modify";
  	public static final String	SEARCH									= "search";
	
	public static final String 	GET_DESCRIPTION								= "get-description";
  
  	// ACC ACTIONS
  	public static final String FORWARD									= "forward";
  
  	//AID CONSTANTS
  
  	public static final String AGENT_IDENTIFIER         = "agent-identifier";
  	public static final String NAME                     = ":name";
  	public static final String ADDRESSES                 = ":addresses";
 	public static final String RESOLVERS                = ":resolvers";
 
  	// AMS AGENT DESCRIPTION CONSTANTS
  
	public static final String AMS_AGENT_DESCRIPTION		= "ams-agent-description";
  	public static final String AGENT_NAME								= ":agent-name";
	public static final String ADDRESS									= ":address";
	public static final String AP_STATE									= ":ap-state";
	public static final String DELEGATE_AGENT_NAME			= ":delegate-agent-name";
	public static final String FORWARD_ADDRESS					= ":forward-address";
	public static final String SIGNATURE								= ":signature";
	public static final String OWNERSHIP								= ":ownership";
  	public static final String STATE									= ":state";
  
 	// MESSAGE TRANSPORT PROTOCOL DESCRIPTION CONSTANTS
  
  	public static final String AVAILABLE_MTPS          = ":available-mtps";
  	public static final String AP_TRANSPORT_DESCRIPTION  = "ap-transport-description";
  	public static final String MTP_DESCRIPTION          = "mtp-description";
  	public static final String AP_DESCRIPTION           = "ap-description";
  	public static final String PROFILE                  = ":profile";
  	public static final String MTP_NAME                 = ":mtp-name";
  	public static final String FIPA_ALPHA               = "fipa-alpha";
  	public static final String FIPA_BETA                = "fipa-beta";
  
	// DF AGENT DESCRIPTION CONSTANTS
	public static final String DF_DESCRIPTION						= ":df-description";
		public static final String DF_AGENT_DESCRIPTION                                         = "df-agent-description";
	public static final String AGENT_ADDRESS						= ":address";
	public static final String AGENT_SERVICES						= ":services";
		public static final String PROTOCOL                                                     = ":protocol";
	public static final String INTERACTION_PROTOCOLS		                        = ":interaction-protocols";
	public static final String AGENT_TYPE							= ":type";
	public static final String ONTOLOGY							= ":ontology";
	public static final String LANGUAGE							= ":language";
	public static final String DF_STATE							= ":df-state";
	// :agent-name and :ownership defined as above for AMS
	
	// ACC DESCRIPTION CONSTANTS
	public static final String ACC_DESCRIPTION					= ":acc-description";
	public static final String IOR											= ":ior";
	
	// DF SERVICE DESCRIPTION
	public static final String SERVICE_DESCRIPTION					                = "service-description";
	public static final String SERVICE_NAME								= ":service-name";
	public static final String SERVICE_TYPE								= ":service-type";
		public static final String SERVICE_TYPE_NEW                                                     = ":type";
	public static final String SERVICE_ONTOLOGY						        = ":service-ontology";
	public static final String PROPERTIES                                                           = ":properties";
		public static final String FIXED_PROPERTIES						        = ":fixed-properties";
	public static final String NEGOTIABLE_PROPERTIES				                = ":negotiable-properties";
	public static final String COMMUNICATION_PROPERTIES		                                = ":communication-properties";
	// :ontology, :protocol and :ownership as defined above 
		
	// AP PROFILE
	public static final String AP_PROFILE									= ":ap-profile";
	public static final String PLATFORM_NAME							= ":platform-name";
	public static final String DYNAMIC_REGISTRATION			= ":dynamic-registration";
	public static final String MOBILITY										= ":mobility";
	public static final String CERTIFICATION_AUTHORITY	= ":certification-authority";
	public static final String FIPA_MAN_COMPLIANCE				= ":fipa-man-compliance";
	public static final String IIOP_URL										= ":iiop-url";
	public static final String DEFAULT_DF									= ":default-df";
  	public static final String DYNAMIC                    = ":dynamic";
  
  	//transport-profile
  	public static final String TRANSPORT_PROFILE          = ":transport-profile";
  
	//search constraints
	public static final String SEARCH_CONSTRAINTS		= "search-constraints";
	public static final String MAX_DEPTH			= ":max-depth";
	public static final String MAX_RESULTS			= ":max-results";
	
	//property template
		public static final String PROPERTY_TEMPLATE    ="property";
		public static final String VALUE                =":value";
  
	// :ownership defined already as above for AMS
	
	// PLATFORM LIFE-CYCLE STATES
	public static final String INITIATED								= "initiated";
	public static final String ACTIVE										= "active";
	public static final String SUSPENDED								= "suspended";
	public static final String WAITING									= "waiting";
	public static final String TRANSIT									= "transit";
	
	// DF LIFECYCLE STATES
	//public static final String ACTIVE									= "active"; 		// as above
	//public static final String SUSPENDED							= "suspended";		// as above
	public static final String RETIRED									= "retired";
	public static final String UNKNOWN									= "unknown";
	
	// FIPA SPECIFICATIONS
	public static final String FIPA97_PART1_V1					= "fipa97-part1-v1";
	public static final String FIPA97_PART1_V2					= "fipa97-part1-v2";
	public static final String FIPA98_PART1_V1					= "fipa98-part1-v1";
	public static final String FIPA99_PART1_V1					= "fipa99-part1-v1";
	public static final String FIPA99_PART15_V1				= "fipa99-part15-v1";
	public static final String FIPA99_PART16_V1				= "fipa99-part16-v1";
	public static final String FIPA99_PART17_V1				= "fipa99-part17-v1";
	
	// CONTENT LANGUAGES
	public static final String FIPA_SL0									= "fipa-sl0";
	public static final String FIPA_SL1									= "fipa-sl1";
	public static final String FIPA_SL2									= "fipa-sl2";
	
	// SERVICE TYPES
	public static final String FIPA_DF									= "fipa-df";
	public static final String FIPA_AMS									= "fipa-ams";
	public static final String FIPA_ACC									= "fipa-acc";
	public static final String FIPA_AGENT								= "fipa-agent";
	
	// FIXED PROPERTIES
	public static final String DF_SEARCH_DEF_TIME_OUT				= ":df-search-def-time-out";
	public static final String DF_SEARCH_ALGO								= ":df-search-algo";
	
	// DF SEARCH CONSTRAINTS
	public static final String DF_SEARCH_RESP_REQ						= ":df-search-resp-req";
	public static final String DF_SEARCH_FILTER							= ":df-search-filter";
	public static final String DF_SEARCH_TIME_OUT						= ":df-search-time-out";
	public static final String DF_SEARCH_DEPTH								= ":df-search-depth";
	// :df-search-algo defined above
	public static final String MAX														= "max";
	public static final String MIN														= "min";
	public static final String EXACTLY												= "exactly";
	
	// AM EXCEPTIONS
	public static final String FIPA_MAN_EXCEPTION						= ":fipa-man-exception";
	public static final String REJECT_AUTHENTICATE						= "reject-authenticate";
	public static final String NO_COMMUNICATIONS_MEANS			= "no-communications-means";	
	public static final String UNAVAILABLE										= "unavailable";
	public static final String AGENT_NOT_REGISTERED					= "not-registered";
	public static final String UNRECOGNISED_ATTRIBUTE_VALUE	= "unrecognised-attribute-value";	
	public static final String UNRECOGNISED_ATTRIBUTE				= "unrecognised-attribute";	
	public static final String UNAUTHORISED									= "unauthorised";	
	public static final String FAILED_MANAGEMENT_ACTION			= "failed-management-action";
	public static final String UNWILLING_TO_PERFORM					= "unwilling-to-perform";	
	public static final String DF_OVERLOADED									= "df-overloaded";
	public static final String AMS_OVERLOADED								= "ams-overloaded";
	public static final String UNABLE_DEREGISTER							= "unable-deregister";
	public static final String INCONSISTENCY									= "inconsistency";
	public static final String AGENT_ALREADY_REGISTERED			= "already-registered";
	public static final String ACC_UNAVAILABLE								= "acc-unavailable";
	public static final String ACC_OVERLOADED								= "acc-overloaded";
	public static final String INTERNAL_ERROR				= "internal-error";
	
	// NORTEL ADDED EXCEPTIONS
	public static final String MANDATORY_ATTRIBUTE_MISSING			= "mandatory-attribute-missing";
		
	// ONTOLOGY
	public static final String FIPA_AGENT_MANAGEMENT			= "fipa-agent-management";
	
	// MISC
	public static final String LIST											= ":list";
	public static final String NO_MATCHES_FOUND				= "no-matches-found";
  	public static final String SEQUENCE                 			="sequence";
  	public static final String SET					        = "set";
	public static final String ACTION					= "action";
	public static final String RESULT					= "result";
  
	

  
	
}