//******************************************************************************
//
//  Open Source Copyright Notice and License: FIPA-OS
//
//  1. The programs and other works made available to you in these files ("the
//     Programs") are Copyright (c) 1999 - 2000 Nortel Networks Corporation, 
//     8200 Dixie Road, Suite 100, Brampton, Ontario, Canada L6R 5P6.  
//     All rights reserved.
//
//  2. Your rights to copy, distribute and modify the Programs are as set out in
//     the Nortel Networks FIPA-OS Public License, a copy of which can be found
//     in file "Nortel_FIPA_OS_Public_Licence.txt" and the latest version can
//     also be found at http://fipa-os.sourceforge.net/. By downloading the
//     files containing the Programs you accept the terms and  conditions of the
//     Public License. You do not have to accept these terms and conditions, but
//     unless you do so you have no rights to use the Programs.
//
//  The Original Code is Nortel Networks' FIPA-OS (Foundation for Intelligent
//  Physical Agents - Open Source).
//
//  The Initial Developer of the Original Code is Nortel Networks Corporation.
//  Portions created by Nortel Networks Corporation or its subsidiaries are
//  Copyright (c) 1999 - 2000 Nortel Networks Corporation. All Rights Reserved.
//
//  Contributor(s):
//  (add contributor names here)
//
//******************************************************************************

package fipaos.parser;

//----------------------------------------------------------------------

// Not needed (yet)
//import fipaos.fipa.FIPACONSTANTS;
//import fipaos.ont.BASECONSTANTS;
//import fipaos.ont.fipaman.FIPAMANCONSTANTS;
import fipaos.agent.conversation.content.Content;

//----------------------------------------------------------------------

/**
 * This interface should be implemented by parser classes which can deal
 * with parsing to/from Content objects.
 * <br>
 * <br>
 */
public interface Parser
{
	 
//----------------------------------------------------------------------
// CONSTANTS
//----------------------------------------------------------------------

//----------------------------------------------------------------------
// PUBLIC METHODS
//----------------------------------------------------------------------	

	/**
	 * This method converts a Content object into a document
	 * which is of a format determined by the Parser implementation.
	 *
	 * @param content The Content object to deparse
	 *
	 * @return The Stringified representation of the Content object
	 */
	public String deparse( Content content ) throws ParserException;
		

	/**
	 * This method converts a content String into a set of Content objects
	 *
	 * @param content The String to parse into Content objects
	 *
	 * @return A Content object representing the content String given.
	 */
	public Content parse( String content ) throws ParserException;


	/**
	 * Determines if the Parser implementation can parse the given content
	 *
	 * @param A content String.
	 *
	 * @return True if the Parser implementation can parse the given String
	 */
	public boolean canParse( String content );


	/**
	 * Returns the type of content language that the Parser implementation
	 * handles.
	 *
	 * @return A String representation of the content format (e.g. RDF, SL)
	 */
	public String getParserType();

}