//******************************************************************************
//  Open Source Copyright Notice and License: FIPA-OS
//
//  1. The programs and other works made available to you in these files 
//     ("the Programs") are Copyright (c) 1999 - 2000 Nortel Networks
//     Corporation, 8200 Dixie Road, Suite 100, Brampton, Ontario, Canada 
//     L6R 5P6.  All rights reserved.
//
//  2. Your rights to copy, distribute and modify the Programs are as set out 
//     in the Nortel Networks FIPA-OS Public License, a copy of which can be
//     found in file "Nortel_FIPA_OS_Public_Licence.txt" and the latest version 
//     can also be found at http://fipa-os.sourceforge.net/. By  downloading
//     the files containing the Programs you accept the terms and conditions of
//     the Public License. You do not have to accept these terms and conditions,
//     but unless you do so you have no rights to use the Programs.
//
//  The Original Code is Nortel Networks' FIPA-OS (Foundation for Intelligent
//  Physical Agents - Open Source).
//
//  The Initial Developer of the Original Code is Nortel Networks Corporation.
//  Portions created by Nortel Networks Corporation or its subsidiaries are
//  Copyright (c) 1999 - 2000 Nortel Networks Corporation. All Rights Reserved.
//
//  Contributor(s): 
//    Emorphia agree to provide Modifications to Nortel Networks' FIPA-OS 
//    Covered Code under Nortel Networks' FIPA-OS Public License. All Emorphia's 
//    Modifications remain Copyright (c) 2001 Emorphia Limited. All Rights
//    Reserved. 
//
//******************************************************************************

/* Generated By:JavaCC: Do not edit this line. ACLParser.java */
package fipaos.parser.acl.string;


import fipaos.parser.acl.ACLMessage;
import fipaos.parser.acl.KeywordValuePair;
import java.util.Vector;
import java.io.IOException;
import java.io.StringReader;
import java.io.FileReader;
import java.io.BufferedReader;
import fipaos.util.DIAGNOSTICS;

				/**	 
	 * The ACLParser is used to parse a string that has the
	 * format of an acl message as defined by fipa97.
	 * For parsing to occur, the string should be converted
	 * to a StringReader and then passed to the constructor
	 * of the ACLParse
	 * <p>
	 * <p>
   */

		public class ACLParser implements ACLParserConstants {

	/**
	 * parse method is the preferred method for parsing an
	 * acl message string.
	 */
	public static ACLMessage parse(String acl_msg) throws ParseException
		{
				StringReader stringreader = new StringReader(acl_msg);

				ACLParser aclparser       = new ACLParser(stringreader);
	 //  		DIAGNOSTICS.println("created the acl parser with str reader");
				return aclparser.ACLCommunicativeAct();

		}

		/**
  	 * a dummy method insert for legacy reasons.  This shouldn't
  	 * really be called as the current design allows concurrent
  	 * parsing thus rendering this previous method meaningless. 
  	 */
		public static String getSender()
		{
				return null;
		}

		/**
  	 * A test harness method.
  	 */
		public static void main(String[] args) throws Exception
				{
						//print out usage instructions if needed
						if(args.length == 0)
			{
			  System.out.println("usage: java fipa.parser.acl.parser.ACLParser filename");
			  System.exit(0);
			}


	  FileReader file_in = new FileReader(args[0]);
						BufferedReader in = new BufferedReader(file_in);
				  String fileLine  = null;
						//Loop through the file parsing each line.
						// (null indicated eof)
						while ((fileLine = in.readLine()) != null)
						{
								System.out.println("Line to parse is: " + fileLine);
								try
								{
										ACLMessage msg=ACLParser.parse(fileLine);

										System.out.println(msg.getMessageType());
										System.out.println(msg.getSender());
										System.out.println(msg.getReceiver());
										System.out.println(msg.getContent());
										System.out.println(msg.getReplyWith());
										System.out.println(msg.getReplyBy());
										System.out.println(msg.getInReplyTo());
		  System.out.println(msg.getReplyTo());
										System.out.println(msg.getLanguage());
										System.out.println(msg.getOntology());
										System.out.println(msg.getProtocol());
										System.out.println(msg.getConversationID());
										System.out.println(msg.toString());
								}
								catch (Exception e)
								{
										e.printStackTrace();
								}
						}

						/*String message="(subscribe :sender agent@http://www.hk.net:100/jkk "+
			               ":receiver (Disney@http://www.hk.net:100/jkk" +
			               " Bull@iiop://abce.xxx.xxx.yyy.aaa:123423/asdfkj234) "+
			               ":reply-with #3\"foo :content"+
			               " <XML></XML> :envelope ((sport football)(music pop)"+
			               "(food burger)) :reply-by +19981204T120502120 "+
			               " :language #3\"123)";
			*/

				}

//----------------------------------------------------------------------
// BNF PRODUCTIONS - used to define the grammar (the non-terminals
// to parse for   
//----------------------------------------------------------------------	

/**
 * @return an ACLMessage if parsed successfully.
 */
  final public ACLMessage ACLCommunicativeAct() throws ParseException {
		ACLMessage acl_message_to_return = new ACLMessage();
	Message(acl_message_to_return);
				{if (true) return acl_message_to_return;}
	throw new Error("Missing return statement in function");
  }  

  final public void Message(ACLMessage acl_message) throws ParseException {
		Token token;
	jj_consume_token(LPAREN);
	token = jj_consume_token(MessageType);
				//set the messageType Token into acl_message
				acl_message.setMessageType(token.image);
	label_1:
	while (true) {
	  switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
	  case Sender:
	  case Receiver:
	  case Content:
	  case ReplyWith:
	  case ReplyBy:
	  case InReplyTo:
	  case ReplyTo:
	  case Envelope:
	  case Language:
	  case Ontology:
	  case Protocol:
	  case ConversationID:
		;
		break;
	  default:
		jj_la1[0] = jj_gen;
		break label_1;
	  }
	  MessageParameter(acl_message);
	}
	jj_consume_token(RPAREN);
  }  

  final public void MessageParameter(ACLMessage acl_message) throws ParseException {
		String str;

		Token  token;
		Vector keyvaluepairlist;
	switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
	case Sender:
	  jj_consume_token(Sender);
	  str = Expression();
				acl_message.setSender(str);
	token_source.SwitchTo(MSGPARAM);
	  break;
	case Receiver:
	  jj_consume_token(Receiver);
	  str = Expression();
				acl_message.setReceiver(str);
	token_source.SwitchTo(MSGPARAM);
	  break;
	case Content:
	  jj_consume_token(Content);
	  str = Expression();
				acl_message.setContentObjectACLParser(str);
				token_source.SwitchTo(MSGPARAM);
	  break;
	case ReplyWith:
	  jj_consume_token(ReplyWith);
	  str = Expression();
				acl_message.setReplyWith(str);
				token_source.SwitchTo(MSGPARAM);
	  break;
	case ReplyBy:
	  jj_consume_token(ReplyBy);
	  token = jj_consume_token(DateTimeToken);
				acl_message.setReplyBy(token.image);
				token_source.SwitchTo(MSGPARAM);
	  break;
	case ReplyTo:
	  jj_consume_token(ReplyTo);
	  str = Expression();
				acl_message.setReplyTo(str);
				token_source.SwitchTo(MSGPARAM);
	  break;
	case InReplyTo:
	  jj_consume_token(InReplyTo);
	  str = Expression();
				acl_message.setInReplyTo(str);
				token_source.SwitchTo(MSGPARAM);
	  break;
	case Language:
	  jj_consume_token(Language);
	  str = Expression();
				acl_message.setLanguage(str);
				token_source.SwitchTo(MSGPARAM);
	  break;
	case Ontology:
	  jj_consume_token(Ontology);
	  str = Expression();
				acl_message.setOntology(str);
				token_source.SwitchTo(MSGPARAM);
	  break;
	case Protocol:
	  jj_consume_token(Protocol);
	  token = jj_consume_token(Word);
				acl_message.setProtocol(token.image);
				token_source.SwitchTo(MSGPARAM);
	  break;
	case Envelope:
	  jj_consume_token(Envelope);
	  keyvaluepairlist = KeyValuePairList();
//                acl_message.setEnvelope(keyvaluepairlist);
				token_source.SwitchTo(MSGPARAM);
	  break;
	case ConversationID:
	  jj_consume_token(ConversationID);
	  str = Expression();
				acl_message.setConversationID(str);
				token_source.SwitchTo(MSGPARAM);
	  break;
	default:
	  jj_la1[1] = jj_gen;
	  jj_consume_token(-1);
	  throw new ParseException();
	}
  }  

  final public String Expression() throws ParseException {
		Token t;
		StringBuffer str_buf = new StringBuffer();
		String str;
	switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
	case DateTimeToken:
	  t = jj_consume_token(DateTimeToken);
				{if (true) return t.image;}
	  break;
	case StringLiteral:
	case ByteLengthEncodedString:
	  str = String();
				{if (true) return str;}
	  break;
	case Word:
	  t = jj_consume_token(Word);
				{if (true) return t.image;}
	  break;
	case Number:
	  t = jj_consume_token(Number);
				{if (true) return t.image;}
	  break;
	case LPAREN:
	  jj_consume_token(LPAREN);
				str_buf.append("(");
	  label_2:
	  while (true) {
		switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
		case DateTimeToken:
		case StringLiteral:
		case ByteLengthEncodedString:
		case Number:
		case LPAREN:
		case Word:
		  ;
		  break;
		default:
		  jj_la1[2] = jj_gen;
		  break label_2;
		}
		str = Expression();
		str_buf.append(str);
		str_buf.append(" ");
	  }
	  jj_consume_token(RPAREN);
				str_buf.append(")");
				{if (true) return str_buf.toString();}
	  break;
	default:
	  jj_la1[3] = jj_gen;
	  jj_consume_token(-1);
	  throw new ParseException();
	}
	throw new Error("Missing return statement in function");
  }  

  final public Vector KeyValuePairList() throws ParseException {
		Vector vector =  new Vector();
		KeywordValuePair kvpair;
	jj_consume_token(LPAREN);
	label_3:
	while (true) {
	  switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
	  case LPAREN:
		;
		break;
	  default:
		jj_la1[4] = jj_gen;
		break label_3;
	  }
	  kvpair = KeyValuePair();
				vector.addElement(kvpair);
	}
	jj_consume_token(RPAREN);
				{if (true) return vector;}
	throw new Error("Missing return statement in function");
  }  

  final public KeywordValuePair KeyValuePair() throws ParseException {
		Token token;
		String str;
	jj_consume_token(LPAREN);
	token = jj_consume_token(Word);
	str = Expression();
	jj_consume_token(RPAREN);
				{if (true) return new KeywordValuePair(token.image, str);}
	throw new Error("Missing return statement in function");
  }  

/**
 * returns the recipient expression as a String.
 */
  final public String RecipientExpr() throws ParseException {
  String str;
		StringBuffer str_buf = new StringBuffer();
		Token receiver_agent_name;
	switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
	case ReceiverAgentName:
	  receiver_agent_name = jj_consume_token(ReceiverAgentName);
				token_source.SwitchTo(MSGPARAM);
				{if (true) return receiver_agent_name.image;}
	  break;
	case LPAREN:
	  jj_consume_token(LPAREN);
		str_buf.append("(");
	  label_4:
	  while (true) {
		receiver_agent_name = jj_consume_token(ReceiverAgentName);
						str_buf.append(receiver_agent_name.image);
						str_buf.append(" ");
		switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
		case ReceiverAgentName:
		  ;
		  break;
		default:
		  jj_la1[5] = jj_gen;
		  break label_4;
		}
	  }
	  jj_consume_token(RPAREN);
				str_buf.append(")");
				{if (true) return str_buf.toString();}
	  break;
	default:
	  jj_la1[6] = jj_gen;
	  jj_consume_token(-1);
	  throw new ParseException();
	}
	throw new Error("Missing return statement in function");
  }  

/**
 * Recipient
 */
  final public String SenderAgentName() throws ParseException {
		Token name;
	name = jj_consume_token(SenderAgentName);
				{if (true) return name.image;}
	throw new Error("Missing return statement in function");
  }  

  final public String String() throws ParseException {
		Token token;
	switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
	case StringLiteral:
	  token = jj_consume_token(StringLiteral);
				{if (true) return token.image;}
	  break;
	case ByteLengthEncodedString:
	  token = jj_consume_token(ByteLengthEncodedString);
				{if (true) return token.image;}
	  break;
	default:
	  jj_la1[7] = jj_gen;
	  jj_consume_token(-1);
	  throw new ParseException();
	}
	throw new Error("Missing return statement in function");
  }  

  public ACLParserTokenManager token_source;
  ASCII_CharStream jj_input_stream;
  public Token token, jj_nt;
  private int jj_ntk;
  private int jj_gen;
  final private int[] jj_la1 = new int[8];
  final private int[] jj_la1_0 = {0x1ffe0,0x1ffe0,0x40000,0x40000,0x0,0x40000000,0x40000000,0x0,};
  final private int[] jj_la1_1 = {0x0,0x0,0xa0e0,0xa0e0,0x2000,0x0,0x2000,0x60,};

  public ACLParser(java.io.InputStream stream) {
	jj_input_stream = new ASCII_CharStream(stream, 1, 1);
	token_source = new ACLParserTokenManager(jj_input_stream);
	token = new Token();
	jj_ntk = -1;
	jj_gen = 0;
	for (int i = 0; i < 8; i++) jj_la1[i] = -1;
  }  

  public void ReInit(java.io.InputStream stream) {
	jj_input_stream.ReInit(stream, 1, 1);
	token_source.ReInit(jj_input_stream);
	token = new Token();
	jj_ntk = -1;
	jj_gen = 0;
	for (int i = 0; i < 8; i++) jj_la1[i] = -1;
  }  

  public ACLParser(java.io.Reader stream) {
	jj_input_stream = new ASCII_CharStream(stream, 1, 1);
	token_source = new ACLParserTokenManager(jj_input_stream);
	token = new Token();
	jj_ntk = -1;
	jj_gen = 0;
	for (int i = 0; i < 8; i++) jj_la1[i] = -1;
  }  

  public void ReInit(java.io.Reader stream) {
	jj_input_stream.ReInit(stream, 1, 1);
	token_source.ReInit(jj_input_stream);
	token = new Token();
	jj_ntk = -1;
	jj_gen = 0;
	for (int i = 0; i < 8; i++) jj_la1[i] = -1;
  }  

  public ACLParser(ACLParserTokenManager tm) {
	token_source = tm;
	token = new Token();
	jj_ntk = -1;
	jj_gen = 0;
	for (int i = 0; i < 8; i++) jj_la1[i] = -1;
  }  

  public void ReInit(ACLParserTokenManager tm) {
	token_source = tm;
	token = new Token();
	jj_ntk = -1;
	jj_gen = 0;
	for (int i = 0; i < 8; i++) jj_la1[i] = -1;
  }  

  final private Token jj_consume_token(int kind) throws ParseException {
	Token oldToken;
	if ((oldToken = token).next != null) token = token.next;
	else token = token.next = token_source.getNextToken();
	jj_ntk = -1;
	if (token.kind == kind) {
	  jj_gen++;
	  return token;
	}
	token = oldToken;
	jj_kind = kind;
	throw generateParseException();
  }  

  final public Token getNextToken() {
	if (token.next != null) token = token.next;
	else token = token.next = token_source.getNextToken();
	jj_ntk = -1;
	jj_gen++;
	return token;
  }  

  final public Token getToken(int index) {
	Token t = token;
	for (int i = 0; i < index; i++) {
	  if (t.next != null) t = t.next;
	  else t = t.next = token_source.getNextToken();
	}
	return t;
  }  

  final private int jj_ntk() {
	if ((jj_nt=token.next) == null)
	  return (jj_ntk = (token.next=token_source.getNextToken()).kind);
	else
	  return (jj_ntk = jj_nt.kind);
  }  

  private java.util.Vector jj_expentries = new java.util.Vector();
  private int[] jj_expentry;
  private int jj_kind = -1;

  final public ParseException generateParseException() {
	jj_expentries.removeAllElements();
	boolean[] la1tokens = new boolean[49];
	for (int i = 0; i < 49; i++) {
	  la1tokens[i] = false;
	}
	if (jj_kind >= 0) {
	  la1tokens[jj_kind] = true;
	  jj_kind = -1;
	}
	for (int i = 0; i < 8; i++) {
	  if (jj_la1[i] == jj_gen) {
		for (int j = 0; j < 32; j++) {
		  if ((jj_la1_0[i] & (1<<j)) != 0) {
			la1tokens[j] = true;
		  }
		  if ((jj_la1_1[i] & (1<<j)) != 0) {
			la1tokens[32+j] = true;
		  }
		}
	  }
	}
	for (int i = 0; i < 49; i++) {
	  if (la1tokens[i]) {
		jj_expentry = new int[1];
		jj_expentry[0] = i;
		jj_expentries.addElement(jj_expentry);
	  }
	}
	int[][] exptokseq = new int[jj_expentries.size()][];
	for (int i = 0; i < jj_expentries.size(); i++) {
	  exptokseq[i] = (int[])jj_expentries.elementAt(i);
	}
	return new ParseException(token, exptokseq, tokenImage);
  }  

  final public void enable_tracing() {
  }  

  final public void disable_tracing() {
  }  

  }