//******************************************************************************
//
//  Open Source Copyright Notice and License: FIPA-OS
//
//  1. The programs and other works made available to you in these files ("the
//     Programs") are Copyright (c) 1999 - 2000 Nortel Networks Corporation, 
//     8200 Dixie Road, Suite 100, Brampton, Ontario, Canada L6R 5P6.  
//     All rights reserved.
//
//  2. Your rights to copy, distribute and modify the Programs are as set out in
//     the Nortel Networks FIPA-OS Public License, a copy of which can be found
//     in file "Nortel_FIPA_OS_Public_Licence.txt" and the latest version can
//     also be found at http://fipa-os.sourceforge.net/. By downloading the
//     files containing the Programs you accept the terms and  conditions of the
//     Public License. You do not have to accept these terms and conditions, but
//     unless you do so you have no rights to use the Programs.
//
//  The Original Code is Nortel Networks' FIPA-OS (Foundation for Intelligent
//  Physical Agents - Open Source).
//
//  The Initial Developer of the Original Code is Nortel Networks Corporation.
//  Portions created by Nortel Networks Corporation or its subsidiaries are
//  Copyright (c) 1999 - 2000 Nortel Networks Corporation. All Rights Reserved.
//
//  Contributor(s):
//  (add contributor names here)
//
//******************************************************************************

/* Generated By:JavaCC: Do not edit this line. AIDParser.java */
package fipaos.parser.aid;


import fipaos.ont.fipa.fipaman.AgentID;
import fipaos.parser.acl.KeywordValuePair;
import java.util.Vector;
import java.io.IOException;
import java.io.StringReader;
import java.io.FileReader;
import java.io.BufferedReader;
import fipaos.util.DIAGNOSTICS;

				/**	 
	 * The AIDParser is used to parse a string that has the
	 * format of an acl message as defined by fipa97.
	 * For parsing to occur, the string should be converted
	 * to a StringReader and then passed to the constructor
	 * of the ACLParse
	 * <p>
	 * <p>
   */

		public class AIDParser implements AIDParserConstants {

	/**
	 * parse method is the preferred method for parsing an
	 * acl message string.
	 */
	public static AgentID parse(String aid) throws ParseException
		{
				StringReader stringreader = new StringReader(aid);

				AIDParser aid_parser       = new AIDParser(stringreader);
	 //  		DIAGNOSTICS.println("created the AID parser with str reader");
				return aid_parser.getAgentID();

		}


		/**
  	 * A test harness method.
  	 */
		public static void main(String[] args) throws Exception
				{
						//print out usage instructions if needed
						if(args.length == 0)
			{
			  System.out.println("usage: java fipa.parser.acl.parser.ACLParser filename");
			  System.exit(0);
			}


	  FileReader file_in = new FileReader(args[0]);
						BufferedReader in = new BufferedReader(file_in);
				  String fileLine  = null;
						//Loop through the file parsing each line.
						// (null indicated eof)
						while ((fileLine = in.readLine()) != null)
						{
								System.out.println("Line to parse is: " + fileLine);
								try
								{
										AgentID aid=AIDParser.parse(fileLine);

										System.out.println( "\nName\n" + aid.getName() );
										System.out.println( "\nAddresses\n" + aid.getAddresses().toString() );
										System.out.println( "\nResolvers\n" + aid.getResolvers().toString() );
										//System.out.println(aid.toString());		
								}
								catch (Exception e)
								{
										e.printStackTrace();
								}
						}


				}

//----------------------------------------------------------------------
// BNF PRODUCTIONS - used to define the grammar (the non-terminals
// to parse for   
//----------------------------------------------------------------------	

/**
 * @return an ACLMessage if parsed successfully.
 */
  final public AgentID getAgentID() throws ParseException {
		AgentID aid_to_return = new AgentID();
	AID(aid_to_return);
				{if (true) return aid_to_return;}
	throw new Error("Missing return statement in function");
  }  

  final public void AID(AgentID aid) throws ParseException {
		Token token;
	jj_consume_token(LPAREN);
	token = jj_consume_token(ObjectType);

	label_1:
	while (true) {
	  switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
	  case Name:
	  case Addresses:
	  case Resolvers:
		;
		break;
	  default:
		jj_la1[0] = jj_gen;
		break label_1;
	  }
	  MessageParameter(aid);
	}
	jj_consume_token(RPAREN);
  }  

  final public void MessageParameter(AgentID aid) throws ParseException {
		String str;

		Token  token;
		Vector keyvaluepairlist;
	switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
	case Name:
	  jj_consume_token(Name);
	  str = Expression();
				aid.setName(str);
	token_source.SwitchTo(MSGPARAM);
	  break;
	case Addresses:
	  jj_consume_token(Addresses);
	  str = Expression();
				aid.setAddresses(str);
	token_source.SwitchTo(MSGPARAM);
	  break;
	case Resolvers:
	  jj_consume_token(Resolvers);
	  str = Expression();
				aid.setResolvers(str);
				token_source.SwitchTo(MSGPARAM);
	  break;
	default:
	  jj_la1[1] = jj_gen;
	  jj_consume_token(-1);
	  throw new ParseException();
	}
  }  

  final public String Expression() throws ParseException {
		Token t;
		StringBuffer str_buf = new StringBuffer();
		String str;
	switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
	case StringLiteral:
	case ByteLengthEncodedString:
	  str = String();
				{if (true) return str;}
	  break;
	case Word:
	  t = jj_consume_token(Word);
				{if (true) return t.image;}
	  break;
	case Number:
	  t = jj_consume_token(Number);
				{if (true) return t.image;}
	  break;
	case LPAREN:
	  jj_consume_token(LPAREN);
				str_buf.append("(");
	  label_2:
	  while (true) {
		switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
		case StringLiteral:
		case ByteLengthEncodedString:
		case Number:
		case LPAREN:
		case Word:
		  ;
		  break;
		default:
		  jj_la1[2] = jj_gen;
		  break label_2;
		}
		str = Expression();
		str_buf.append(str);
		str_buf.append(" ");
	  }
	  jj_consume_token(RPAREN);
				str_buf.append(")");
				{if (true) return str_buf.toString();}
	  break;
	default:
	  jj_la1[3] = jj_gen;
	  jj_consume_token(-1);
	  throw new ParseException();
	}
	throw new Error("Missing return statement in function");
  }  

  final public Vector KeyValuePairList() throws ParseException {
		Vector vector =  new Vector();
		KeywordValuePair kvpair;
	jj_consume_token(LPAREN);
	label_3:
	while (true) {
	  switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
	  case LPAREN:
		;
		break;
	  default:
		jj_la1[4] = jj_gen;
		break label_3;
	  }
	  kvpair = KeyValuePair();
				vector.addElement(kvpair);
	}
	jj_consume_token(RPAREN);
				{if (true) return vector;}
	throw new Error("Missing return statement in function");
  }  

  final public KeywordValuePair KeyValuePair() throws ParseException {
		Token token;
		String str;
	jj_consume_token(LPAREN);
	token = jj_consume_token(Word);
	str = Expression();
	jj_consume_token(RPAREN);
				{if (true) return new KeywordValuePair(token.image, str);}
	throw new Error("Missing return statement in function");
  }  

/**
 * returns the recipient expression as a String.
 */
/*String RecipientExpr():
{
  String str;  
	StringBuffer str_buf = new StringBuffer();
	Token receiver_agent_name;
}
{
	receiver_agent_name = <ReceiverAgentName>
	{
		token_source.SwitchTo(MSGPARAM);
		return receiver_agent_name.image;
	}
| <LPAREN> 
  { 
  	str_buf.append("(");
  }
	(
		receiver_agent_name = <ReceiverAgentName>
		{
			str_buf.append(receiver_agent_name.image);
			str_buf.append(" ");
		}
	)+ 
	<RPAREN>
	{
		str_buf.append(")");
		return str_buf.toString();
	}
}    */


/**
 * Recipient
 */
/*String SenderAgentName():
{
	Token name;
}
{
	name = <SenderAgentName>
	{
		return name.image;
	}	
}	   */
  final public String String() throws ParseException {
		Token token;
	switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
	case StringLiteral:
	  token = jj_consume_token(StringLiteral);
				{if (true) return token.image;}
	  break;
	case ByteLengthEncodedString:
	  token = jj_consume_token(ByteLengthEncodedString);
				{if (true) return token.image;}
	  break;
	default:
	  jj_la1[5] = jj_gen;
	  jj_consume_token(-1);
	  throw new ParseException();
	}
	throw new Error("Missing return statement in function");
  }  

  public AIDParserTokenManager token_source;
  ASCII_CharStream jj_input_stream;
  public Token token, jj_nt;
  private int jj_ntk;
  private int jj_gen;
  final private int[] jj_la1 = new int[6];
  final private int[] jj_la1_0 = {0xe0,0xe0,0xa0e00,0xa0e00,0x20000,0x600,};

  public AIDParser(java.io.InputStream stream) {
	jj_input_stream = new ASCII_CharStream(stream, 1, 1);
	token_source = new AIDParserTokenManager(jj_input_stream);
	token = new Token();
	jj_ntk = -1;
	jj_gen = 0;
	for (int i = 0; i < 6; i++) jj_la1[i] = -1;
  }  

  public void ReInit(java.io.InputStream stream) {
	jj_input_stream.ReInit(stream, 1, 1);
	token_source.ReInit(jj_input_stream);
	token = new Token();
	jj_ntk = -1;
	jj_gen = 0;
	for (int i = 0; i < 6; i++) jj_la1[i] = -1;
  }  

  public AIDParser(java.io.Reader stream) {
	jj_input_stream = new ASCII_CharStream(stream, 1, 1);
	token_source = new AIDParserTokenManager(jj_input_stream);
	token = new Token();
	jj_ntk = -1;
	jj_gen = 0;
	for (int i = 0; i < 6; i++) jj_la1[i] = -1;
  }  

  public void ReInit(java.io.Reader stream) {
	jj_input_stream.ReInit(stream, 1, 1);
	token_source.ReInit(jj_input_stream);
	token = new Token();
	jj_ntk = -1;
	jj_gen = 0;
	for (int i = 0; i < 6; i++) jj_la1[i] = -1;
  }  

  public AIDParser(AIDParserTokenManager tm) {
	token_source = tm;
	token = new Token();
	jj_ntk = -1;
	jj_gen = 0;
	for (int i = 0; i < 6; i++) jj_la1[i] = -1;
  }  

  public void ReInit(AIDParserTokenManager tm) {
	token_source = tm;
	token = new Token();
	jj_ntk = -1;
	jj_gen = 0;
	for (int i = 0; i < 6; i++) jj_la1[i] = -1;
  }  

  final private Token jj_consume_token(int kind) throws ParseException {
	Token oldToken;
	if ((oldToken = token).next != null) token = token.next;
	else token = token.next = token_source.getNextToken();
	jj_ntk = -1;
	if (token.kind == kind) {
	  jj_gen++;
	  return token;
	}
	token = oldToken;
	jj_kind = kind;
	throw generateParseException();
  }  

  final public Token getNextToken() {
	if (token.next != null) token = token.next;
	else token = token.next = token_source.getNextToken();
	jj_ntk = -1;
	jj_gen++;
	return token;
  }  

  final public Token getToken(int index) {
	Token t = token;
	for (int i = 0; i < index; i++) {
	  if (t.next != null) t = t.next;
	  else t = t.next = token_source.getNextToken();
	}
	return t;
  }  

  final private int jj_ntk() {
	if ((jj_nt=token.next) == null)
	  return (jj_ntk = (token.next=token_source.getNextToken()).kind);
	else
	  return (jj_ntk = jj_nt.kind);
  }  

  private java.util.Vector jj_expentries = new java.util.Vector();
  private int[] jj_expentry;
  private int jj_kind = -1;

  final public ParseException generateParseException() {
	jj_expentries.removeAllElements();
	boolean[] la1tokens = new boolean[21];
	for (int i = 0; i < 21; i++) {
	  la1tokens[i] = false;
	}
	if (jj_kind >= 0) {
	  la1tokens[jj_kind] = true;
	  jj_kind = -1;
	}
	for (int i = 0; i < 6; i++) {
	  if (jj_la1[i] == jj_gen) {
		for (int j = 0; j < 32; j++) {
		  if ((jj_la1_0[i] & (1<<j)) != 0) {
			la1tokens[j] = true;
		  }
		}
	  }
	}
	for (int i = 0; i < 21; i++) {
	  if (la1tokens[i]) {
		jj_expentry = new int[1];
		jj_expentry[0] = i;
		jj_expentries.addElement(jj_expentry);
	  }
	}
	int[][] exptokseq = new int[jj_expentries.size()][];
	for (int i = 0; i < jj_expentries.size(); i++) {
	  exptokseq[i] = (int[])jj_expentries.elementAt(i);
	}
	return new ParseException(token, exptokseq, tokenImage);
  }  

  final public void enable_tracing() {
  }  

  final public void disable_tracing() {
  }  

  }