//******************************************************************************
//
//  Open Source Copyright Notice and License: FIPA-OS
//
//  The contents of this file are subject to the Emorphia Public License (the 
//  "License"); you may not use this file except in compliance with the License.
//  You may obtain a copy of the License at http://www.emorphia.com/EPL/
//
//  Software distributed under the License is distributed on an "AS IS" basis, 
//  WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License 
//  for the specific language governing rights and limitations under the
//  License.
//
//  The Original Code is FIPA-OS.
//
//  The Initial Developer of the Original Code is Emorphia.
//
//  Portions created by Emorphia are Copyright (C) 2001 Emorphia Limited
//  licensed under the Emorphia Public License, available at
//  http://www.emorphia.com/EPL/.
//
//  All Rights Reserved.
//
//  Contributor(s):
//  (add contributor names here)
//
//******************************************************************************

package fipaos.parser.envelope.xml;

import java.util.List;
public class AddressesImpl implements Addresses {

	private static final String xmlName = "addresses";

	/** @associates <{Url}> 
	 * @supplierCardinality 0..**/
	private List urlList;

	public AddressesImpl() {
		urlList = new java.util.LinkedList();
	}

	public String getXMLName() {
		return xmlName;
	}

	public java.util.List getUrlList() {
		return urlList;
	}

	public void setUrlList(java.util.List urlList) {
		this.urlList = urlList;
	}

	public void addUrl(Url url) {
		urlList.add(url);
	}

	public void removeUrl(Url url) {
		urlList.remove(url);
	}

}