//******************************************************************************
//
//  Open Source Copyright Notice and License: FIPA-OS
//
//  The contents of this file are subject to the Emorphia Public License (the 
//  "License"); you may not use this file except in compliance with the License.
//  You may obtain a copy of the License at http://www.emorphia.com/EPL/
//
//  Software distributed under the License is distributed on an "AS IS" basis, 
//  WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License 
//  for the specific language governing rights and limitations under the
//  License.
//
//  The Original Code is FIPA-OS.
//
//  The Initial Developer of the Original Code is Emorphia.
//
//  Portions created by Emorphia are Copyright (C) 2001 Emorphia Limited
//  licensed under the Emorphia Public License, available at
//  http://www.emorphia.com/EPL/.
//
//  All Rights Reserved.
//
//  Contributor(s):
//  (add contributor names here)
//
//******************************************************************************

package fipaos.parser.envelope.xml;

import java.util.List;
public class EnvelopeImpl implements Envelope {

	private static final String xmlName = "envelope";

	/** @associates <{Params}>
	 * @supplierCardinality 0..**/
	private List paramsList;

	public EnvelopeImpl() {
		paramsList = new java.util.LinkedList();
	}

	public String getXMLName() {
		return xmlName;
	}

	public java.util.List getParamsList() {
		return paramsList;
	}

	public void setParamsList(java.util.List paramsList) {
		this.paramsList = paramsList;
	}

	public void addParams(Params params) {
		paramsList.add(params);
	}

	public void removeParams(Params params) {
		paramsList.remove(params);
	}

}