//******************************************************************************
//  Open Source Copyright Notice and License: FIPA-OS
//
//  1. The programs and other works made available to you in these files 
//     ("the Programs") are Copyright (c) 1999 - 2000 Nortel Networks
//     Corporation, 8200 Dixie Road, Suite 100, Brampton, Ontario, Canada 
//     L6R 5P6.  All rights reserved.
//
//  2. Your rights to copy, distribute and modify the Programs are as set out 
//     in the Nortel Networks FIPA-OS Public License, a copy of which can be
//     found in file "Nortel_FIPA_OS_Public_Licence.txt" and the latest version 
//     can also be found at http://fipa-os.sourceforge.net/. By  downloading
//     the files containing the Programs you accept the terms and conditions of
//     the Public License. You do not have to accept these terms and conditions,
//     but unless you do so you have no rights to use the Programs.
//
//  The Original Code is Nortel Networks' FIPA-OS (Foundation for Intelligent
//  Physical Agents - Open Source).
//
//  The Initial Developer of the Original Code is Nortel Networks Corporation.
//  Portions created by Nortel Networks Corporation or its subsidiaries are
//  Copyright (c) 1999 - 2000 Nortel Networks Corporation. All Rights Reserved.
//
//  Contributor(s): 
//    Emorphia agree to provide Modifications to Nortel Networks' FIPA-OS 
//    Covered Code under Nortel Networks' FIPA-OS Public License. All Emorphia's 
//    Modifications remain Copyright (c) 2001 Emorphia Limited. All Rights
//    Reserved. 
//
//******************************************************************************

package fipaos.util;

import fipaos.FIPAOSException;

import java.io.*;

/**
 * Wraps an exception from a dynamically invoked method on a object wrapped
 * by DynamicClass
 */
public class DynamicClassException extends FIPAOSException
{
	private Throwable _thrown;
	
	public DynamicClassException( Throwable e )
	{
		super( e.toString() );
		
		_thrown = e;
	}
	
	public Throwable getThrowable()
	{
		return _thrown;
	}
	
	public String toString()
	{
		return "DynamicClassException: " + _thrown.toString();
	}
	
	public void printStackTrace()
	{
		printStackTrace( System.err );
	}
	
	public void printStackTrace( PrintStream ps )
	{
		ps.print( "DynamicClassException:\n" );
		_thrown.printStackTrace( ps );
	}
	
	public void printStackTrace( PrintWriter pw )
	{
		pw.println( "DynamicClassException:" );
		_thrown.printStackTrace( pw );
	}
}