package ranab.io;

import java.io.File;

/**
 * This class is used by <code>FileNavigator</code> to do
 * something on file.
 * 
 * @author <a href="mailto:rana_b@yahoo.com">Rana Bhattacharyya</a>
 */
public interface FileAction {
    
    /**
     * Navigation started.
     */
    public void startAction();
    
    /**
     * Do something on this file.
     */
    public void actionPerformed(File fl);
    
    /**
     * Navigation ended.
     */
    public void endAction();
}