/*
 * Copyright (C) The Apache Software Foundation. All rights reserved.
 *
 * This software is published under the terms of the Apache Software License
 * version 1.1, a copy of which has been included with this distribution in
 * the LICENSE file.
 */
package ranab.io;

/**
 * This interface observes stream connector activity.
 *  
 * @author <a href="mailto:rana_b@yahoo.com">Rana Bhattacharyya</a>
 */
public 
interface StreamConnectorObserver {
    /**
     * Data has been transferred.
     *
     * @size transferred byte size. If finished, it is -1.
     */
    public void dataTransferred(int size);
} 