package ranab.jar;

import java.util.Comparator;

/**
 * Interface of all the zip entry comparators.
 *
 * @author <a href="mailto:rana_b@yahoo.com">Rana Bhattacharyya</a>
 */
public
class ZipReverseComparator extends ZipComparator {
    
    private ZipComparator mOrigComp;
    
    public ZipReverseComparator(ZipComparator comp)  {
        mOrigComp = comp;
    }
    
    public int compare(Object o1, Object o2)  {
        return mOrigComp.compare(o2, o1);
    }
    
    public String getHeaderName()  {
        return mOrigComp.getHeaderName();
    }
}
