/*
 * Copyright (C) The Apache Software Foundation. All rights reserved.
 *
 * This software is published under the terms of the Apache Software License
 * version 1.1, a copy of which has been included with this distribution in
 * the LICENSE file.
 */
package ranab.server.ftp;

import ranab.server.ftp.FtpUser;

/**
 * This observer interface monitors all the ftp connections.
 * @author Rana Bhattacharyya (rana_b@yahoo.com)
 */
public 
interface FtpConnectionObserver {
    
    /**
     * New ftp connection.
     */
    void newConnection(final FtpUser user);
    
    /**
     * Closing ftp connection
     */
    void removeConnection(final FtpUser user);
    
    /**
     * Connected user property change 
     */
    void updateConnection(final FtpUser user);
}    