/*
 * Copyright (C) The Apache Software Foundation. All rights reserved.
 *
 * This software is published under the terms of the Apache Software License
 * version 1.1, a copy of which has been included with this distribution in
 * the LICENSE file.
 */
package ranab.server.ftp;

import java.io.File;

/**
 * Ftp file upload/download/delete listener interface.
 *
 * @author <a href="mailto:rana_b@yahoo.com">Rana Bhattacharyya</a>
 */
public 
interface FtpFileListener {
    /**
     * User file upload notification.
     */
    void notifyUpload(final File fl, final FtpUser user);
    
    /**
     * User file download notification.
     */
    void notifyDownload(final File fl, final FtpUser user);
    
    /**
     * User file delete notification.
     */
    void notifyDelete(final File fl, final FtpUser user);
     
}    
