/*
 * Copyright (C) The Apache Software Foundation. All rights reserved.
 *
 * This software is published under the terms of the Apache Software License
 * version 1.1, a copy of which has been included with this distribution in
 * the LICENSE file.
 */
package ranab.server.ftp;


/**
 * Ftp statistics listener interface.
 *
 * @author <a href="mailto:rana_b@yahoo.com">Rana Bhattacharyya</a>
 */
public 
interface FtpStatisticsListener {
     /**
     * User file upload notification.
     */
    void notifyUpload();
    
    /**
     * User file download notification.
     */
    void notifyDownload();
    
    /**
     * User file delete notification.
     */
    void notifyDelete();
     
    /**
     * New user login notification.
     */
    void notifyLogin();
    
    /**
     * User logout notification.
     */
    void notifyLogout();
    
    /**
     * Connection open/close notification
     */
    void notifyConnection(); 

}    
