/*
 * Copyright (C) The Apache Software Foundation. All rights reserved.
 *
 * This software is published under the terms of the Apache Software License
 * version 1.1, a copy of which has been included with this distribution in
 * the LICENSE file.
 */
package ranab.server.gui;

import javax.swing.JPanel;
import ranab.server.ServerEngine;

/**
 * All the server gui panel should implement this interface.
 */
public 
interface ServerPane {
    
    /**
     * Get the server engine.
     */
    ServerEngine getServerEngine();
    
    /**
     * Get the server admin panel.
     */
    JPanel getPanel();
    
    /**
     * Get this server name.
     */
    String getServerName(); 
}